# Apache Tomcat 7

Version 7.0.68, Feb 18 2016

Links

- Docs Home
- FAQ
- User Comments

User Guide

- 1) Introduction
- 2) Setup
- 3) First webapp
- 4) Deployer
- 5) Manager
- 6) Realms and AAA
- 7) Security Manager
- 8) JNDI Resources
- 9) JDBC DataSources
- 10) Classloading
- 11) JSPs
- 12) SSL/TLS
- 13) SSI
- 14) CGI
- 15) Proxy Support
- 16) MBean Descriptor
- 17) Default Servlet
- 18) Clustering
- 19) Load Balancer
- 20) Connectors
- 21) Monitoring and Management
- 22) Logging
- 23) APR/Native
- 24) Virtual Hosting
- 25) Advanced IO
- 26) Additional Components
- 27) Mavenized
- 28) Security Considerations
- 29) Windows Service
- 30) Windows Authentication
- 31) Tomcat's JDBC Pool
- 32) WebSocket

Reference

- Release Notes
- Configuration
- Tomcat Javadocs
- Servlet Javadocs
- JSP 2.2 Javadocs
- EL 2.2 Javadocs
- WebSocket 1.1 Javadocs
- JK 1.2 Documentation

Apache Tomcat Development

- Building
- Changelog
- Status
- Developers
- Architecture
- Functional Specs.
- Tribes

# Changelog

Tomcat 7.0.68 (violetagg)

> General

> > | Allow to configure multiple JUnit test class patterns with the build property `test.name` and document the property in BUILDING.txt. (rjung)

> Catalina

> > | Correct implementation of `validateClientProvidedNewSessionId` so client provided session IDs may be rejected if validation is enabled. (markt)
> > | 56785: Avoid `NullPointerException` if directory exists on the class path that is not readable by the Tomcat user. (kkolinko)
> > | 57906: Suppress WebappClassLoader log messages when running with a security manager on Java 6, caused by `java.beans.Introspector.findExplicitBeanInfo()` calls during evaluation of EL expressions. (kkolinko)
> > | 58692: Make `StandardJarScanner` more robust. Log a warning if a class path entry cannot be scanned rather than triggering the failure of the web application. (markt)
> > | 58701: Reset the `instanceInitialized` field in `StandardWrapper` when unloading a Servlet so that a new instance may be correctly initialized. (markt)
> > | 58702: Ensure an access log entry is generated if the client aborts the connection. (markt)
> > | Fixed various issues reported by Findbugs. (violetagg)
> > | 58735: Add support for the `X-XSS-Protection` header to the `HttpHeaderSecurityFilter`. Patch provided by Jacopo Cappellato. (markt)
> > | 58751: Correctly handle the case where an `AsyncListener` dispatches to a Servlet on an asynchronous timeout and the Servlet uses `sendError()` to trigger an error page. Includes a test case based on code provided by Andy Wilkinson.(markt)
> > | 58765: Change default for `mapperContextRootRedirectEnabled` to `true` since this is required for correct session management because of the default for `sessionCookiePathUsesTrailingSlash`. (markt)
> > | Add the `StatusManagerServlet` to the list of Servlets that can only be loaded by privileged applications. (markt)
> > | Simplify code and fix messages in `org.apache.catalina.core.DefaultInstanceManager` class. (kkolinko)
> > | Ensure that the proper file encoding if specified will be used when a readme file is served by DefaultServlet. (violetagg)
> > | Fix declaration of `localPort` attribute of Connector MBean: it is read-only. (kkolinko)
> > | 58766: Make skipping non-class files during annotation scanning faster by checking the file name first. Improve debug logging. (kkolinko)
> > | 58768: Log a warning if a redirect fails because of an invalid location. (markt)
> > | 58836: Correctly merge query string parameters when processing a forwarded request where the target includes a query string that contains a parameter with no value. (markt/kkolinko)
> > | Make sure that shared Digester is reset in an unlikely error case in `HostConfig.deployWAR()`. (kkolinko)
> > | Fix a potential JDBC resource leak in DataSourceRealm. (schultz)
> > | 58900: Correctly undeploy symlinked resources and prevent an infinite cycle of deploy / undeploy. (markt)
> > | Protect initialization of `ResourceLinkFactory` when running with a SecurityManager. (kkolinko)

> > Extend the feature available in the cluster session manager implementations that enables session attribute replication to be filtered bases on attribute name to all session manager implementations. Note that configuration attribute name has changed from `sessionAttributeFilter` to `sessionAttributeNameFilter`. Apply the filter on load as well as unload to ensure that configuration changes made while the web application is stopped are applied to any persisted data. (markt)

> > | Extend the session attribute filtering options to include filtering based on the implementation class of the value and optional `WARN` level logging if an attribute is filtered. These options are available for all of the Manager implementations that ship with Tomcat. When a `SecurityManager` is used filtering will be enabled by default. (markt)
> > | 58905: Ensure that `Tomcat.silence()` silences the correct logger and respects the current setting. (markt)
> > | 58946: Ensure that the request parameter map remains immutable when processing via a RequestDispatcher. (markt)

> Coyote

> > | New configuration option `ajpFlush` for the AJP connectors to disable the sending of AJP flush packets. (rjung)

> Jasper

> > | Fix handling of missing messages in `org.apache.el.util.MessageFactory`. (violetagg)

> Cluster

> > | In order to avoid that the heartbeat thread and the background thread to run `Channel.heartbeat` simultaneously, if `heartbeatBackgroundEnabled` of `SimpleTcpCluster` set to `true`, ensure that the heartbeat thread does not start. (kfujino)

> WebSocket

> > | 57489: Ensure `onClose()` is called when a WebSocket connection is closed even if the sending of the close message fails. Includes test cases by Barry Coughlan. (markt)
> > | Fix a timing issue on session close that could result in an exception being thrown for an incomplete message even through the message was completed. (markt)

> Web Applications

> > | Correct some typos in the JNDI resources How-To. (markt)
> > | Don't create sessions unnecessarily in the Manager application. (markt)
> > | Don't create sessions unnecessarily in the Host Manager application. (markt)
> > | 58723: Clarify documentation and error messages for the text interface of the manager to make clear that version must be used with path when referencing contexts deployed using parallel deployment. (markt)
> > | Correct an error in the documentation of the expected behaviour for automatic deployment. If a WAR is updated and an expanded directory is present, the directory will always be deleted and recreated by expanding the WAR if `unpackWARs` is `true`. (markt)
> > | 58935: Remove incorrect references in the documentation to using `jar:file:` URLs with the Manager application. (markt)

> Tribes

> > | Add support for the startup notification of local members in the static cluster. (kfujino)
> > | Ignore the unnecessary member remove operation from different domain. (kfujino)
> > | Add support for the shutdown notification of local members in the static cluster. (kfujino)
> > | Ensure that asynchronous session replication thread is a daemon thread. (kfujino)

> Other

> > | Update the NSIS Installer used to build the Windows Installers to version 2.50. (markt/kkolinko)

Tomcat 7.0.67 (violetagg) | released 2015-12-10

> Catalina

> > | 56917: As per RFC7231 (HTTP/1.1), allow HTTP/1.1 and later redirects to use relative URIs. This is controlled by a new attribute `useRelativeRedirects` on the Context and defaults to `true`. (markt)
> > | 58660: Correct a regression in 7.0.66 caused by the change that moved the redirection for context roots from the Mapper to the Default Servlet. (markt)
> > | Fixed potential NPE in `HostConfig` while deploying an application. Issue reported by coverity scan. (violetagg)

> > 58655: Fix an `IllegalStateException` when calling `HttpServletResponse.sendRedirect()` with the `RemoteIpFilter`. This was caused by trying to correctly generate the absolute URI for the redirect. With the fix for 56917, redirects may now be relative making the `sendRedirect()` implementation for the `RemoteIpFilter` much simpler. This also addresses issues where the redirect may not have behaved as expected when redirecting from http to https to from https to http. (markt)

> WebSocket

> > | 58658: Correct a regression in 7.0.66 that prevented Tomcat from starting on Java 6 unless the WebSocket JARs (that require Java 7) were removed. (markt)

> Web Applications

> > | Add a description of the default value of `heartbeatSleeptime` attribute and `optionCheck` attribute in the cluster channel docs. (kfujino)

> Tribes

> > | Fix potential NPE in `AbstractReplicatedMap.breakdown()`. (kfujino)

Tomcat 7.0.66 (violetagg) | not released

> General

> > | 58596: Clarify the description in RUNNING.txt of how environment variables are used. (markt)

> Catalina

> > | 34319: Only load those keys in `StoreBase.processExpire` from JDBCStore, that are old enough, to be expired. Based on a patch by Tom Anderson. (fschumacher)
> > | 56777: Allow file based configuration resources (user database, certificate revocation lists, keystores and trust stores) to be configured using URLs as well as files. Back-port provided by Huxing Zhang. (markt/violetagg)
> > | 57741: Enable the CGI servlet to use the standard error page mechanism. Note that if the CGI servlet's debug init parameter is set to 10 or higher then the standard error page mechanism will be bypassed and a debug response generated by the CGI servlet will be returned instead. (markt)
> > | 58486: Protect against two further possible memory leaks associated with XML parsing. (markt)
> > | 58497: Make `AbstractHttp11Processor` easy to extend. (markt)
> > | 58508: Escape role names when generating associated MBeans in case the role name contains characters not permitted in an MBean name. (markt)
> > | 58522: Fixed concurrency issue when iterating web application's resources. (violetagg)
> > | 58534: Removed repeated conditional tests in `o.a.tomcat.websocket.pojo.PojoMethodMapping` and `o.a.tomcat.util.net.AprEndpoint` Patch provided by Anthony Whitford. (violetagg)
> > | 58535: Use `Collections.reverseOrder` when a reverse ordering is needed. (violetagg)
> > | 58537: Some of the inner classes in `o.a.catalina.valves.ExtendedAccessLogValve` are made static. Patch provided by Anthony Whitford. (violetagg)
> > | 58540: Removed unused code from `o.a.catalina.connector.Request`. Patch provided by Anthony Whitford. (violetagg)
> > | 58541, 58544: It is more efficient to call `Integer.toString(int)` instead of `Integer.valueOf(int).toString()` when only a string representation of a primitive is needed. Based on a patch provided by Anthony Whitford. (violetagg)
> > | 58541, 58547: It is more efficient to call `valueOf(...)` instead of Number constructor. Based on a patch provided by Anthony Whitford. (violetagg)
> > | 58545: In some use cases it is more efficient to use `Map.entrySet()` instead of `Map.keySet()` Based on a patch provided by Anthony Whitford. (violetagg)
> > | Add a new RestCsrfPreventionFilter that provides basic CSRF protection for REST APIs. (violetagg)
> > | 58581: If a custom error page fails, fall back to the standard error page rather than throwing an NPE. Based on a patch by Huxing Zhang. (markt)
> > | 58582: Combined realm should perform background processing on its sub-realms. Based upon a patch provided by Aidan. (kkolinko)
> > | Handle the unlikely case where different versions of a web application are deployed with different session settings. (markt)
> > | Add a new Context option, enabled by default, that enables an additional check that a client provided session ID is in use in at least one other web application before allowing it to be used as the ID for a new session in the current web application. (markt)
> > | Add support for DIGEST authentication to the JNDIRealm. Based on a patch by Alexis Hassler. (markt)
> > | 58603: Ensure that `HttpServletRequest.getRequestURL()` returns the correct value when using the `RemoteIpFilter`. (markt)
> > | Ensure that in an embedded Tomcat the logging configuration is not lost during garbage collection. (violetagg)

> > Move the functionality that provides redirects for context roots and directories where a trailing `/` is added from the Mapper to the `DefaultServlet`. This enables such requests to be processed by any configured Valves and Filters before the redirect is made. This behaviour is configurable via the `mapperContextRootRedirectEnabled` and `mapperDirectoryRedirectEnabled` attributes of the Context which may be used to restore the previous behaviour. (markt)

> > | 58635: Enable break points to be set within agent code when running Tomcat with a Java agent. Based on a patch by Huxing Zhang. (markt)
> > | Add path parameter handling to `HttpServletRequest.getContextPath()`. This is a follow-up to the fix for 57215. (markt)

> Jasper

> > 57136#c25: Implement a setting that controls what quoting rule is used when parsing EL expressions in attributes on a JSP page (chapter JSP.1.6 of specification). The setting name is `quoteAttributeEL` and it is configured as initialisation parameter of JSP Servlet (per web application configuration is possible) and as a command line option for JspC. The default value was changed to `true`, which restores behaviour implemented in Tomcat 7.0.64. It means that attribute quoting is applied on top of EL quoting. This provides better compatibility with older versions of Tomcat and other implementations. (kkolinko)

> Cluster

> > | Optimize the session lock range in DeltaManager.requestCompleted. (kfujino)
> > | Enable an explicit configuration of local member in the static cluster membership. (kfujino)
> > | Fix potential integer overflow in `DeltaSession`. Reported by coverity scan. (fschumacher)

> Tribes

> > | Distinguish the handling of the shutdown payload and member verification clearly. When handling shutdown payload, verification completion message is not required. (kfujino)
> > | When starting the `StaticMembershipInterceptor`, `StaticMembershipInterceptor` checks the required Interceptors. If the required Interceptor does not exist, it issues warning logs. (kfujino)
> > | Ensure that the static member is registered to the add suspect list even if the static member that is registered to the remove suspect list has disappeared. (kfujino)
> > | Correct the warning log of when the member that is not registered in the membership is detected. (kfujino)
> > | When using a static cluster, add the members that have been cached in the membership service to the map members list in order to ensure that the map member is a static member. (kfujino)

> WebSocket

> > | Use instance manager for server endpoint instances. (remm)
> > | 55006: The WebSocket client now honors the `java.net.java.net.ProxySelector` configuration (using the HTTP type) when establishing WebSocket connections to servers. Based on a patch by Niki Dokovski. (markt)
> > | 58624: Correct a thread safety issue that meant that blocking message writes could block indefinitely if the WebSocket connection was closed while a message write was in progress. (markt)

> Web applications

> > | Make it clear in the documentation for the CGI servlet that the debug page is not considered secure and should not be used in production. (markt)
> > | The `domain` attribute of `StaticMember` is not required but optional. (kfujino)
> > | 58631: Correct the continuation character use in the Windows Service How-To page of the documentation web application. (markt)

> jdbc-pool

> > | 58489: Correct QueryStatsComparator to hold up the general contract for Comparator. (fschumacher)
> > | When creating a `QueryStats` object, ensure that `maxQueries` is checked. If `maxQueries` is a value less than or equal to 0, `QueryStats` are never created. (kfujino)
> > | Fix potential integer overflow in `ConnectionPool` and `PooledConnection`. Reported by coverity scan. (fschumacher)

Tomcat 7.0.65 (violetagg) | released 2015-10-19

> Catalina

> > | 57681: Add a web application class loader implementation that supports the parallel loading of web application classes. Use of this feature requires a Java 7 or later JRE. Based on a patch by Huxing Zhang. (markt)
> > | 58187: Correct a regression in the fix for 57765 that meant that deployment of web applications deployed via the Manager application was delayed until the next execution of the automatic deployment background process. (markt)
> > | 58284: Correctly implement session serialization so non-serializable attributes are skipped with a warning. Patch provided by Andrew Shore. (markt)
> > | 58313: Fix concurrent access of encoders map when clearing encoders prior to switch to async. (markt)
> > | 58320: Fix concurrent access of request attributes which is possible during asynchronous processing. (markt)
> > | In preparation for implementing enhancement 57681, replace the use of the `StandardClassLoader` with `URLClassLoader`. This removes the server class loader from JMX. (markt)
> > | 58352: Always trigger a thread dump if Tomcat fails to stop gracefully from `catalina.sh` even if using `-force`. Patch provided by Alexandre Garnier. (markt)
> > | 58416: Correctly detect when a forced stop fails to stop Tomcat because the Tomcat process is waiting on some system call or is uninterruptible. (markt)
> > | 58436: Fix some rare data races in JULI's `ClassLoaderLogManager` during shutdown. (markt)

> Coyote

> > | Correct some edge cases in `RequestUtil.normalize()`. (markt)
> > | 58275: The IBM JREs accept cipher suite names starting with `TLS_` or `SSL_` but when listing the supported cipher suites only the `SSL_` version is reported. This can break Tomcat's check that at least one requested cipher suite is supported. Tomcat now includes a work-around so either form of the cipher suite name can be used when running on an IBM JRE. (markt)
> > | 58357: For reasons not currently understood when the APR/native connector is used with OpenSSL reads can return an error code when there is no apparent error. This was work-around for HTTP upgrade connections by treating this as `EAGAIN`. The same fix has now been applied to the standard HTTP connector. (markt)
> > | 57799: Remove useless sendfile check for NIO SSL. (remm)

> Jasper

> > | 57136: Correct a regression in the previous fix for this issue. `\${` should only be an escape for `${` within an EL expression. Within a JSP page `\$` should be an escape for `$`. The EL specification applies when parsing the expression delimited by `${` and `}`. Parsing of the delimiting `${` and `}` is the responsibility of the JSP specification. (markt)
> > | 58296: Fix a memory leak in the JSP unloading feature that meant that using a value other than `-1` for `maxLoadedJsps` triggered a memory leak once the limit was reached. (markt)
> > | 58340: Improve error reporting for tag files packaged in JARs. (markt)
> > | 58444: Ensure that JSPs work with any custom base class that meets the requirements defined in the JSP specification without requiring that base class to implement Tomcat specific code. (markt)

> Cluster

> > | Fix a default clusterListeners in `SimpleTcpCluster`. The optimal default value is different for each session manager. `ClusterSessionListener` is never used in `BackupManager`. (kfujino)
> > | Correct log messages in case of using `BackupManager`. (kfujino)

> WebSocket

> > | 58342: Fix a copy and paste error that meant MessageHandler removal could fail for binary and pong MessageHandlers. Patch provided by DJ. (markt)
> > | 58414: Correctly handle sending zero length messages when using per message deflate. (markt)

> Web applications

> > | Correct documentation for cluster-howto. (kfujino)

> Extras

> > | Ensure JULI adapters does not include the LogFactoryImpl class. Patch provided by Benjamin Gandon. (markt)

> Tribes

> > | Add support for configurations of `ChannelListener` and `MembershipListener` in server.xml. (kfujino)
> > | Correct log messages in case of using `ReplicatedMap`. (kfujino)

> jdbc-pool

> > | Make sure the pool has been properly configured when attributes that related to the pool size are changed via JMX. (kfujino)

Tomcat 7.0.64 (violetagg) | released 2015-08-25

> Catalina

> > | 55317: Facilitate weaving by allowing ClassFileTransformer to be added to WebappClassLoader. Patch by Nick Williams. (markt)
> > | 58031: Make the (first) reason parameter parsing failed available as a request attribute and then use it to provide a better status code via the FailedRequstFilter (if configured). (markt)
> > | 58086: Ensure that WAR URLs are handled properly when using Apache Ant for web application deployment. (violetagg)
> > | 58094: Fix cosmetic error log when using non standard non cacheable resources, like with the empty resources used in some tests. (remm)
> > | 58096: Classes loaded from `/WEB-INF/classes/` should use that directory as their code base. (markt)
> > | Fix possible resource leaks by closing streams properly. Issues reported by Coverity Scan. (violetagg)
> > | 58116: Fix a regression in the fix for 57281 that broke Comet support when running under a security manager. Based on a patch provided by Johno Crawford. (markt)
> > | 58179: Fix a thread safety issues that could mean concurrent threads setting the same attribute on a `ServletContext` could both see `null` as the old value. (markt)
> > | 58192: Correct a regression in the previous fix for 58023. Ensure that classes are associated with their manifest even if the class file is first read (and cached) without the manifest. (markt)
> > | Fix thread safety issue in the `AsyncContext` implementation that meant a sequence of `start();dispatch();` calls using non-container threads could result in a previous dispatch interfering with a subsequent start. (markt)

> Coyote

> > | 57943: Prevent the same socket being added to the cache twice. Patch based on analysis by Ian Luo / Sun Qi. (markt)
> > | Add `text/javascript,application/javascript` to the default list of compressable MIME types. (violetagg)
> > | 58103: When pipelining requests, and the previous request was an async request, ensure that the socket is removed from the waiting requests so that the async timeout thread doesn't process it during the next request. (markt)
> > | Fix a concurrency issue that meant that a change in socket timeout (e.g. when switching to asynchronous I/O) did not always take effect immediately. (markt)
> > | In the AJP and HTTP NIO connectors, ensure that the socket timeout is correctly set before adding the socket back to the poller for read. (markt)
> > | 58157: Ensure that the handling of async timeouts does not result in an unnecessary dispatch to a container thread that could result in the current socket being added to the Poller multiple times with multiple attempts to process the same event for the same socket. (markt)
> > | Correct a couple of edge cases in `RequestUtil.normalize()`. (markt)

> Jasper

> > | 58110: Like scriptlet sections, declaration sections of JSP pages have a one-to-one mapping of lines to the generated .java file. Use this information to provide more accurate error messages if a compilation error occurs in a declaration section. (markt)
> > | 58119: When tags are compiled they must be placed in the org/apache/jsp/tag/web directory. Correct a regression in the fix for 52725. (violetagg)
> > | 58178: Expressions in a tag file should use the tag file's `PageContext` rather than that of the containing page. (markt)

> WebSocket

> > | 58166: Allow applications to send close codes in the range 3000-4999 inclusive. (markt)
> > | 58232: Avoid possible NPE when adding endpoints programmatically to the `javax.websocket.server.ServerContainer`. Based on a patch provided by bastian.(violetagg)

> Web applications

> > | Correct the incorrect document of `QueryTimeoutInterceptor`. The setting value is not in milliseconds but in seconds. (kfujino)
> > | 58112: Update the documentation for using the Catalina tasks in an Apache Ant build file. (markt)
> > | Improve the Javadoc for some of the APR socket read functions that have inconsistent behaviour for return values. (markt)
> > | 58255: Document the Semaphore valve. Patch provided by Kyohei Nakamura. (markt)

> jdbc-pool

> > | Fix potential NPE in `QueryTimeoutInterceptor`. (kfujino)
> > | Add support for stopping the pool cleaner via JMX. (kfujino)
> > | The `fairness` attribute and `ignoreExceptionOnPreLoad` attribute do not allow a change via JMX. (kfujino)
> > | If the `timeBetweenEvictionRunsMillis` attribute is changed via jmx, it should restart the pool cleaner because this attribute affects the execution interval of the pool cleaner. (kfujino)
> > | Eliminate the dependence on `maxActive` of busy queues and idle queue in order to enable the expansion of the pool size via JMX. (kfujino)

> Other

> > | Update sample Eclipse IDE configuration to exclude test/webapp* and similar paths from compiler sourcepath. (kkolinko)

Tomcat 7.0.63 (violetagg) | released 2015-07-06

> Catalina

> > 57938: Correctly handle empty form fields when a form is submitted as `multipart/form-data`, the `maxPostSize` attribute of the Connector has been set to a negative value and the Context has been configured with a value of `true` for `allowCasualMultipartParsing`. The meaning of the value zero for the `maxPostSize` has also been changed to mean a limit of zero rather than no limit to align it with `maxSavePostSize` and to be more intuitive. (markt)

> > | 54618: Add a new `HttpHeaderSecurityFilter` that adds the `Strict-Transport-Security`, `X-Frame-Options` and `X-Content-Type-Options` HTTP headers to the response. (markt)
> > | Add a workaround for issues with SPNEGO authentication when running on Java 8 update 40 and later. The workaround should be safe for earlier Java versions but it can be disabled with the `applyJava8u40Fix` attribute of the SPNEGO authenticator if necessary. (markt)
> > | 57154: Add support for web applications (Context elements) that do not have a docBase. This is primarily for use when embedding but it also fixes a rare issue when running the unit test. Patch provided by Huxing Zhang. (markt)
> > | 57959: Fixed deadlock in `org.apache.juli.FileHandler` when log is rotated. (violetagg)
> > | 57977: Correctly bind and unbind the web application class loader during execution of the PersistentValve. (markt)
> > | 58023: Fix potentially excessive memory usage due to unnecessary caching of JAR manifests in the web application class loader. (markt)
> > | 57700: Ensure that Container event `ADD_CHILD_EVENT` will be sent in all cases. (violetagg)
> > | Add configuration fields for header names in SSLValve. (remm)

> Coyote

> > | 57265: Further fix to address a potential threading issue for NIO when sendfile is used in conjunction with TLS. (markt)
> > | 57931: Ensure that TLS connections with the NIO HTTP connector that experience issues during the handshake (e.g. missing or invalid client certificate) are closed cleanly and that the client receives the correct error code rather than simply closing the connection. (markt)
> > | 57943: Added a work-around to catch `ConcurrentModificationException`s during Poller timeout processing that were causing the Poller thread to stop. The root cause of these exceptions is currently unknown. (markt)
> > | Fix possible very long (1000 seconds) timeout with APR/native connector. (markt)
> > | Support "-" separator in the SSLProtocol configuration of the APR/native connector for protocol exclusion. (rjung)

> Cluster

> > | Make sure that stream is closed after using it in `DeltaSession.applyDiff()`. (kfujino)

> WebSocket

> > | 57676: List conflicting WebSocket endpoint classes when there is a path conflict. Based upon a patch proposed by yangkun. (schultz)
> > | Extend support for the `permessage-deflate` extension to the client implementation.
> > | 57969: Provide path parameters to POJO via per session `javax.websocket.server.ServerEndpointConfig` as they vary between different requests. (violetagg)
> > | 57974: Session.getOpenSessions should return all sessions associated with a given endpoint instance, rather than all sessions from the endpoint class. (remm)

> Web applications

> > | 57282: Update request processing sequence diagrams. Updated diagrams provided by Stephen Chen. (markt)
> > | 57971: Correct the documentation for the cluster configuration setting `recoverySleepTime`. (markt)
> > | 57758: Add document of `testOnConnect` attribute in jdbc-pool doc. (kfujino)
> > | Add description of `validatorClassName` attribute to testXXXX attributes in jdbc-pool docs. (kfujino)

> Tribes

> > | Ensure that the state transfer flag is updated to true only when the map states have been transferred correctly from existing map members. (kfujino)
> > | Do not set the nodes that failed to replication to the backup nodes. Ensure that the nodes that the data has been successfully replicated are set to the backup node. (kfujino)
> > | When failed to replication, rather than all member is handled as a failed member, exclude the failure members from backup members. (kfujino)

> jdbc-pool

> > | Refactoring of the `removeOldest` method in `SlowQueryReport` to behave as expected. (kfujino)
> > | 57783: Fix `NullPointerException` in `SlowQueryReport`. To avoid this NPE, Refactor `SlowQueryReport#removeOldest` and handle the abandoned connection properly. (kfujino)

> Other

> > | Update package renamed Apache Commons BCEL to r1682271 to pick up some some code clean up. (markt)
> > | Update package renamed Apache Commons File upload to r1682322 to pick up the post 1.3.1 fixes. (markt)
> > | Update package renamed Apache Commons Codec to r1682326. No functional changes. Javadoc only. (markt)

Tomcat 7.0.62 (violetagg) | released 2015-05-14

> Catalina

> > | Allow logging of the remote port in the access log using the format pattern `%{remote}p`. (rjung)

> > 57765: When checking last modified times as part of the automatic deployment process, account for the fact that `File.lastModified()` has a resolution of one second to ensure that if a file has been modified within the last second, the latest version of the file is always used. Note that a side-effect of this change is that files with modification times in the future are treated as if they are unmodified. (markt)

> > | Align redeploy resource modification checking with reload modification checking so that now, in both cases, a change in modification time rather than an increase in modification time is used to determine if the resource has changed. (markt)
> > | Cleanup `o.a.tomcat.util.digester.Digester` from debug messages that do not give any valuable information. Patch provided by Polina Genova. (violetagg)
> > | 57772: When reloading a web application and a directory representing an expanded WAR needs to be deleted, delete the directory after the web application has been stopped rather than before to avoid potential ClassNotFoundExceptions. (markt)
> > | 57801: Improve the error message in the start script in case the PID read from the PID file is already owned by a process. (rjung)
> > | 57824: Correct a regression in the fix for 57252 that broke request listeners for non-async requests that triggered an error that was handled by the ErrorReportingValve. (markt/violetagg)
> > | 57841: Improve error logging during web application start. (markt)
> > | 57856: Ensure that any scheme/port changes implemented by the `RemoteIpFilter` also affect `HttpServletResponse.sendRedirect()`. (markt)
> > | 57896: Support defensive copying of "cookie" header so that unescaping double quotes in a cookie value does not corrupt original value of "cookie" header. This is an opt-in feature, enabled by `org.apache.tomcat.util.http.ServerCookie.PRESERVE_COOKIE_HEADER` or `org.apache.catalina.STRICT_SERVLET_COMPLIANCE` system property. (kkolinko)

> Coyote

> > | 57779: When an I/O error occurs on a non-container thread only dispatch to a container thread to handle the error if using Servlet 3+ asynchronous processing. This avoids potential deadlocks if an application is performing I/O on a non-container thread without using the Servlet 3+ asynchronous API. (markt)
> > | 57833: When using JKS based keystores for NIO, ensure that the key alias is always converted to lower case since that is what JKS key stores expect. Based on a patch by Santosh Giri Govind M. (markt)
> > | 57837: Add `text/css` to the default list of compressable MIME types. (markt)

> Jasper

> > | 57845: Ensure that, if the same JSP is accessed directly and via a `<jsp-file>` declaration in web.xml, updates to the JSP are visible (subject to the normal rules on re-compilation) regardless of how the JSP is accessed. (markt)
> > | 57855: Explicitly handle the case where a `MethodExpression` is invoked with null or the wrong number of parameters. Rather than failing with an `ArrayIndexOutOfBoundsException` or a `NullPointerException` throw an `IllegalArgumentException` with a useful error message. (markt)

> Cluster

> > | Add new attribute that send all actions for session across Tomcat cluster nodes. (kfujino)
> > | Remove unused `pathname` attribute in mbean definition of `BackupManager`. (kfujino)
> > | 57338: Improve the ability of the ClusterSingleSignOn valve to handle nodes being added and removed from the Cluster at run time. (markt)
> > | Avoid unnecessary call of `DeltaRequest.addSessionListener()` in non-primary nodes. (kfujino)

> WebSocket

> > | 57762: Ensure that the WebSocket client correctly detects when the connection to the server is dropped. (markt)
> > | 57776: Revert the 8.0.21 fix for the `permessage-deflate` implementation and incorrect op-codes since the fix was unnecessary (the bug only affected trunk) and the fix broke rather than fixed `permessage-deflate` if an uncompressed message was converted into more than one compressed message. (markt)
> > | Fix log name typo in `WsRemoteEndpointImplServer` class, caused by a copy-paste. (markt/kkolinko)
> > | 57788: Avoid NPE when looking up a class hierarchy without finding anything. (remm)

> Web applications

> > | 57759: Add information to the keyAlias documentation to make it clear that the order keys are read from the keystore is implementation dependent. (markt)
> > | 57864: Update the documentation web application to make it clearer that hex values are not valid for cluster send options. Based on a patch by Kyohei Nakamura. (markt)

> Tribes

> > | Fix a concurrency issue when a backup message that has all session data and a backup message that has diff data are processing at the same time. This fix ensures that `MapOwner` is set to `ReplicatedMapEntry`. (kfujino)
> > | Clarify the handling of Copy message and Copy nodes. (kfujino)
> > | Copy node does not need to send the entry data. It is enough to send only the node information of the entry. (kfujino)
> > | `ReplicatedMap` should send the Copy message when replicating. (kfujino)
> > | Fix behavior of `ReplicatedMap` when member has disappeared. If map entry is primary, rebuild the backup members. If primary node of map entry has disappeared, backup node is promoted to primary. (kfujino)
> > | When a map member has been added to `ReplicatedMap`, make sure to add it to backup nodes list of all other members. (kfujino)

Tomcat 7.0.61 (violetagg) | released 2015-04-07

> Catalina

> > | 55988: Correct the check used for Java 8 JSSE server-preferred TLS cipher suite ordering. Ensure that SSL parameters are provided to `SSLServerSocket` and `SSLEngine`. Patch provided by Ognjen Blagojevic. (violetagg)

> WebSocket

> > | 57761: Ensure that the opening HTTP request is correctly formatted when the WebSocket client connects to a server root. (remm)

Tomcat 7.0.60 (violetagg) | not released

> Catalina

> > | Clarify threaded usage of variables by removing volatile marker in NonceInfo. Issue reported by Coverity Scan. (fschumacher)
> > | 49785: Enable StartTLS connections for JNDIRealm. (fschumacher)
> > | 55988: Add support for Java 8 JSSE server-preferred TLS cipher suite ordering. This feature requires Java 8 and is controlled by `useServerCipherSuitesOrder` attribute on an HTTP connector. Based upon patches provided by Ognjen Blagojevic. (schultz)
> > | 56438: Add logging that reports when a JAR is scanned for TLDs but nothing is found so that Tomcat may be configured to skip this JAR in future. Based on a patch by VIN. (markt)
> > | 56848: Use `Locale.forLanguageTag` to process Locale headers when running on a Java 7 or later JRE. (markt)
> > | 57021: Improve logging in AprLifecycleListener and jni.Library when Tomcat-Native DLL fails to load. Based on a patch by Pravallika Peddi. (markt/kkolinko)
> > | 57180: Further fixes to support the use of arbitrary HTTP methods with the CORS filter. (markt)
> > | Warn about problematic setting of appBase. (fschumacher)
> > | 57534: CORS Filter should only look at media type component of Content-Type request header. (markt)
> > | Ensure that user name checking in the optional SecurityListener is case-insensitive (as documented) and than the case-insensitive comparison is performed using the system default Locale. (markt)
> > | When docBase refers internal war and unpackWARs is set to false, avoid registration of the invalid redeploy resource that has been added ".war" extension in duplicate. (kfujino)
> > | If WAR exists, it is not necessary to trigger a reload when adding a Directory. (kfujino)
> > | 56608: When deploying an external WAR, add watched resources in the expanded directory based on whether the expanded directory is expected to exist rather than if it does exist.
> > | When triggering a reload due to a modified watched resource, ensure that multiple changed watched resources only trigger one reload rather than a series of reloads.
> > | 57601: Ensure that HEAD requests return the correct content length (i.e. the same as for a GET) when the requested resource includes a resource served by the Default servlet. (jboynes/markt)
> > | 57602: Ensure that HEAD requests return the correct content length (i.e. the same as for a GET) when the requested resource includes a resource served by a servlet that extends `HttpServlet`. (markt)
> > | 57621: When an async request completes, ensure that any remaining request body data is swallowed. (markt)
> > | 57637: Do not create unnecessary sessions when using PersistentValve. (jboynes/fschumacher)
> > | 57645: Correct a regression in the fix for 57190 that incorrectly required the path passed to `ServletContext.getContext(String)` to be an exact match to a path to an existing context. (markt)
> > | Make sure that `unpackWAR` attribute of `Context` is handled correctly in `HostConfig`. (kfujino)
> > | When deploying a WAR file that contains a context.xml file and `unpackWARs` is `false` ignore any context.xml file that may exist in an expanded directory associated with the WAR. (markt)
> > | 57675: Correctly quote strings when using the extended access log. (markt)
> > | 57704: Fix potential NPEs during web application start/stop when `org.apache.tomcat.InstanceManager` is not initialized. (violetagg)
> > | Add support for `LAST_ACCESS_AT_START` system property to `SingleSignOn`. (kfujino)
> > | 57723: Ensure that the Context name and path remain consistent when adding a web application to an embedded Tomcat instance via `Tomcat.addWebapp(Host,String,String,String)`. (markt)
> > | 57724: Handle the case in the CORS filter where a user agent includes an origin header for a non-CORS request. (markt)
> > | Refactor Authenticator implementations to reduce code duplication. (markt)
> > | When searching for SCIs `o.a.catalina.Context.getParentClassLoader` will be used instead of `java.lang.ClassLoader.getParent`. Thus one can provide the correct parent class loader when running embedded Tomcat in other environments such as OSGi. (violetagg)

> Coyote

> > | 57509: Improve length check when writing HTTP/1.1 response headers: reserve space for 4 extra bytes. (kkolinko)

> > 57540: Make TLS/SSL protocol available in a new request attribute (`org.apache.tomcat.util.net.secure_protocol_version`). (Note that AJP connectors will require `mod_jk` 1.2.41 or later, or an as-yet-unknown version of mod_proxy_ajp, or configure the proxy to send the AJP_SSL_PROTOCOL request attribute to Tomcat. Please see the bug comments for details.) Based upon a patch provided by Ralf Hauser. (schultz)

> > | 57544: Fix potential infinite loop when preparing a kept alive HTTP connection for the next request. (markt)
> > | 57546: Ensure that a dropped network connection does not leave references to the UpgradeProcessor associated with the connection in memory. (markt)
> > | 57570: Make the processing of trailer headers with chunked input optional and disabled by default. (markt)
> > | When applying the `maxSwallowSize` limit to a connection read that many bytes first before closing the connection to give the client a chance to read the response. (markt)
> > | Prevent an async timeout being processed multiple times for the same socket when running on slow and/or heavily loaded systems. (markt)
> > | 57581: Change statistics byte counter in coyote Request object to be long to allow values above 2Gb. (kkolinko)
> > | Fix a concurrency issue in the APR Poller that meant it was possible under low load for a socket queued to be added to the Poller not to be added for 10 seconds. (markt)
> > | 57638: Avoid an IllegalArgumentException when an AJP request body chunk larger than the socket read buffer is being read. This typically requires a larger than default AJP packetSize. (markt)
> > | 57674: Avoid a BufferOverflowException when an AJP response body chunk larger than the socket write buffer is being written. This typically requires a larger than default AJP packetSize. (markt)
> > | Refactor Connector authentication (only used by AJP) into a separate method. (markt)
> > | 57708: Implement a new feature for AJP connectors - Tomcat Authorization. If the new tomcatAuthorization attribute is set to `true` (it is disabled by default) Tomcat will take an authenticated user name from the AJP protocol and use the appropriate Realm for the request to authorize (i.e. add roles) to that user. (markt)
> > | Fix an issue that meant that any pipe-lined data read by Tomcat before an asynchronous request completed was lost during the completion of the asynchronous request. This mean that the pipe-lined request(s) would be lost and/or corrupted. (markt)
> > | Update the minimum recommended version of the Tomcat Native library (if used) to 1.1.33. (markt)

> Jasper

> > | 57136: Ensure only `\${` and `\#{` are treated as escapes for `${` and `#{` rather than `\$` and `\#` being treated as escapes for `$` and `#` when processing literal expressions in expression language. (markt)
> > | 57148: When coercing an object to a given type and a `PropertyEditor` has been registered for the type correctly coerce the empty string to `null` if the `PropertyEditor` throws an exception. (kkolinko/markt)
> > | Simplify code in `ProtectedFunctionMapper` class of Jasper runtime. (kkolinko)
> > | 57123: Update all references to the ECJ compiler to version 4.4.1. With thanks to Ralph Schaer for uploading the 4.4.1 JAR to Maven Central. (markt)
> > | 57662: Update all references to the ECJ compiler to version 4.4.2. (violetagg)
> > | 57643: Fix JspC when the path to the web application to compile contains a character that must be encoded when used in a URL such as space. (mark)

> Cluster

> > | Remove unnecessary method that always returns true. The domain filtering works on `DomainFilterInterceptor`. (kfujino)

> WebSocket

> > | Correct a bug in the `permessage-deflate` implementation that meant that the incorrect op-codes were used if an uncompressed message was converted into more than one compressed message. (markt)

> Web applications

> > | Fix possible resource leaks by closing streams properly. Issues reported by Coverity Scan. (fschumacher)
> > | 56058: Add links to the AccessLogValve documentation for configuring reverse proxies and/or Tomcat to ensure that the desired information is used entered in the access log when Tomcat is running behind a reverse proxy. (markt)
> > | 57503: Make clear that the JULI integration for log4j only works with log4j 1.2.x. (markt)
> > | Remove incorrect note from context configuration page in the documentation web application that stated WAR files located outside the appBase were never unpacked. (markt)
> > | 57644: Update examples to use Apache Standard Taglib 1.2.5. (jboynes)
> > | 57683: Ensure that if a client aborts their connection to the stock ticker example (the only way a client can disconnect), the example continues to work for existing and new clients. (markt)
> > | Correct the documentation for deployOnStartup to make clear that if a WAR file is updated while Tomcat is stopped and unpackWARs is true, Tomcat will not detect the changed WAR file when it starts and will not replace the unpacked WAR file with the contents of the updated WAR. (markt)

> Extras

> > | 57377: Remove the restriction that prevented the use of SSL when specifying a bind address with the JMXRemoteLifecycleListener. Also enable SSL to be configured for the registry as well as the server. (markt)

> Tribes

> > | Make sure that refuse the messages from a different domain in `DomainFilterInterceptor`. (kfujino)

> Other

> > | Enhance bean factory used for JNDI resources. New attribute `forceString` allows to support non-standard string argument property setters. (rjung)
> > | Fix `TestAbstractAjpProcessor` unit test failures on Windows. (kkolinko)
> > | Guard the digester from MbeansDescriptorsDigesterSource with its own lock object. (fschumacher)
> > | 57558: Add missing JAR in Ant task definition required by the validate task. (markt/kkolinko)
> > | List names of Testsuites that have failed or skipped tests when running tests with Ant. (kkolinko)
> > | 57703: Update the `http-method` definition for web applications using a Servlet 2.5 descriptor as per Servlet 2.5 MR 6. (markt)
> > | Update to Tomcat Native Library version 1.1.33 to pick up the Windows binaries that are based on OpenSSL 1.0.1m and APR 1.5.1. (markt)

Tomcat 7.0.59 (violetagg) | released 2015-02-04

> Jasper

> > | 57504: Initialize TLD locations cache when creating the ServletContext. (jboynes)

> Tribes

> > | Fix a possible deadlock when receiver thread invokes `mapMemberAdded()` while ping thread invokes `memberAlive()`. (kfujino)

Tomcat 7.0.58 (violetagg) | not released

> Catalina

> > | 57173: Revert the fix for 56953 that broke annotation scanning in some cases. (markt)
> > | 57178: The CORS filter now treats `null` as a valid origin that matches `*`. Patch provided by Gregor Zurowski. (markt)
> > | 57180: Do not limit the CORS filter to only accepting requests that use an HTTP method defined in RFC 7231. (markt)
> > | 57190: Fix `ServletContext.getContext(String)` when parallel deployment is used so that the correct ServletContext is returned. (markt)
> > | 57208: Prevent NPE in JNDI Realm when no results are found in a directory context for a user with specified user name. Based on a patch provided by Jason McIntosh. (violetagg)
> > | 57209: Add a new attribute, userSearchAsUser to the JNDI Realm. (markt)
> > | 57215: Ensure that the result of calling `HttpServletRequest.getContextPath()` is neither decoded nor normalized as required by the Servlet specification. (markt)
> > | 57216: Improve handling of invalid context paths. A context path should either be an empty string or start with a `'/'` and do not end with a `'/'`. Invalid context path are automatically corrected and a warning is logged. The `null` and `"/"` values are now correctly changed to `""`. (markt/kkolinko)
> > | Correct message that is logged when load-on-startup servlet fails to load. It was logging a wrong name. (kkolinko)
> > | 57239: Correct several message typos. Includes patch by vladk. (kkolinko)
> > | Make the session id generator extensible by adding a `SessionIdGenerator` interface, an abstract base class and a standard implementation. (rjung)
> > | Back-port clarification from Servlet 3.1 specification that during async processing an `IllegalStateException` should be thrown if `getRequest()` or `getResponse()` is called after `complete()` or `dispatch()`. (markt)
> > | Fix a concurrency issue in async processing. Ensure that a non-container thread can not change the async state until the container thread has completed. (markt)
> > | 57252: Provide application configured error pages with a chance to handle an async error before the built-in error reporting. (markt)
> > | 57281: Enable non-public Filter and Servlet classes to be configured programmatically via the Servlet 3.0 API and then used without error when running under a SecurityManager. (markt)
> > | 57308: Remove unnecessary calls to `System.getProperty()` where more suitable API calls are available. (markt)
> > | Add unit tests for RemoteAddrValve and RemoteHostValve. (rjung)
> > | Allow to configure RemoteAddrValve and RemoteHostValve to adopt behavior depending on the connector port. Implemented by optionally adding the connector port to the string compared with the patterns `allow` and `deny`. Configured using `addConnectorPort` attribute on valve. (rjung)
> > | Optionally trigger authentication instead of denial in RemoteAddrValve and RemoteHostValve. This only works in combination with `preemptiveAuthentication` on the application context. Configured using `invalidAuthenticationWhenDeny` attribute on valve. (rjung)
> > | Prevent file descriptors leak and ensure that files are closed after retrieving the last modification time. (violetagg)
> > | 57326: Enable `AsyncListener` implementations to re-register themselves during `AsyncListener.onStartAsync`. (markt)
> > | 57331: Allow ExpiresFilter to use "year" as synonym for "years" in its configuration. (kkolinko)
> > | Improve SnoopServlet in unit tests. (rjung)
> > | Add RequestDescriptor class to unit tests. Adjust TestRewriteValve to use RequestDescriptor. (rjung)
> > | Add more AJP unit tests. (rjung)
> > | 57363: Log to stderr if LogManager is unable to read configuration files rather than swallowing the exception silently. (markt)
> > | 57420: Make UEncoder a local variable in DirContextURLConnection to make it threadsafe. Based on ideas from kkolinko and violetagg. (fschumacher)
> > | 57425: Don't add attributes with null value or name to the replicated context. (fschumacher)
> > | 57431: Enable usage of custom class for context creation when using embedded tomcat. (fschumacher)
> > | 57446: Ensure that `ServletContextListener`s that have limited access to `ServletContext` methods are called with the same `ServletContext` instance for both `contextInitialized()` and `contextDestroyed()`. (markt)
> > | 57461: When an instance of `org.apache.catalina.startup.VersionLoggerListener` logs the result of `System.getProperty("java.home")` don't report it in a manner that makes it look like the `JAVA_HOME` environment variable. (markt)
> > | While closing streams for given resources ensure that if an exception happens it will be handled properly. Issue is reported by Coverity Scan. (violetagg)
> > | Change Response to use UEncoder instances with shared safeChars. (fschumacher)
> > | Allow `VersionLoggerListener` to log all system properties. This feature is off by default. (kkolinko)

> Coyote

> > | 57234: Make SSL protocol filtering to remove insecure protocols case insensitive. (markt)
> > | 57265: Fix some potential concurrency issues with sendFile and the NIO connector. (markt)
> > | 57324: If the client uses `Expect: 100-continue` and Tomcat responds with a non-2xx response code, Tomcat also closes the connection. If Tomcat knows the connection is going to be closed when committing the response, Tomcat will now also send the `Connection: close` response header. (markt)
> > | 57340: When using Comet, ensure that Socket and SocketWrapper are only returned to their respective caches once on socket close (it is possible for multiple threads to call close concurrently). (markt)
> > | 57446: Ensure that `ServletContextListener`s that have limited access to `ServletContext` methods are called with the same `ServletContext` instance for both `contextInitialized()` and `contextDestroyed()`. (markt)

> Jasper

> > | CVE-2014-7810: Do not use a privileged code block when evaluating EL expressions when running under a security manager, which allowed to bypass code restrictions. (markt)
> > | Fix an issue with BeanELResolver when running under a security manager. Some classes may not be accessible but may have accessible interfaces. (markt)
> > | 57316: Fix JspC when directory name contains a character sequence that appears to be URL encoded. (markt)

> Cluster

> > | In order to enable define in `Cluster` element, `ClusterSingleSignOn` implements `ClusterValve`. (kfujino)
> > | Fix mbean descriptor of `ClusterSingleSignOn`. (kfujino)
> > | 57473: Add sanity check to FarmWebDeployer's WarWatcher to detect suspected incorrect permissions on the watch directory. (schultz)

> WebSocket

> > | Correct multiple issues with the flushing of batched messages that could lead to duplicate and/or corrupt messages. (markt)
> > | Correctly implement headers case insensitivity. (markt/remm)
> > | Allow optional use of user extensions. (remm)
> > | Allow using partial binary message handlers. (remm)
> > | Limit ping/pong message size. (remm)
> > | Allow configuration of the time interval for the periodic event. (remm)
> > | More accurate annotations processing. (remm)
> > | Allow optional default for origin header in the client. (remm)
> > | 57490: Make it possible to use Tomcat's WebSocket client within a web application when running under a SecurityManager. Based on a patch by Mikael Sterner. (markt)
> > | Add some debug logging to the WebSocket session to track session creation and session closure. (markt)

> Web applications

> > | Update documentation for CGI servlet. Recommend to copy the servlet declaration into web application instead of enabling it globally. Correct documentation for cgiPathPrefix. (kkolinko)
> > | Improve HTML version of build instructions and align with BUILDING.txt. Document creating second Eclipse project to compile WebSocket classes with Java 7 (`ide-eclipse-websocket` target added in 7.0.56). (kkolinko)
> > | Improve Tomcat Manager documentation. Rearrange, add section on HTML GUI, document /expire command and Server Status page. (kkolinko)
> > | Fix ambiguity of section links on Valves configuration reference page. (kkolinko)
> > | 57238: Update information on SSL/TLS on Security and SSL documentation pages. Based on patch by Glen Peterson. (kkolinko)
> > | 57261: Add vminfo and threaddump commands to Manager application. Implement `VminfoTask` and `ThreaddumpTask` Ant tasks. (kkolinko)
> > | 57323: Correct display of outdated sessions in sessions count listing in Manager application. (kkolinko)
> > | Add document of `ClusterSingleSignOn`. (kfujino)
> > | Clarify documentation for `useBodyEncodingForURI` attribute of a connector. (kkolinko)

> Other

> > | When downloading required libraries at build time, use random name for temporary file and automatically create destination directory (`base.path`). (kkolinko)
> > | Update optional Checkstyle library to 6.1.1. (kkolinko)
> > | Simplify `setproxy` task in `build.xml`. Taskdef there is not needed since Ant 1.8.2. (kkolinko)
> > | Improve Java 7 support in `build.xml`. Check whether the specified ${java.7.home} is valid. By default use Java that runs Ant (${java.home}) instead of the one found on $PATH to run JUnit tests. (kkolinko)
> > | 57344: Provide sha1 checksum files for Tomcat downloads. Correct filename patterns for apache-tomcat-*-embed.tar.gz archive to exclude an *.asc file. (kkolinko)

Tomcat 7.0.57 (violetagg) | released 2014-11-11

> Catalina

> > | 47919: Extend the information logged when Tomcat starts to optionally log the values of command line arguments (enabled by default) and environment variables (disabled by default). Note that the values added to CATALINA_OPTS and JAVA_OPTS environment variables will be logged, as they are used to build up the command line. (markt)
> > | 56401: Log version information when Tomcat starts. (markt/kkolinko)
> > | 57022: Ensure SPNEGO authentication continues to work with the JNDI Realm using delegated credentials with recent Oracle JREs. (markt)
> > | Correct a couple of NPEs in the JNDI Realm that could be triggered with when not specifying a roleBase and enabling roleSearchAsUser. (markt)
> > | Remove the unnecessary registration of context.xml as a redeploy resource. The context.xml having an external docBase has already been registered as a redeploy resources at first. (kfujino)
> > | Improve the previous fix for 56401. Avoid logging version information in the constructor since it then gets logged at undesirable times such as when using `StoreConfig`. (markt)
> > | 57105: When parsing web.xml do not limit the buffer element of the jsp-property-group element to integer values as the allowed values are `<number>kb` or `none`. (markt)
> > | Update the minimum required version of the Tomcat Native library (if used) to 1.1.32. (markt)
> > | 57144: Improve ClientAbortException to provide non-null message. (kkolinko)
> > | AsyncContext should remain usable until fireOnComplete is called. (remm)
> > | AsyncContext createListener should wrap any instantiation exception using a ServletException. (remm)

> Coyote

> > | 53952: Add support for TLSv1.1 and TLSv1.2 for APR connector. Based upon a patch by Marcel Šebek. This feature requires Tomcat Native library 1.1.32 or later. (schultz/jfclere)
> > | Disable SSLv3 by default for JSSE based HTTPS connectors (BIO and NIO). The change also ensures that SSLv2 is disabled for these connectors although SSLv2 should already be disabled by default by the JRE. (markt)
> > | Disable SSLv3 by default for the APR/native HTTPS connector. (markt)
> > | Do not increase remaining counter at end of stream in IdentityInputFilter. (kkolinko)
> > | Async state MUST_COMPLETE should still be started. (remm)

> Jasper

> > | 57099: Ensure that semi-colons are not permitted in JSP import page directives. (markt)

> Cluster

> > | Avoid possible integer overflows reported by Coverity Scan. (fschumacher)

> WebSocket

> > | 57054: Correctly handle the case in the WebSocket client when the HTTP response to the upgrade request can not be read in a single pass; either because the buffer is too small or the server sent the response in multiple packets. (markt)
> > | Fix client subprotocol handling. (remm)
> > | Add null checks for arguments in remote endpoint. (remm/kkolinko)
> > | 57091: Work around the behaviour of the Oracle JRE when creating new threads in an applet environment that breaks the WebSocket client implementation. Patch provided by Niklas Hallqvist. (markt)
> > | 57118: Ensure that that an `EncodeException` is thrown by `RemoteEndpoint.Basic.sendObject(Object)` rather than an `IOException` when no suitable `Encoder` is configured for the given Object. (markt)

> Web applications

> > | Correct documentation for `ServerCookie.ALLOW_NAME_ONLY` system property. (kkolinko)
> > | 57049: Clarified that `jvmRoute` can be set in `<Engine>`'s `jvmRoute` or in a system property. (schultz)
> > | Correct version of Java WebSocket mentioned in documentation (s/1.0/1.1/). (markt/kkolinko)
> > | In examples web application move Async and Comet examples from JSP to Servlet examples page. (kkolinko)
> > | Suppress timestamp comments and enable charset header in Javadoc. (kkolinko)

> jdbc-pool

> > | 57079: Use Tomcat version number for jdbc-pool module when building and shipping the module as part of Tomcat. (markt/kkolinko)
> > | Fix broken overview page in javadoc generated via "javadoc" task in jdbc-pool build.xml file. (kkolinko)

> Other

> > | 56079: The Apache Tomcat Windows service and the Apache Tomcat Windows service monitor application are now digitally signed. (markt)
> > | Fix timestamps in Tomcat build and jdbc-pool to use 24-hour format instead of 12-hour one and use UTC timezone. (markt/kkolinko)
> > | Improve Tomcat build script to ensure that only one ecj-nn.jar file is present in Tomcat `lib` directory when Eclipse JDT Compiler is updated to a new version. (kkolinko)
> > | 56596: Update to Tomcat Native Library version 1.1.32 to pick up the Windows binaries that are based on OpenSSL 1.0.1j and APR 1.5.1. (markt)
> > | In Tomcat tests: log name of the current test method at start time. (kkolinko)

Tomcat 7.0.56 (violetagg) | released 2014-10-06

> Catalina

> > | When scanning class files (e.g. for annotations) and reading the number of parameters in a `MethodParameters` structure only read a single byte (rather than two bytes) as per the JVM specification. Patch provided by Francesco Komauli. (markt)
> > | Allow the JNDI Realm to start even if the directory is not available. The directory not being available is not fatal once the Realm is started and it need not be fatal when the Realm starts. Based on a patch by Cédric Couralet. (markt)
> > | 56736: Avoid an incorrect `IllegalStateException` if the async timeout fires after a non-container thread has called `AsyncContext.dispatch()` but before a container thread starts processing the dispatch. (markt)
> > | 56739: If an application handles an error on an application thread during asynchronous processing by calling `HttpServletResponse.sendError()`, then ensure that the application is given an opportunity to report that error via an appropriate application defined error page if one is configured. (markt)
> > | 56771: When lookup for a resource in all the alternate or backup `javax.naming.directory.DirContext`, `javax.naming.NameNotFoundException` will be thrown at the end of the search if the resource is not available in these alternate or backup `javax.naming.directory.DirContext`. Based on a patch by Sheldon Shao. (violetagg)
> > | 56796: Remove unnecessary sleep when stopping a web application. (markt)
> > | 56801: Improve performance of `org.apache.tomcat.util.file.Matcher` which is to filter JARs for scanning during web application start. Based on a patch by Sheldon Shao. (kkolinko)
> > | 56825: Enable pre-emptive authentication to work with the SSL authenticator. Based on a patch by jlmonteiro. (markt)
> > | 56857: Fix thread safety issue when calling ServletContext methods while running under a security manager. (markt)
> > | 56882: Add testcase for processing of forwards and includes when Context have been reloaded. (kkolinko)
> > | 56900: Fix some potential resource leaks when reading property files reported by Coverity Scan. Based on patches provided by Felix Schumacher. (markt)
> > | 56902: Fix a potential resource leak in the Default Servlet reported by Coverity Scan. Based on a patch provided by Felix Schumacher. (markt)
> > | 56903: Correct the return value for `StandardContext.getResourceOnlyServlets()` so that multiple names are separated by commas. Identified by Coverity Scan and fixed based on a patch by Felix Schumacher. (markt)
> > | Fixed the multipart elements merge operation performed during web application deployment. Identified by Coverity Scan. (violetagg)
> > | Correct the information written by `ExtendedAccessLogValve` when a format token x-O(XXX) is used so that multiple values for a header XXX are separated by commas. Identified by Coverity Scan. (violetagg)
> > | Fix a potential resource leak when reading MANIFEST.MF file for extension dependencies reported by Coverity Scan. (violetagg)
> > | Correctly handle multiple `accept-language` headers rather than just using the first header to determine the user's preferred Locale. (markt)
> > | Fix some potential resource leaks when reading properties, files and other resources. Reported by Coverity Scan. (violetagg)
> > | When using parallel deployment and `undeployOldVersions` feature is enabled on a Host, correctly undeploy context of old version. Make sure that Tomcat does not undeploy older Context if current context is not running. (kfujino)
> > | When deploying war, add XML file in the config base to the redeploy resources if war does not have META-INF/context.xml or `deployXML` is false. If XML file is created in the config base, redeploy will occur. (kfujino)
> > | Various changes to reduce unnecessary code in Tomcat's copy of Apache Commons BCEL to reduce the time taken for annotation scanning when web applications start. Includes contributions from kkolinko and hzhang9. (markt)
> > | 56938: Ensure web applications that have mixed case context paths and are deployed as directories are correctly removed on undeploy when running on a case sensitive file system. (markt)
> > | 57004: Add `stuckThreadCount` property to `StuckThreadDetectionValve`'s JMX bean. Patch provided by Jiří Pejchal. (schultz)
> > | 57011: Ensure that the request and response are correctly recycled when processing errors during async processing. (markt)
> > | 57016: When using the `PersistentValve` do not remove sessions from the store when persisting them. (markt)

> Coyote

> > | 56780: Enable Tomcat to start when using SSL with an IBM JRE in strict SP800-131a mode. (markt)
> > | 56910: Prevent the invalid value of `-1` being used for `maxConnections` with APR connectors. (markt)
> > | Ensure that `AjpNioProtocol` and `AjpAprProtocol` enable the `KeepAliveTimeout`. (kfujino)

> Jasper

> > | 43001: Enable the JspC Ant task to set the JspC option `mappedFile`. (kkolinko)
> > | 56797: When matching a method in an EL expression, do not treat bridge methods as duplicates of the method they bridge to. In this case always call the target of the bridge method. (markt)
> > | Correct a logic error in the `JasperElResolver`. There was no functional impact but the code was less efficient as a result of the error. Based on a patch by martinschaef. (markt)
> > | Ensure that the implementation of `javax.servlet.jsp.PageContext.include(String)` and `javax.servlet.jsp.PageContext.include(String, boolean)` will throw `IOException` when an I/O error occur during the operation. (violetagg)
> > | 56908: Fix some potential resource leaks when reading jar files. Reported by Coverity Scan. Based on patch provided by Felix Schumacher. (violetagg)
> > | 56991: Deprecate the use of a request attribute to pass a <jsp-file> declaration to Jasper and prevent an infinite loop if this technique is used in conjunction with an include. (markt)
> > | Fix a potential resource leak in JDTCompiler when checking whether a resource is a package. Reported by Coverity Scan. (fschumacher)

> WebSocket

> > | 56446: Clearer handling of exceptions when calling a method on a POJO based WebSocket endpoint. Based on a suggestion by Eugene Chung. (markt)
> > | 56746: Allow secure WebSocket client threads to use the current context class loader rather than explicitly setting it to the class loader that loaded the WebSocket implementation. This allows WebSocket client connections from within web applications to access, amongst other things, the JNDI resources associated with the web application. (markt)
> > | 56905: Make destruction on web application stop of thread group used for WebSocket connections more robust. (kkolinko/markt)
> > | 56907: Ensure that client IO threads are stopped if a secure WebSocket client connection fails. (markt)
> > | When a WebSocket client attempts to write to a closed connection, handle the resulting `IllegalStateException` in a manner consistent with the handling of an `IOException`. (markt)
> > | Add support for the `permessage-deflate` extension. This is currently limited to decompressing incoming messages on the server side. It is expected that support will be extended to outgoing messages and to the client side shortly. (markt)
> > | Extend support for the `permessage-deflate` extension to compression of outgoing messages on the server side. (markt)
> > | 56982: Return the actual negotiated extensions rather than an empty list for `Session.getNegotiatedExtensions()`. (markt)
> > | Update the WebSocket implementation to support the Java WebSocket specification version 1.1. (markt)

> Web applications

> > | Correct the label in the list of sessions by idle time for the bin that represents the idle time immediately below the maximum permitted idle time when using the expire command of the Manager application. (markt)
> > | Update the Windows authentication documentation after some additional testing to answer the remaining questions. (markt)
> > | Correct a couple of broken links in the Javadoc. (markt)

> Other

> > | 56788: Display the full version in the list of installed applications when installed via the Windows installer package. Patch provided by Alexandre Garnier. (markt)
> > | 56829: Add the ability for users to define their own values for `_RUNJAVA` and `_RUNJDB` environment variables. Be more strict with executable filename on Windows (s/java/java.exe/). Based on a patch by Neeme Praks. (markt/kkolinko)
> > | 56895: Correctly compose `JAVA_OPTS` in `catalina.bat` so that escape sequences are preserved. Patch by Lucas Theisen. (markt)
> > | 56988: Allow to use relative path in `base.path` setting when building Tomcat. (kkolinko)
> > | 56990: Ensure that the `ide-eclipse` build target downloads all the libraries required by the default Eclipse configuration files and configures Eclipse to use Java 6 for the project. Add build target `ide-eclipse-websocket` that creates a separate linked project that compiles websocket classes of Tomcat 7 with Java 7 compiler. (kkolinko)

Tomcat 7.0.55 (violetagg) | released 2014-07-27

> Catalina

> > | 44312: Log an error if there is a conflict between Host and Alias names. Improve host management methods in `Mapper` to avoid occasionally removing a wrong host. Check that host management operations are performed on the host and not on an alias. (kkolinko)
> > | 55282: Ensure that one and the same application listener is added only once when starting the web application. (violetagg)
> > | 56461: New `failCtxIfServletStartFails` attribute on Context and Host configuration to force the context startup to fail if a load-on-startup servlet fails its startup. (slaurent)
> > | 56526: Improved the `StuckThreadDetectionValve` to optionally interrupt stuck threads to attempt to unblock them. (slaurent)
> > | 56545: Pre-load an additional class, the loading of which may otherwise be triggered by a web application which in turn would trigger an exception when running under a security manager. (kkolinko)
> > | 56578: Correct regression in the fix for 56339 that prevented sessions from expiring when using clustering. (markt)
> > | 56588: Update deprecation of Context.addApplicationListener() methods according to changes in Tomcat 8. (kkolinko)
> > | 56600: In WebdavServlet: Do not waste time generating response for broken PROPFIND request. (kkolinko)
> > | Provide a better error message when asynchronous operations are not supported by a filter or servlet. Patch provided by Romain Manni-Bucau. (violetagg)
> > | 56606: User entries in `tomcat-users.xml` file are recommended to use "username" attribute rather than legacy "name" attribute. Fix inconsistencies in Windows installer, examples. Update digester rules and documentation for `MemoryRealm`. (markt/kkolinko)
> > | 56611: Refactor code to remove inefficient calls to `Method.isAnnotationPresent()`. Based on a patch by Jian Mou. (markt/kkolinko)
> > | 56653: Fix concurrency issue with lists of contexts in `Mapper` when stopping Contexts. (kkolinko)
> > | 56657: When using parallel deployment, if the same session id matches different versions of a web application, prefer the latest version. Ensure that remapping selects the version that we expect. (kkolinko)
> > | Assert that mapping result object is empty before performing mapping work in `Mapper`. (kkolinko)
> > | 56658: Avoid delay between registrations of mappings for context and for its servlets. (kkolinko)
> > | 56665: Correct the generation of the effective web.xml when elements contain an empty string as value. (violetagg)
> > | 56666: When clearing the SSO cookie use the same values for domain, path, httpOnly and secure as were used to set the SSO cookie. (markt)
> > | 56677: Ensure that `HttpServletRequest.getServletContext()` returns the correct value during a cross-context dispatch. (markt)
> > | 56684: Ensure that Tomcat does not shut down if the socket waiting for the shutdown command experiences a `SocketTimeoutException`. (markt)
> > | When the current PathInfo is modified as a result of dispatching a request, ensure that a call to `HttpServletRequest.getPathTranslated()` returns a value that is based on the modified PathInfo. (markt)
> > | 56698: When persisting idle sessions, only persist newly idle sessions. Patch provided by Felix Schumacher. (markt)
> > | 56710: Do not map requests to servlets when context is being reloaded. (kkolinko)
> > | 56712: Fix session idle time calculations in `PersistenceManager`. (kkolinko)
> > | 56717: Fix duplicate registration of `MapperListener` during repeated starts of embedded Tomcat. (kkolinko)
> > | 56724: Write an error message to Tomcat logs if container background thread is aborted unexpectedly. (kkolinko)

> Coyote

> > | 56518: When using NIO, do not attempt to write to the socket if the thread is marked interrupted as this will lead to a connection limit leak. This fix was based on analysis of the issue by hanyong. (markt)
> > | 56521: Re-use the asynchronous write buffer between writes to reduce allocation and GC overhead. Based on a patch by leonzhx. Also make the buffer size configurable and remove copying of data within buffer when the buffer is only partially written on a subsequent write. (markt)
> > | Correct a copy/paste error and return a 500 response rather than a 400 response when an internal server error occurs on early stages of request processing. (markt)
> > | 56582: Use switch(actionCode) in processors instead of a chain of "elseif"s. (kkolinko)
> > | Fix CVE-2014-0227: Various improvements to ChunkedInputFilter including clean-up, i18n for error messages and adding an error flag to allow subsequent attempts at reading after an error to fail fast. (markt)
> > | If request contains an unrecognized Expect header, respond with error 417 (Expectation Failed), according to RFC2616 chapter 14.20. (markt)
> > | When an error occurs after the response has been committed close the connection immediately rather than attempting to finish the response to make it easier for the client to differentiate between a complete response and one that failed part way though. (markt)
> > | 56620: Avoid bogus access log entries when pausing the NIO HTTP connector and ensure that access log entries generated by error conditions use the correct request start time. (markt)
> > | Fix CVE-2014-0230: Add a new limit, defaulting to 2MB, for the amount of data Tomcat will swallow for an aborted upload. The limit is configurable by `maxSwallowSize` attribute of an HTTP connector. (markt)
> > | Allow to configure `maxSwallowSize` attribute of an HTTP connector via JMX. (kkolinko)
> > | 56661: Fix `getLocalAddr()` for AJP connectors. The complete fix is only available with a recent AJP forwarder like the forthcoming mod_jk 1.2.41. (rjung)

> Jasper

> > | 56334#c15: Fix a regression in EL parsing when quoted string follows a whitespace. (kkolinko/markt)
> > | 56543: Update to the Eclipse JDT Compiler 4.4. (violetagg)
> > | 56561: Avoid `NoSuchElementException` while handling attributes with empty string value. (violetagg)
> > | 56581: If an error on a JSP page occurs when response has already been committed, do not clear the buffer of JspWriter, but flush it. It will make more clear where the error occurred. (kkolinko)
> > | 56612: Correctly parse two consecutive escaped single quotes when used in UEL expression in a JSP. (markt)
> > | Move code that parses EL expressions within JSP template text from `Parser` to `JspReader` class for better performance. (kkolinko)

> WebSocket

> > | 56577: Improve the executor configuration used for the callbacks associated with asynchronous writes. (markt)

> Web applications

> > | Set the path for cookies created by the examples web application so they only returned to the examples application. This reduces the opportunity for using such cookies for malicious purposes should the advice to remove the examples web application from security sensitive systems be ignored. (markt/kkolinko)
> > | Attempt to obfuscate session cookie values associated with other web applications when viewing HTTP request headers with the Request Header example from the examples web application. This reduces the opportunity to use this example for malicious purposes should the advice to remove the examples web application from security sensitive systems be ignored. (markt)

> Other

> > | Update optional Checkstyle library to 5.7. (kkolinko)
> > | 56685: Add quotes necessary for `daemon.sh` to work correctly on Solaris. Based on a suggestion by lfuka. (markt)
> > | 56596: Update to Tomcat Native Library version 1.1.31 to pick up the Windows binaries that are based on OpenSSL 1.0.1h. (markt)

Tomcat 7.0.54 (violetagg) | released 2014-05-22

> Catalina

> > | Fix custom UTF-8 decoder so that a byte of value 0xC1 is always rejected immediately as it is never valid in a UTF-8 byte sequence. Update UTF-8 decoder tests to account for UTF-8 decoding improvements in Java 8. The custom UTF-8 decoder is still required due to bugs in the UTF-8 decoder provided by Java. Java 8's decoder is better than Java 7's but it is still buggy. (markt)
> > | 56027: Add more options for managing FIPS mode in the AprLifecycleListener. (schultz/kkolinko)
> > | 56321: When a WAR is modified, undeploy the web application before deleting any expanded directory as the undeploy process may refer to classes that need to be loaded from the expanded directory. If the expanded directory is deleted first, any attempt to load a new class during undeploy will fail. (markt)
> > | 56339: Avoid an infinite loop if an application calls `session.invalidate()` from the session destroyed event for that session. (markt)
> > | 56365: Simplify file name pattern matching code in `StandardJarScanner`. Ignore leading and trailing whitespace and empty strings when configuring patterns. Improve documentation. (kkolinko)
> > | 56369: Ensure that removing an MBean notification listener reverts all the operations performed when adding an MBean notification listener. (markt)
> > | 56382: Information about finished deployment and its execution time is added to the log files. Patch is provided by Danila Galimov. (violetagg)
> > | 56383: Properties for disabling server information and error report are added to the `org.apache.catalina.valves.ErrorReportValve`. Based on the patch provided by Nick Bunn. (violetagg/kkolinko)
> > | Fix CVE-2014-0119: Only create XML parsing objects if required and fix associated potential memory leak in the default Servlet. Extend XML factory, parser etc. memory leak protection to cover some additional locations where, theoretically, a memory leak could occur. Ensure that a TLD parser obtained from the cache has the correct value of `blockExternal`. (markt)
> > | Modify generic exception handling so that `StackOverflowError` is not treated as a fatal error and can handled and/or logged as required. (markt)
> > | 56409: Avoid `StackOverflowError` on non-Windows systems if a file named `\` is encountered when scanning for TLDs. (markt)
> > | 56430: Extend checks for suspicious URL patterns to include patterns of the form `*.a.b` which are not valid patterns for extension mappings. (markt)
> > | 56441: Raise the visibility of exceptions thrown when a problem is encountered calling a getter or setter on a component attribute. The logging level is raised from debug to warning. (markt)
> > | 56451: Make resources accessed via a context alias accessible via JNDI in the same way standard resources are available. (markt)
> > | 56463: Property for disabling server information is added to the `DefaultServlet`. Server information is presented in the response sent to the client when directory listings is enabled. (violetagg)
> > | Add the `org.apache.naming` package to the packages requiring code to have the `defineClassInPackage` permission when running under a security manager. (markt)
> > | Add the `org.apache.naming.resources` package to the packages requiring code to have the `accessClassInPackage` permission when running under a security manager. (markt)
> > | Make the naming context tokens for containers more robust. Require RuntimePermission when introducing a new token. (markt/kkolinko)
> > | 56472: Allow NamingContextListener to clean up on stop if its start failed. (kkolinko)
> > | 56492: Avoid eclipse debugger pausing on uncaught exceptions when tomcat renews its threads. (slaurent)
> > | Minor fixes to `ThreadLocalLeakPreventionListener`. Do not trigger threads renewal for failed contexts. Do not ignore `threadRenewalDelay` setting. Improve documentation. (kkolinko)
> > | Correct regression introduced in r797162 that broke authentication of users when using the `JAASMemoryLoginModule`. (markt)
> > | 56501: `HttpServletRequest.getContextPath()` should return the undecoded context path used by the user agent. (markt)
> > | 56523: When using SPNEGO authentication, log the exceptions associated with failed user logins at debug level rather than error level. (markt)
> > | 56536: Ensure that `HttpSessionBindingListener.valueUnbound()` uses the correct class loader when the `SingleSignOn` valve is used. (markt)

> Coyote

> > | 56399: Assert that both Coyote and Catalina request objects have been properly recycled. (kkolinko)
> > | 56416: Correct documentation for default value of socket linger for the AJP and HTTP connectors. (markt)

> Jasper

> > | 56334: Fix a regression in the handling of back-slash escaping introduced by the fix for 55735. (markt/kkolinko)
> > | 56425: Improve method matching for EL expressions. When looking for matching methods, an exact match between parameter types is preferred followed by an assignable match followed by a coercible match. (markt)
> > | Correct the handling of back-slash escaping in the EL parser and no longer require that `\$` or `\#` must be followed by `{` in order for the back-slash escaping to take effect. (markt)
> > | 56529: Avoid `NoSuchElementException` while handling attributes with empty string value in custom tags. Patch provided by Hariprasad Manchi. (violetagg)

> Cluster

> > | Remove cluster and replicationValve from cluster manager template. These instance are not necessary to template. (kfujino)
> > | Add support for cross context session replication to `org.apache.catalina.ha.session.BackupManager`. (kfujino)
> > | Remove the unnecessary cross context check. It does not matter whether the context that is referenced by other context is set to `crossContext`=true. The context that refers to the different context must be set to `crossContext`=true. (kfujino)
> > | Move to `org.apache.catalina.ha.session.ClusterManagerBase` common logics of `org.apache.catalina.ha.session.BackupManager` and `org.apache.catalina.ha.session.DeltaManager`. (kfujino)
> > | Simplify the code of `o.a.c.ha.tcp.SimpleTcpCluster`. In order to add or remove cluster valve to Container, use pipeline instead of `IntrospectionUtils`. (kfujino)
> > | There is no need to set cluster instance when `SimpleTcpCluster.unregisterClusterValve` is called. Set null than cluster instance for cleanup. (kfujino)
> > | Backport refactoring of `AbstractReplicatedMap` to implement `Map` rather than extend `ConcurrentHashMap` to enable Tomcat 7 to be built with Java 8. (markt)

> WebSocket

> > | 56343: Avoid a NPE if Tomcat's Java WebSocket 1.0 implementation is used with the Java WebSocket 1.0 API JAR from the reference implementation. (markt)
> > | Increase the default maximum size of the executor used by the WebSocket implementation for call backs associated with asynchronous writes from 10 to 200. (markt)
> > | Add a warning if the thread group created for WebSocket asynchronous write call backs can not be destroyed when the web application is stopped. (markt)
> > | Ensure that threads created to support WebSocket clients are stopped when no longer required. This will happen automatically for WebSocket client connections initiated by web applications but stand alone clients must call `WsWebSocketContainer.destroy()`. (markt)
> > | 56449: When creating a new session, add the message handlers to the session before calling `Endpoint.onOpen()` so the message handlers are in place should the `onOpen()` method trigger the sending of any messages. (markt)
> > | 56458: Report WebSocket sessions that are created over secure connections as secure rather than as not secure. (markt)
> > | Stop threads used for secure WebSocket client connections when they are no longer required and give them better names for easier debugging while they are running. (markt)

> Web applications

> > | Add Support for `copyXML` attribute of Host to Host Manager. (kfujino)
> > | Ensure that "name" request parameter is used as a application base of host if "webapps" request parameter is not set when adding host in HostManager Application. (kfujino)
> > | Correct documentation on Windows service options, aligning it with Apache Commons Daemon documentation. (kkolinko)
> > | 55215: Improve log4j configuration example. Clarify access logging documentation. Based on patches provided by Brian Burch. (kkolinko)
> > | 55383: Backport improved HTML markup for tables and code fragments from Tomcat 8 documentation. (kkolinko)
> > | 56418: Ensure that the Manager web application does not report success for a web application deployment that fails. (slaurent)
> > | Fix target and rel attributes on links in documentation. They were lost during XSLT transformation. (kkolinko)
> > | Improve valves documentation. Split valves into groups. (kkolinko)

> Other

> > | Align DisplayName of Tomcat installed by `service.bat` with one installed by the *.exe installer. Print a warning in case if neither server nor client jvm is found by `service.bat`. (kkolinko)
> > | 56363: Update to version 1.1.30 of Tomcat Native library. (schultz)
> > | Update package renamed Apache Commons BCEL to r1593495 to pick up some additional changes for Java 7 support and some code clean up. (markt)
> > | In tests: allow to configure directory where JUnit reports and access log are written to. (kkolinko)

Tomcat 7.0.53 (violetagg) | released 2014-03-30

> Catalina

> > | Make it easier for applications embedding and/or extending Tomcat to modify the `javaseClassLoader` attribute of the `WebappClassLoader`. (markt)
> > | Improve the robustness of web application undeployment based on some code analysis triggered by the report for 54315. (markt)
> > | 56219: Improve merging process for web.xml files to take account of the elements and attributes supported by the Servlet version of the merged file. (markt)
> > | 56190: The response should be closed (i.e. no further output is permitted) when a call to `AsyncContext.complete()` takes effect. (markt)
> > | 56236: Enable Tomcat to work with alternative Servlet and JSP API JARs that package the XML schemas in such as way as to require a dependency on the JSP API before enabling validation for web.xml. Tomcat has no such dependency. (markt)
> > | 56246: Fix NullPointerException in MemoryRealm when authenticating an unknown user. (markt)
> > | 56248: Allow the deployer to update an existing WAR file without undeploying the existing application if the update flag is set. This allows any existing custom context.xml for the application to be retained. To update an application and remove any existing context.xml simply undeploy the old version of the application before deploying the new version. (markt)
> > | Fix CVE-2014-0096: Redefine the `globalXsltFile` initialisation parameter of the DefaultServlet as relative to CATALINA_BASE/conf or CATALINA_HOME/conf. Prevent user supplied XSLTs used by the DefaultServlet from defining external entities. (markt)
> > | Add a work around for validating XML documents (often TLDs) that use just the file name to refer to refer to the JavaEE schema on which they are based. (markt)
> > | 56293: Cache resources loaded by the class loader from `/META-INF/services/` for better performance for repeated look ups. (markt)

> Coyote

> > | 53119: Make sure the NIO AJP output buffer is cleared on any error to prevent any possible overflow if it is written to again before the connection is closed. This extends the original fix for the APR/native output buffer to the NIO connector. (kkolinko)
> > | 56172: Avoid possible request corruption when using the AJP NIO connector and a request is sent using more than one AJP message. Patch provided by Amund Elstad. (markt)
> > | 56213: Reduce garbage collection when the NIO connector is under heavy load. (markt)
> > | Fix CVE-2014-0075: Improve processing of chuck size from chunked headers. Avoid overflow and use a bit shift instead of a multiplication as it is marginally faster. (markt/kkolinko)
> > | Fix CVE-2014-0099: Fix possible overflow when parsing long values from a byte array. (markt)

> Jasper

> > | 54475: Add Java 8 support to SMAP generation for JSPs. Patch by Robbie Gibson. (markt)
> > | 55483: Improve handing of overloaded methods and constructors in expression language implementation. (markt)
> > | 56208: Restore the validateXml option to Jasper that was previously renamed validateTld. Both options are now supported. validateXml controls the validation of web.xml files when Jasper parses them and validateTld controls the validation of *.tld files when Jasper parses them. (markt)
> > | 56223: Throw an `IllegalStateException` if a call is made to `ServletContext.setInitParameter()` after the ServletContext has been initialized. (markt)
> > | 56265: Do not escape values of dynamic tag attributes containing EL expressions. (kkolinko)
> > | Make the default compiler source and target versions for JSPs Java 6 since Tomcat 7 requires Java 6 as a minimum. (markt)
> > | 56283: Update to the Eclipse JDT Compiler P20140317-1600 which adds support for Java 8 syntax to JSPs. Add support for value "1.8" for the `compilerSourceVM` and `compilerTargetVM` options. (markt)

> WebSocket

> > | Avoid a possible deadlock when one thread is shutting down a connection while another thread is trying to write to it. (markt)
> > | Call onError if an exception is thrown calling onClose when closing a session. (remm)

> Web applications

> > | In the documentation: add support for several documentation tags from Tomcat 8. Such as `<version-major/>`. (kkolinko)
> > | 56093: Add the SSL Valve to the documentation web application. (markt)
> > | 56217: Improve readability by using left alignment for the table cell containing the request information on the Manager application status page. (markt)
> > | Fixed `java.lang.NegativeArraySizeException` when using "Expire sessions" command in the manager web application on a context where the session timeout is disabled. (kfujino)
> > | Add support for `LAST_ACCESS_AT_START` system property to Manager web application. (kfujino)
> > | Add definition of `org.apache.catalina.ant.FindLeaksTask`. (kfujino)
> > | 56273: If the Manager web application does not perform an operation because the web application is already being serviced, report an error rather than reporting success. (markt)
> > | 56304: Add a note to the documentation about not using WebSocket with BIO HTTP in production. (markt)

> Other

> > | 56143: Improve `service.bat` so that it can be launched from a non-UAC console. This includes using a single call to `tomcat7.exe` to install the Windows service rather than three calls, and using command line arguments instead of environment variables to pass the settings. (markt/kkolinko)
> > | Fix regression in 7.0.52: when using `service.bat install` to install the service the values for --StdOutput, --StdError options were passed as blank instead of "auto". (kkolinko)

> > Align options between `service.bat` and `exe` Windows installer. For `service.bat` the changes are in --Classpath, --DisplayName, --StartPath, --StopPath. For `exe` installer the changes are in --JvmMs, --JvmMx options, which are now 128 Mb and 256 Mb respectively instead of being empty. Explicitly specify --LogPath path when uninstalling Windows service, avoiding default value for that option. (kkolinko)

> > | Simplify Windows *.bat files: remove %OS% checks, as java 6 does not run on ancient non-NT operating systems. (kkolinko)
> > | 56137: Explicitly use the BIO connector in the SSL example in server.xml so it doesn't break if APR is enabled. (markt)
> > | 56139: Avoid a web application class loader leak in some unit tests when running on Windows. (markt)
> > | Correct build script to avoid building JARs with empty packages. (markt)
> > | Allow to limit JUnit test run to a number of selected test case methods. (kkolinko)
> > | 56189: Remove used file cpappend.bat from the distribution. (markt)

Tomcat 7.0.52 (violetagg) | released 2014-02-17

> Catalina

> > | Generate a valid root element for the effective web.xml for a web application for all supported versions of web.xml. (markt)

> Coyote

> > | Pull up `SocketWrapper` to `AbstractProcessor`. (markt)
> > | In some circumstances asynchronous requests could time out too soon. (markt)

Tomcat 7.0.51 (violetagg) | not released

> Catalina

> > | 55287: `ServletContainerInitializer` defined in the container may not be found. (markt/jboynes)
> > | 55855: Provide a per Context option (containerSciFilter) to exclude container SCIs. (markt)
> > | 55937: When deploying applications, treat a context path of `/ROOT` as equivalent to `/`. (markt)

> > 55943: Improve the implementation of the class loader check that prevents web applications from trying to override J2SE implementation classes. As part of this fix, refactor the way a null parent class loader is handled which enables a number of null checks and object creation calls to be removed. Note that this change means that, by default, the web application class loader is now a higher priority for loading classes than the system class loader. (markt)

> > | 55958: Differentiate between `foo.war` the WAR file and `foo.war` the directory. (markt)
> > | 55960: Improve the single sign on (SSO) unit tests. Patch provided by Brian Burch. (markt)
> > | 55974: Retain order when reporting errors and warnings while parsing XML configuration files. (markt)
> > | 56013: Fix issue with SPNEGO authentication when using IBM JREs. IBM JREs only understand the option of infinite lifetime for Kerberos credentials. Based on a patch provided by Arunav Sanyal. (markt)
> > | 56016: When loading resources for XML schema validation, take account of the possibility that servlet-api.jar and jsp-api.jar may not be loaded by the same class loader. Patch by Juan Carlos Estibariz. (markt)
> > | 56025: When creating a WebSocket connection, always call `ServerEndpointConfig.Configurator.getNegotiatedSubprotocol()` and always create the EndPoint instance after calling `ServerEndpointConfig.Configurator.modifyHandshake()`. (markt)
> > | 56032: Ensure that the WebSocket connection is closed after an IO error or an interrupt while sending a WebSocket message. (markt)
> > | 56042: If a request in async mode has an error but has already been dispatched don't generate an error page in the ErrorReportValve so the dispatch target can handle it. (markt)
> > | Add missing `javax.annotation.sql.*` classes to annotations-api.jar. (markt)
> > | The type of logger attribute of Context MBean should be not `org.apache.commons.logging.Log` but `org.apache.juli.logging.Log`. (kfujino)
> > | 56082: Fix a concurrency bug in JULI's LogManager implementation. (markt)
> > | 56096: When the attribute `rmiBindAddress` of the JMX Remote Lifecycle Listener is specified it's value will be used when constructing the address of a JMX API connector server. Patch is provided by Jim Talbut. (violetagg)
> > | When environment entry with one and the same name is defined in the web deployment descriptor and with annotation then the one specified in the web deployment descriptor is with priority. (violetagg)
> > | Change default value of `xmlBlockExternal` attribute of Context. It is `true` now. (kkolinko)

> Coyote

> > | Avoid possible NPE if a content type is specified without a character set. (markt)
> > | 55956: Make the forwarded remote IP address available to the Connectors via a request attribute. (markt)
> > | 55976: Fix sendfile support for the HTTP NIO connector. (markt)
> > | 55996: Ensure Async requests timeout correctly when using the NIO HTTP connector. (markt)
> > | 56021: Make it possible to use the Windows-MY key store with the BIO and NIO connectors for SSL configuration. It requires a `keystoreFile="" keystoreType="Windows-My"` to be set on the connector. Based on a patch provided by Asanka. (markt)

> Jasper

> > | Correct a regression in the XML refactoring that meant that errors in TLD files were swallowed. (markt)
> > | 55671: Correct typo in the log message for a wrong value of genStringAsCharArray init-param of JspServlet. This parameter had a different name in Tomcat 6. (kkolinko)
> > | 55973: Fix processing of XML schemas when validation is enabled in Jasper. (kkolinko)
> > | 56010: Don't throw an `IllegalArgumentException` when `JspFactory.getPageContext` is used with `JspWriter.DEFAULT_BUFFER`. Based on a patch by Eugene Chung. (markt)
> > | 56012: When using the extends attribute of the page directive do not import the super class if it is in an unnamed package as imports from unnamed packages are now explicitly illegal. (markt)
> > | 56029: A regression in the fix for 55198 meant that when EL containing a ternary expression was used in an attribute a compilation error would occur for some expressions. (markt)
> > | Correct several errors in jspxml Schema and DTD. (kkolinko)
> > | Change default value of the `blockExternal` attribute of JspC task. The default value is `true`. Add support for `-no-blockExternal` switch when JspC is run as a standalone application. (kkolinko)

> Cluster

> > | Simplify the code of `o.a.c.ha.tcp.SimpleTcpCluster.createManager(String)`. Remove unnecessary class cast. (kfujino)

> WebSocket

> > | Do not return an empty string for the `Sec-WebSocket-Protocol` HTTP header when no sub-protocol has been requested or no sub-protocol could be agreed as RFC6455 requires that no `Sec-WebSocket-Protocol` header is returned in this case. (markt)

> Web applications

> > | Add index.xhtml to the welcome files list for the examples web application. (kkolinko)
> > | Clarify that the connectionTimeout may also be used as the read timeout when reading a request body (if any) in the documentation web application. (markt)
> > | Clarify the behaviour of the maxConnections attribute for a connector in the documentation web application. (markt)
> > | 55888: Update the documentation web application to make it clearer that a Container may define no more than one Realm. (markt)
> > | 55956: Where available, displayed the forwarded remote IP address available on the status page of the Manager web application. (markt)
> > | Correct links to the Tomcat mailing lists in the ROOT web application. (kkolinko)
> > | In Manager web application improve handling of file upload errors. Display a message instead of error 500 page. Simplify parts handling code, as it is known that Tomcat takes care of them when recycling a request. (kkolinko)

> Extras

> > | 55166, 56045: Copy the XML schemas used for validation that are packaged in jsp-api.jar to servlet-api.jar so that an embedded Tomcat instance can start without Jasper being available. This also enables validation to work without Jasper being available. (markt/kkolinko)
> > | 56039: Enable the JmxRemoteLifecycleListener to work over SSL. Patch by esengstrom. (markt)

> Other

> > | 55743: Enable the stop script to work when the shutdown port is disabled and a PID file is defined. This is only available on platforms that use `catalina.sh`. (markt)
> > | 55986: When forcing Tomcat to stop via `kill -9 $CATALINA_PID`, the `catalina.sh` script could incorrectly report that Tomcat had not yet completely stopped when it had. Based on a patch by jess. (markt)
> > | Package correct license and notice files with embedded JARs. (markt)
> > | Remove svn keywords (such as $Id) from source files and documentation. (kkolinko)
> > | Fix CVE-2014-0050, a denial of service with a malicious, malformed Content-Type header and multipart request processing. Fixed by merging latest code (r1565163) from Commons FileUpload. (markt)
> > | 56115: Expose the `httpusecaches` property of Ant's `get` task as some users may need to change the default. Based on a suggestion by Anthony. (markt)

Tomcat 7.0.50 (violetagg) | released 2014-01-08

> Catalina

> > | Handle the case where a `context.xml` file is added to a web application deployed from a directory. Previously the file was ignored until Tomcat was restarted. Now (assuming automatic deployment is enabled) it will trigger a redeploy of the web application. (markt)
> > | Fix string comparison in `HostConfig.setContextClass()`. (kkolinko)
> > | Streamline handling of WebSocket messages when no handler is configured for the message currently being received. (markt)
> > | Handle the case where a WebSocket annotation configures a message size limit larger than the default permitted by Tomcat. (markt)
> > | 55855: This is a partial fix that bypasses the relatively expensive check for a WebSocket upgrade request if no WebSocket endpoints have been registered. (markt)
> > | 55905: Prevent a NPE when web.xml references a taglib file that does not exist. Provide better error message. (violetagg)

> Coyote

> > | When using the BIO connector with an internal executor, do not display a warning that the executor has not shutdown as the default configuration for BIO connectors is not to wait. This is because threads in keep-alive connections cannot be interrupted and therefore the warning was nearly always displayed. (markt)

> Jasper

> > | JspC uses servlet context initialization parameters to pass configuration so ensure that the servlet context used supports initialization parameters. (markt)

> Cluster

> > | In `AbstractReplicatedMap#finalize`, remove rpcChannel from channel Listener of group channel before sending `MapMessage.MSG_STOP` message. This prevents that the node that sent the `MapMessage.MSG_STOP` by normal shutdown is added to member map again by ping at heartbeat thread in the node that received the `MapMessage.MSG_STOP`. (kfujino)
> > | Add time stamp to `GET_ALL_SESSIONS` message. (kfujino)

> Web applications

> > | Fix the sample configuration of `StaticMembershipInterceptor` in order to prevent warning log. uniqueId must be 16 bytes. (kfujino)

> Extras

> > | Update dependencies that are used to build tomcat-juli extras component. Apache Avalon Framework is updated to version 4.1.5, Apache Log4J to version 1.2.17. (rjung)

Tomcat 7.0.49 (violetagg) | not released

> Catalina

> > | Correct a regression in the new XML local resolver that triggered false failures when XML validation was configured. (markt)
> > | Prevent a NPE when destroying HTTP upgrade handler for WebSocket connections. (violetagg)

Tomcat 7.0.48 (violetagg) | not released

> Catalina

> > | 51294: Add support for unpacking WARs located outside of the Host's appBase in to the appBase. (markt)
> > | 55656: Configure the Digester to use the server class loader when parsing server.xml rather than the class loader that loaded StandardServer. Patch provided by Roberto Benedetti. (markt)
> > | 55664: Correctly handle JSR 356 WebSocket Encoder, Decoder and MessageHandler implementations that use a generic type such as `Encoder.Text<List<String>>`. Includes a test case by Niki Dokovski. (markt)
> > | Correctly handle WebSocket `Encoder`s, `Decoder`s and `MessageHandler`s that use arrays of generic types. (markt)
> > | 55681: Ensure that the WebSocket session is made available to `MessageHandler` method calls. (markt)
> > | Updated servlet spec version and documentation section-number reported when JAR files are rejected for containing a trigger class (e.g. javax.servlet.Servlet). (schultz)
> > | Modify the WebSocket handshake process so that the user properties `Map` exposed by the `ServerEndpointConfig` during the call to `Configurator.modifyHandshake()` is unique to the connection rather than shared by all connections associated with the Endpoint. This allows for easier configuration of per connection properties from within `modifyHandshake()`. (markt)
> > | 55684: Log a warning but continue if the memory leak detection code is unable to access all threads to check for possible memory leaks when a web application is stopped. (markt)
> > | Define the web-fragment.xml in tomcat7-websocket.jar as a Servlet 3.0 web fragment rather than as a Servlet 3.1 web fragment. (markt)
> > | 55715: Add a per web application executor to the WebSocket implementation and use it for calling `SendHandler.onResult()` when there is a chance that the current thread also initiated the write. (markt)
> > | Prevent file descriptors leak and ensure that files are closed when configuring the web application. (violetagg)
> > | Fixed the name of the provider-configuration file located in `tomcat7-websocket.jar!/META-INF/services` that exposes information for `javax.websocket.server.ServerEndpointConfig$Configurator` implementation. (violetagg)
> > | 55760: Remove the unnecessary setting of the `javax.security.auth.useSubjectCredsOnly` system property in the `SpnegoAuthenticator` as in addition to it being unnecessary, it causes problems with using SPNEGO with IBM JDKs. Patch provided by Arunav Sanyal. (markt)
> > | 55772: Ensure that the request and response are recycled after an error during asynchronous processing. Includes a test case based on code contributed by Todd West. (markt)
> > | 55778: Add an option to the JNDI Realm to control the QOP used for the connection to the LDAP server after authentication when using SPNEGO with delegated credentials. This value is used to set the `javax.security.sasl.qop` environment property for the LDAP connection. (markt)
> > | 55798: Log an error if the MemoryUserDatabase is unable to find the specified user database file. (markt)
> > | 55799: Correctly enforce the restriction in JSR356 that no more than one data message may be sent to a remote WebSocket endpoint at a time. (markt)
> > | When Catalina parses TLD files, always use a namespace aware parser to be consistent with how Jasper parses TLD files. The `tldNamespaceAware` attribute of the Context is now ignored. (markt)
> > | Deprecate the `tldNamespaceAware` Context attribute as TLDs are always parsed with a namespace aware parser. (markt)
> > | Correct a logic error that meant that unpackWARs was ignored and the WAR was always expanded if a WAR failed to deploy. (markt)
> > | Add support for defining `copyXML` on a per Context basis. (markt)
> > | Define the expected behaviour of the automatic deployment and align the implementation to that definition. (markt)
> > | When running under a security manager, change the default value of the Host's `deployXML` attribute to `false`. (markt)
> > | If a Host is configured with a value of `false` for `deployXML`, a web application has an embedded descriptor at `META-INF/context.xml` and no explicit descriptor has been defined for this application, do not allow the application to start. The reason for this is that the embedded descriptor may contain configuration necessary for secure operation such as a `RemoteAddrValve`. (markt)
> > | Prevent an NPE in the WebSocket `ServerContainer` when processing an HTTP session end event. (markt)
> > | 55801: Add the ability to set a custom `SSLContext` to use for client wss connections. Patch provided by Maciej Lypik. (markt)
> > | 55804: If the GSSCredential for the cached Principal expires when using SPNEGO authentication, force a re-authentication. (markt)
> > | 55811: If the main web.xml contains an empty absolute-ordering element and validation of web.xml is not enabled, skip parsing any web-fragment.xml files as the result is never used. (markt)
> > | 55839: Extend support for digest prefixes {MD5}, {SHA} and {SSHA} to all Realms rather than just the JNDIRealm. (markt)
> > | 55842: Ensure that if a larger than default response buffer is configured that the full buffer is used when a Servlet outputs via a Writer. (markt)
> > | 55851: Further fixes to enable SPNEGO authentication to work with IBM JDKs. Based on a patch by Arunav Sanyal. (markt)
> > | Fix CVE-2013-4590: Add an option to the Context to control the blocking of XML external entities when parsing XML configuration files and enable this blocking by default when a security manager is used. The block is implemented via a custom resolver to enable the logging of any blocked entities. (markt)

> Coyote

> > | Implement a number of small refactorings to the APR/native handler for upgraded HTTP connections. (markt)
> > | Fix an issue with upgraded HTTP connections over HTTPS (e.g. secure WebSocket) when using the APR/native connector that resulted in the unexpected closure of the connection. (markt)
> > | Ensure that the application class loader is used when calling the `ReadListener` and `WriteListener` methods when using non-blocking IO. A side effect of not doing this was that JNDI was not available when processing WebSocket events. (markt)
> > | Make the time that the internal executor (if used) waits for request processing threads to terminate before continuing with the connector stop process configurable. (markt)
> > | 55749: Improve the error message when `SSLEngine` is disabled in the `AprLifecycleListener` and SSL is configured for an APR/native connector. (markt)
> > | If a request that includes an `Expect: 100-continue` header receives anything other than a 2xx response, close the connection This protects against misbehaving clients that may not sent the request body in that case and send the next request instead. (markt)
> > | Improve the parsing of trailing headers in HTTP requests. (markt)

> Jasper

> > | 55735: Fix a regression caused by the fix to 55198. When processing JSP documents, attributes in XML elements that are template content should have their text xml-escaped, but output of EL expressions in them should not be escaped. (markt)
> > | 55807: The JSP compiler used a last modified time of -1 for TLDs in JARs expanded in to WEB-INF/classes (IDEs often do this expansion) when creating the dependency list for JSPs that used that TLD. This meant JSPs using that TLD were recompiled on every access. (markt)

> Cluster

> > | Add log message that initialization of `AbstractReplicatedMap` has been completed. (kfujino)
> > | The logger of `AbstractReplicatedMap` should be non-static in order to enable logging of each application. Side-effects of this change is to throw `RuntimeException` in `MapMessage#getKey()` and `getValue()` instead of Null return and error log. (kfujino)
> > | Simplify the code of `DeltaManager#startInternal()`. Reduce unnecessary nesting for acquisition of cluster instance. (kfujino)
> > | Remove unnecessary attributes of `stateTransferCreateSendTime` and `receiverQueue` from cluster manager template. These attributes should not be defined as a template. (kfujino)
> > | Fix MBean attribute definition of `stateTransfered`. The method name is not `isStateTransfered()` but `getStateTransfered()`. (kfujino)
> > | Correct stop failure log of cluster. Failure cause is not only Valve. (kfujino)
> > | Remove unnecessary sleep when sending session blocks on session sync phase. (kfujino)
> > | Expose `stateTimestampDrop` of `org.apache.catalina.ha.session.DeltaManager` via JMX. (kfujino)
> > | When the ping timeouted, make sure that `memberDisappeared` method is not called by specifying the members that has already been removed. (kfujino)
> > | Add log message of session relocation when member disappeared. (kfujino)
> > | If ping message fails, prevent wrong timeout detection of normal member that is no failure members. (kfujino)

> Web applications

> > | Add some documentation on the SSL configuration options for WebSocket clients. (markt)
> > | Add to cluster document a description of `notifyLifecycleListenerOnFailure` and `heartbeatBackgroundEnabled`. (kfujino)
> > | Update the documentation with information for WebSocket 1.0 specification and javadoc. (violetagg)
> > | 55703: Clarify the role of the singleton attribute for JNDI resource factories. (markt)
> > | 55746: Add documentation on the `allRolesMode` to the `CombinedRealm` and `LockOutRealm`. Patch by Cédric Couralet. (markt)
> > | Expand the information on web applications that ship as part of Tomcat in the security how-to section of the documentation web application. (markt)
> > | Expand the description of the WebSocket buffers in the documentation web application to clarify their purpose. (markt)
> > | Correct the documentation for Cluster manager. (kfujino)
> > | Add information on how to configure integrated Windows authentication when Tomcat is running on a non-Windows host. (markt)

> Extras

> > | Update commons-logging to version 1.1.3. (rjung)

> Other

> > | 52323: Add support for the Cobertura code coverage tool when running the unit tests. Based on a patch by mhasko. (markt/kkolinko)
> > | Update sample Eclipse IDE project. Explicitly use a Java 6 SE JDK. Exclude JSR356 WebSocket classes from build path, as they cannot be compiled with Java 6. (kkolinko)
> > | Update the Eclipse compiler to 4.3.1. (kkolinko/markt)

Tomcat 7.0.47 (violetagg) | released 2013-10-24

> Coyote

> > | Fix regression with legacy WebSocket implementation in NIO and APR connectors. (markt)

> Web applications

> > | Avoid hang observed with Java 6 on Windows when stopping the Tomcat process via CTRL-C. (markt)

> Other

> > | 55663: NOTICE files are corrected according to NOTICE files requirements. (violetagg)

Tomcat 7.0.46 (violetagg) | not released

> Catalina

> > | Only send a WebSocket close message on an IOException if the client has not yet received a close control message from the server as the IOException may be in response to the client continuing to send a message after the server sent a close control message. (markt)
> > | 49134: Ensure nested realms are correctly destroyed, when a CombinedRealm is destroyed. This ensures that the associated MBeans are deregistered. (markt)

> Coyote

> > | Refactor APR/native connector to reduce the scope of `localAddList`. (markt)
> > | 55602: Ensure that sockets removed from the Poller and then closed in the APR/native connector are removed and then closed in a thread-safe manner. (markt)
> > | Update the APR/native connector to version 1.1.29. (violetagg)

> Jasper

> > | 55642: Correct logic error in the JSP parser that was incorrectly identifying EL expressions in jsp:param element values as a literal string. (markt)

> Cluster

> > | Add support for notify periodic event of cluster. (kfujino)

> Web applications

> > | Correct the javadoc for `org.apache.catalina.Lifecycle`. (kfujino)
> > | Add document for sessionIdAttribute attribute in `org.apache.catalina.ha.session.JvmRouteBinderValve`. (kfujino)
> > | Handle the case when a user closes the browser whilst playing the snake game in the JSR356 WebSocket examples. (markt)
> > | Ensure Javadoc comments are associated with the correct elements in `org.apache.tomcat.jni.Poll`. (markt)
> > | Expand Context documentation for the use of `sessionCookiePath="/"` to make the implications for session fixation protection clearer. (markt)
> > | 55629: Ensure that the JMX notification listener added during initialization of the servlet org.apache.catalina.manager.StatusManagerServlet is removed in the destroy phase. (violetagg)
> > | Correct the documentation for Deployment Organization in the App Dev Guide. (violetagg)
> > | 55639: Add a Drawboard WebSocket example. (kpreisser)

Tomcat 7.0.45 (violetagg) | not released

> Catalina

> > | 55576: Preserve the order in which request parameters were received when accessing them via the Servlet API. (markt)

> Cluster

> > | Logger instance of cluster session manager is changed to non-static in order to enable logging of each application. (kfujino)

Tomcat 7.0.44 (violetagg) | not released

> Jasper

> > | 55582: Correct concurrency issue that can result in two instances of JspServletWrapper being created for one tag Patch provided by Sheldon Shao. (markt)

Tomcat 7.0.43 (violetagg) | not released

> Catalina

> > | 51526: `o.a.catalina.startup.Tomcat#addWebapp` methods now process the web application's `META-INF/context.xml` when it is available in the provided path. (violetagg)
> > | 55186: Ensure local name is recycled between requests so IP virtual hosting works correctly. (markt)
> > | 55210: Correct the processing of the provider-configuration file for `javax.servlet.ServletContainerInitializer` in the resource directory `META-INF/services` when this file contains comments and multiple SCIs. Patch provided by Nick Williams. (violetagg)
> > | 55230: Use the correct resource path when obtaining an InputStream for resources served by a ProxyDirContext. (markt)
> > | Ensure that the JAR scanning process scans the Apache Log4j version 2 JARs. Patch provided by Nick Williams. (markt)
> > | 55261: Fix failing unit test for file upload checks when running on platform / JVM combinations that have large network buffers. (markt)
> > | 55268: Added optional --service-start-wait-time command-line option to change service start wait time from default of 10 seconds.
> > | The `contextClass` attribute of `HostConfig` refers to the value of the `contextClass` attribute of Host. (kfujino)
> > | 55331: Dispatching to an asynchronous servlet from `AsyncListener.onTimeout()` should not trigger an `IllegalStateException`. (markt)
> > | 55333: Correct a regression in the fix for 55071. (markt)
> > | When using a security manager, ensure that calls to the ServletContext that are routed via an `AccessController.doPrivileged` block do not result in a call to a different underlying method on the ServletContext. (markt)
> > | 55354: Ensure that the naming context environment parameters are restored after associating the Principle with the user name. Based on patch provided by Richard Begg. (violetagg)
> > | 55357: Ensure the web application class loader is set as a thread context class loader during session deserialization. (violetagg)
> > | 55404: Log warnings about using security roles in web.xml without defining them as warnings. (markt)
> > | 55439: Don't try a forced stop when `stop -force` is used if Tomcat has already been stopped. This avoids error messages when the PID file has been cleared. If a forced stop is required, improve handling of the case when the PID file can be read from or written to but not deleted. (markt)
> > | 55454: Avoid NPE when parsing an incorrect content type. (violetagg)
> > | Back-port the JSR-356 Java WebSocket 1.0 implementation from Tomcat 8. Note that use of this functionality requires Java 7. (markt)
> > | Deprecate the Tomcat proprietary WebSocket API in favour of the new JSR-356 implementation. (markt)
> > | 55494: Reduce severity of log message from warning to information for JNDI Realm connection issues where the JNDI Realm automatically re-tries the action that failed. Make clear in the log message that the action is being re-tried. (markt)
> > | Correct several incorrect formats of `JdkLoggerFormatter`. (kfujino)
> > | 55521: Ensure that calls to `HttpSession.invalidate()` do not return until the session has been invalidated. Also ensure that checks on the validity of a session return a result consistent with any previous call to `HttpSession.invalidate()`. (markt)
> > | 55524: Refactor to avoid a possible deadlock when handling an `IOException` during output when using Tomcat' proprietary (and deprecated) WebSocket API. (markt)
> > | The loaded attribute never exists in `PersistentManager`. isLoaded is defined as operation in mbeans-descriptors. (kfujino)
> > | Added logging of logging.properties location when system property `org.apache.juli.ClassLoaderLogManager.debug=true` is set.
> > | 55570: Correctly log exceptions for all error conditions in the SPNEGO authenticator. (markt)

> Coyote

> > | 55228: Allow web applications to set a HTTP Date header. (markt)
> > | Expose the current connection count for each protocol handler via JMX. (markt)
> > | 55267: If an application configures a timeout for a Comet connection ensure it is only used for read and not write operations. This prevents a long timeout delaying the closing of the socket associated with a Comet connection after an error occurs. (markt)
> > | Ensure that `java.lang.VirtualMachineError`s are not swallowed when using the HTTP or AJP NIO connectors. (markt)
> > | 55399: Use the response locale to select the language to use for the status message in the HTTP response. (markt)
> > | Refactor the connectors to support the new JSR-356 Java WebSocket 1.0 implementation. The most noticeable change is that the AJP APR/native and HTTP APR/native connectors no longer support multiple poller threads. Both connectors now use a single poller thread. (markt)
> > | Internally, content length is managed as a `long`. Fix a few places in the AJP connector where this was restricted to an `int`. (markt)
> > | 55453: Ensure that the AJP connector does not permit response bodies to be included for responses with status codes and/or request methods that are not permitted to have a response body. (markt)
> > | 55500: Don't ignore the value of an asynchronous context timeout when using the AJP NIO connector. (markt)
> > | Fix CVE-2013-4286: Better adherence to RFC2616 for content-length headers. (markt)
> > | Fix CVE-2013-4322: Add support for limiting the size of chunk extensions when using chunked encoding. (markt)
> > | Update the APR/native connector to version 1.1.28. Make this the minimum acceptable version as the correct behaviour of the JSR-356 WebSocket implementation when using the APR/native HTTP connector depends on a bug fix in the 1.1.28 release. (markt)

> Jasper

> > | 55198: Ensure attribute values in tagx files that include EL and quoted XML characters are correctly quoted in the output. (markt)
> > | Ensure that `javax.el.ELContext.getContext(Class)` will throw `NullPointerException` when the provided class is null. (violetagg)
> > | Ensure that `FeatureDescriptor` objects returned by `javax.el.MapELResolver.getFeatureDescriptors(ELContext,Object)` will be created with a correct `shortDescription` - an empty string and a named attribute `ELResolver.RESOLVABLE_AT_DESIGN_TIME` - true. (violetagg)
> > | Ensure that `FeatureDescriptor` objects returned by `javax.el.ResourceBundleELResolver.getFeatureDescriptors(ELContext,Object)` will be created with a correct `shortDescription` - an empty string. `javax.el.ResourceBundleELResolver.isReadOnly(ELContext,Object,Object)` returns true if the base object is an instance of ResourceBundle. (violetagg)
> > | 55207: Enforce the restriction that a <jsp:text> element may not contain any sub-elements from any namespace. Patch provided by Jeremy Boynes. (markt)
> > | Ensure that `javax.el.ListELResolver.getFeatureDescriptors(ELContext,Object)` will always return null. `javax.el.ListELResolver.isReadOnly(ELContext,Object,Object)` will return a result when the property cannot be coerced into an integer. (violetagg)
> > | Ensure that `javax.el.ArrayELResolver.getFeatureDescriptors(ELContext,Object)` will always return null. `javax.el.ArrayELResolver.isReadOnly(ELContext,Object,Object)` and `javax.el.ArrayELResolver.getType(ELContext,Object,Object)` will return a result when the property cannot be coerced into an integer. (violetagg)
> > | 55309: Fix concurrency issue with JSP compilation and the tag plug-in manager. Patch provided by Sheldon Shao. (markt)
> > | Ensure that `javax.el.BeanELResolver.getFeatureDescriptors(ELContext,Object)` and `javax.el.BeanELResolver.getCommonPropertyType(ELContext,Object)` do not throw `NullPointerException` when the provided context is null. (violetagg)

> Cluster

> > | Add new attribute terminateOnStartFailure. Set to true if you wish to terminate replication map when replication map fails to start. If replication map is terminated, associated context will fail to start. If you set this attribute to false, replication map does not end. It will try to join the map membership in the heartbeat. Default value is false. (kfujino)
> > | Avoid ConcurrentModificationException when sending a heartbeat. (kfujino)
> > | Avoid NPE when the channel fails to start. (kfujino)
> > | 55301: Fix `IllegalArgumentException` thrown by simple test for McastService. (kfujino)
> > | 55332: Fix NPE in `FileMessageFactory.main` when specify empty file as arguments. (kfujino)
> > | More definite thread name for `MessageDispatch15Interceptor`. (kfujino)

> Web applications

> > | Remove the experimental label from the AJP NIO connector documentation. (markt)
> > | Correctly associated the default resource bundle with the English locale so that requests that specify an Accept-Language of English ahead of French, Spanish or Japanese get the English messages they asked for. (markt)
> > | 55469: Fixed tags that were not properly closed. Based on a patch provided by Larry Shatzer, jr. (violetagg)
> > | The WebSocket examples in the examples web application have been changed to use the new JSR-356 Java WebSocket 1.0 implementation. (markt)
> > | Add document for `org.apache.catalina.tribes.group.GroupChannel`. (kfujino)
> > | Correct Realm Component page of Tomcat documentation. (violetagg)

> jdbc-pool

> > | 54693: Add a validationQueryTimeout property. Patch provided by Daniel Mikusa. (kfujino)
> > | 54693#c6: Avoid NPE caused by `createConnection()` method returns null. Patch provided by Daniel Mikusa. (kfujino)
> > | 55342: Remove unnecessary reset of interrupted flag. If `InterruptedException` is thrown, the interrupted flag has been cleared. (kfujino)
> > | 55343: Add flag to ignore exceptions of connection creation while initializing the pool. (kfujino)
> > | Add undefined attributes and operations to mbeans-descriptor. (kfujino)

> Other

> > | 45428: Trigger a thread dump written to standard out if Tomcat fails to stop in a timely manner to aid diagnostics. This is only available on platforms that use `catalina.sh`. (markt)
> > | 55204: Correct namespace used in Servlet 2.4 test web application. Patch provided by Jeremy Boynes. (markt)
> > | 55205: Reorder elements so web.xml complies with schema for Servlet 3.0 test web application. Patch provided by Jeremy Boynes. (markt)
> > | 55211: Correct namespace in TLD files used in test web applications. Rename elements `tagclass` to `tag-class` so TLD files complies with DTD/schema. Patch provided by Jeremy Boynes. (violetagg)
> > | Update package renamed version of Commons BCEL to the latest code from Commons BCEL trunk. (markt)
> > | Update package renamed version of Commons FileUpload to the latest code from Commons FileUpload trunk. (markt)
> > | 55297: When looking for the jsvc executable, if an explicit path is not set and it is not found in $CATALINA_BASE, look in $CATALINA_HOME as well. (markt)
> > | 55336: Correctly escape parameters passed to eval in the catalina.sh script to ensure that Tomcat starts when installed on a path that contains multiple consecutive spaces. (markt)

Tomcat 7.0.42 (markt) | released 2013-07-05

> Catalina

> > | Enforce the restriction described in section 4.4 of the Servlet 3.0 specification that requires the new pluggability methods only to be available to `ServletContextListener`s defined in one of the specified ways. (markt)
> > | Better handle FORM authentication when requesting a resource as an unauthenticated user that is only protected for a sub-set of HTTP methods that does not include GET. (markt)
> > | 53777: Add support for a JAAS Realm instance to use a dedicated configuration rather than the JVM global JAAS configuration. This is most likely to be useful for per web application JAAS Realms. Based on a patch by eolivelli. (markt)
> > | 54745: Fix JAR file scanning when Tomcat is deployed via Java Web Start. Patch provided by Nick Williams. (markt)
> > | 55017: Add the ability to configure the RMI bind address when using the JMX remote lifecycle listener. Patch provided by Alexey Noskov. (markt)
> > | 55071: Ensure original exception is reported if JDBC Realm fails to read a user's credentials. (markt)
> > | 55073, 55108, 55109, 55110, 55158 & 55159: Small performance improvements. Patches provided by Adrian Nistor. (markt/violetagg)
> > | 55102: Add support for time to first byte in the AccessLogValve. Patch provided by Jeremy Boynes. (markt)
> > | 55125: If the Server container fails to start, don't allow the Catalina wrapper to start (used when running from the command line and when running as a service) since Tomcat will not be able to do any useful work. (markt)
> > | Update the `JreMemoryLeakPreventionListener` to take account of changes in the behaviour of `java.beans.Introspector.flushCaches()` and `sun.awt.AppContext.getAppContext()` in Java 7. (markt)
> > | Avoid WARNING log message of `Users:type=UserDatabase,database=UserDatabase` at Tomcat shutdown. (pero)
> > | Avoid `ClassCastException` when an asynchronous dispatch is invoked in an asynchronous cycle which is started by a call to `ServletRequest.startAsync(ServletRequest,ServletResponse)` where ServletRequest/ServletResponse are custom implementations. (violetagg)
> > | Correct a regression introduced in 7.0.39 (refactoring of base 64 encoding and decoding) that broke the JNDI Realm when `userPassword` was set and passwords were hashed with MD5 or SHA1. (markt/kkolinko)
> > | Correct the mechanism for the path calculation in `AsyncContext.dispatch()`. (violetagg)
> > | 55155: Avoid constant focus grabbing when running the Tomcat unit tests under Java 6 on OSX. Patch provided by Casey Lucas. (markt)
> > | 55160: Don't ignore connectionUploadTimeout setting when using HTTP NIO connector. (markt)
> > | 55176: Correctly handle regular expressions within SSI expressions that contain an equals character. (markt)

> Coyote

> > | 55177: Correctly handle infinite soTimeout for BIO HTTP connector. Based on a patch by Nick Bunn. (markt)
> > | 55180: Correctly handle infinite soTimeout when `disableUploadTimeout` is set to false. Patch provided by Nick Bunn. (violetagg)

> Cluster

> > | Delete leftover of war file from tempDir when removing invalid `FileMessageFactory`. (kfujino)
> > | Ensure that the keepAlive of NioSender works correctly when `keepAliveCount`/`keepAliveTime` is set to a value greater than 0. (kfujino)
> > | Add logging of when a member is unable to join the cluster. (kfujino)
> > | Replace Tribes's `TaskQueue` as executor's workQueue in order to ensure that executor's `maxThread` works correctly. (kfujino)
> > | 54086: Fix an additional code path that could lead to multiple threads attempting to modify the same selector key set. (markt)

> Web applications

> > | Complete the document for `MessageDispatch15Interceptor`. (kfujino)
> > | 53655: Document the circumstances under which Tomcat will add a `javax.mail.Authenticator` to mail sessions created via a JNDI resource. (markt)
> > | 55179: Correct the Javadoc for the remote IP valve so the correct name is used to refer to the `proxiesHeader` property. (markt)

> jdbc-pool

> > | 55031: Fixed `Export-Package` header and `uses` directives in MANIFEST.MF. Change the version for package `org.apache.juli.logging` to "0" in `Import-Package` header. Thus any version of that package can be used. Patch provided by Martin Lichtin. (violetagg)

> Other

> > | Update Maven Central location used to download dependencies at build time to be `repo.maven.apache.org`. (kkolinko)
> > | Update JUnit to version 4.11. Configure separate download for Hamcrest 1.3 core library as its classes are no longer included in junit.jar. (kkolinko)
> > | 54013: When using a forced stop, allow a short period of time (5s) for the process to die before returning. Patch provided by mukarram.baig. (markt)
> > | 55119: Ensure that the build process produces Javadoc that is not vulnerable to CVE-2013-1571. Based on a patch by Uwe Schindler. (markt)

Tomcat 7.0.41 (markt) | released 2013-06-10

> Catalina

> > | 54703: Make parsing of HTTP Content-Type headers tolerant of any CR or LF characters that appear in the value passed by the application. Also fix some whitespace parsing issues identified by the additional test cases. (markt)
> > | Prevent possible WAR file locking when reading a context.xml file from an unexpanded WAR file. Note that in normal usage, the `JreMemoryLeakPreventionListener` would protect against this. (markt)
> > | Ensure that when auto deployment runs for a Host, it uses the latest values for copyXML, deployXML and unpackWARs. (markt)
> > | 54939: Provide logging (using a UserDataHelper) when HTTP header parsing fails (e.g. when maxHeaderCount is exceeded). (markt)
> > | 54944: Enhancements to the unit tests for FORM authentication. Patch provided by Brian Burch. (markt)
> > | 54955: When a reload of the application is performed ensure that a subsequent request to the context root does not result in a 404 response. (violetagg)
> > | 54971: Ensure that the correct location is used when writing files via `javax.servlet.http.Part.write(String)`. (markt)
> > | 54974: Ensure that `SessionCookieConfig#set<methods>` will throw `IllegalStateException` if the `ServletContext` from which this `SessionCookieConfig` was acquired has already been initialized. (violetagg)
> > | 54981: Ensure that `ServletContext#getJspConfigDescriptor()` will return `null` when there is no jsp configuration provided by web.xml/web-fragment.xml. (violetagg)
> > | Ensure that when Tomcat's anti-resource locking features are used that the temporary copy of the web application and not the original is removed when the web application stops. (markt)
> > | 54984: Use the correct encoding when processing a form data posted as multipart/form-data even when the request parameters are not parsed. (violetagg)
> > | 54999: The old JSESSIONIDSSO needs to be removed when SSO is being used and logout() and login() occur within a single request. Patch provided by Keith Mashinter. (markt)
> > | 55035: Add support for the version attribute to the deploy command of the Ant tasks for interfacing with the text based Manager application. Patch provided by Sergey Tcherednichenko. (markt)
> > | 55046: Add a Servlet Filter that implements CORS. Patch provided by Mohit Soni. (markt)
> > | 55052: JULI's LogManager now additionally looks for logging properties without prefixes if the property cannot be found with a prefix. (markt)
> > | Ensure that only the first asynchronous dispatch operation for a given asynchronous cycle will be performed. Any subsequent asynchronous dispatch operation for the same asynchronous cycle will be ignored and `IllegalStateException` will be thrown. (violetagg)

> Coyote

> > | 54947: Fix the HTTP NIO connector that incorrectly rejected a request if the CRLF terminating the request line was split across multiple packets. Patch by Konstantin Preißer. (markt)

> Jasper

> > | 54964: Allow tag plug-ins to be packaged with a web application. Patch provided by Sheldon Shao. (markt)
> > | 54968: Return the correct version number (2.2) of the JSP specification that is supported by the JSP engine when `javax.servlet.jsp.JspEngineInfo#getSpecificationVersion()` is invoked. (violetagg)

> Cluster

> > | Add `maxValidTime` attribute to prevent the leak of `FileMessageFactory` in `FarmWarDeployer`. (kfujino)
> > | Simplify the code of `ReplicationValve`: Rather than get cluster instance from container on every request, use instance variable. (kfujino)
> > | Add `maxWait` attribute that the senderPool will wait when there are no available senders. (kfujino)
> > | Improve error message by including specified timeout if failed to retrieve a data sender. (kfujino)
> > | Add `removeSuspectsTimeout` attribute in order to remove a suspect node in TcpFailureDetector. (kfujino)

> Web applications

> > | 54931: Add information to the Window Service how-to about installing and running multiple instances. Based on a patch by Chris Derham. (markt)
> > | 54932: Correct the link to Tribes documentation. (violetagg)
> > | Add document for `o.a.c.tribes.group.interceptors.TcpFailureDetector`. (kfujino)

Tomcat 7.0.40 (markt) | released 2013-05-09

> Catalina

> > | Update Tomcat's internal copy of Commons FileUpload to FileUpload 1.3. (markt)
> > | 54178, CVE-2013-2071: Protect against `AsyncListener` implementations that throw `RuntimeException`s in response to an event. (markt)
> > | 54791: Restore `tools.jar` entry in `jarsToSkip` property to prevent warnings when running Tomcat from Eclipse. (markt)
> > | 54851: When scanning for web fragments, directories without any web-fragment.xml should not impact the status of distributable element. Patch provided by Trask Stalnaker. (violetagg)
> > | When an error occurs during the sending of a WebSocket message, notify the Inbound side (where all the events occur that the application reacts to) that an error has occurred and that the connection is being closed. (markt)
> > | 54906: Better error message if a `ConcurrentModificationException` occurs while checking for memory leaks when a web application stops. Also ensure that the exception does not cause remaining checks to be skipped. Based on a patch by NateC.
> > | Allow 204 responses (no content) to include entity headers as required by RFC2616. (markt)

> Coyote

> > | Ensure write errors when using HTTP Upgrade with the APR/native connector result in `IOException`s rather than errors being silently swallowed. (markt)

> Jasper

> > | 54802: Provide location information for exceptions thrown by JspDocumentParser. (kkolinko)
> > | 54801: Do not attempt to parse text that looks like an EL expressions inside a scriptlet in a JSP document because EL expressions are not permitted in scriptlets. (kkolinko/markt)
> > | 54821: Do not attempt to parse text that looks like an EL expressions in a JSP document if EL expressions have been disabled. (kkolinko/markt)
> > | 54888: Add support for CSV lists with the ForEach tag plugin. Patch provided by Sheldon Shao. (markt)

> Cluster

> > | Add several improvements for FarmWarDeployer. (kfujino)

> Web applications

> > | 54872: Correct Cluster Receiver page of Tomcat documentation. (violetagg)

> jdbc-pool

> > | Document `StatementCache` interceptor. (kkolinko)
> > | Fix minor threading issue in `ConnectionPool`. (markt/kkolinko)
> > | 54732: Fix leak of statements in `StatementCache` interceptor. (kkolinko)
> > | Fix NPE in `SlowQueryReportJmx` when running `TestSlowQueryReport` test. (kkolinko)

> Other

> > | Update to Eclipse JDT Compiler 4.2.2. (kkolinko)
> > | 54890: Update to Apache Commons Daemon 1.0.15. (mturk)
> > | Convert remaining unit tests to JUnit 4 and enable Checkstyle rule that forbids use of methods from JUnit 3. (markt/kkolinko)
> > | Remove unneeded permissions for reading UserDataHelper properties from `catalina.policy` file. The class that needed those was moved in 7.0.26. (kkolinko)

Tomcat 7.0.39 (markt) | released 2013-03-26

> Catalina

> > | Ensure a log message is generated when a web application fails to start due to an error processing a ServletContainerInitializer. (markt)
> > | Prevent NPE in JAR scanning when running in an environment where the bootstrap class loader is not an ancestor of the web application class loader such as OSGi environments. (violetagg)
> > | Ensure that, if a call to UEncoder#encodeURL is made, all internal structures are properly cleaned. (violetagg)
> > | 54660: Enable the modification of an access log's `fileDateFormat` attribute while the access log is in use. The change will take effect when the next entry is made to the access log. (markt)
> > | Update Tomcat's internal copy of Commons FileUpload to FileUpload trunk, revision 1458500 and the associated extract from Commons IO to 2.4. (markt)
> > | 54702: Prevent file descriptors leak and ensure that files are closed when parsing web application deployment descriptors. (violetagg)
> > | 54707: Further relax the parsing of DIGEST authentication headers to allow for buggy clients that quote values that RFC2617 states should not be quoted. (markt/kkolinko)
> > | Enable support for MBeans with multiple operations with the same name but different signatures. (markt)
> > | Deprecate Tomcat's internal Base 64 encoder/decoder and switch to using a package renamed copy of the Commons Codec implementation. (markt)
> > | Ensure that StandardJarScanner#scan will use the provided class loader when scanning the class loader hierarchy. (violetagg)

> Coyote

> > | 54690: Fix a regression caused by the previous fix for 54406. If no values are specified for sslEnabledProtocols or ciphers use the default values for server sockets rather than the default values for client sockets. (markt)

> Web applications

> > | Correct Deployer, Manager and Context pages of Tomcat documentation. (kkolinko)

> jdbc-pool

> > | 52318: Version for imported package `org.apache.juli.logging` is extended to include also 7.0.x versions. The fix is applicable only when running in OSGi environment. Patch provided by Martin Lichtin. (violetagg)
> > | 54599: Do not print connection password in `PoolProperties.toString()`. Based on a patch by Daniel Mikusa. (kkolinko)
> > | 54684: Add `javax.naming.spi` to `Import-Package` header in MANIFEST.MF in order to resolve `ClassNotFoundException` when running in OSGi environment. (violetagg)

> Other

> > | Update to Apache Commons Daemon 1.0.14 to resolve 54609 which meant that installation of Windows service could fail producing incorrect service launch command. (mturk)
> > | Ensure HEAD requests return the correct content length when the requested resource uses a Writer. Patch by Nick Williams. (markt)

Tomcat 7.0.38 (markt) | not released

> Catalina

> > | Ensure that the request start time (used by the access log valve to calculate request processing time) is correctly recorded for the HTTP NIO connector. In some cases the request processing time may have been longer than that recorded. (markt)
> > | Add one more library from JDK 7 to the value of `jarsToSkip` property in the `catalina.properties` file. (kkolinko)
> > | 53871: If annotation scanning results in a `StackOverflowError` due to broken class dependencies, add the class hierarchy that triggered the exception to the error message. (markt)
> > | Add a new option to the standard JarScanner implementation (`scanBootstrapClassPath`) to control if the bootstrap classpath is scanned or not. By default, it will not be scanned. (markt)
> > | Provide more consolidated servlet MBean data in the webapp MBean. (rjung)
> > | 54584: Take account of the delegate attribute when building the web application class path to pass to the JSP compiler. (markt)
> > | Copy the updated and re-packaged UTF-8 decoder from Tomcat 8.0.x and use this improved decoder for WebSocket connections. Remove the WebSocket specific UTF-8 decoder. (markt)
> > | 54602: Recycle the byte to character converter used for URIs between requests to ensure an error in one request does not trigger a failure in the next request. (markt)

> > Use the newly added improved UTF-8 decoder for decoding UTF-8 encoded URIs and UTF-8 encoded request bodies. Invalid UTF-8 URIs will not cause an error but will make use of the replacement character when an error is detected. This will allow web applications to handle the URI which will most likely result in a 404 response. The fall-back to decoding with ISO-8859-1 if UTF-8 decoding fails has been removed. Invalid UTF-8 sequences in a request body will trigger an IOException. The way the decoder is used has also been improved. The notable change is that invalid sequences at the end of the input now trigger an error rather than being silently swallowed. (markt)

> > | 54624: Ensure that the correct request body length is used when swallowing a request body after FORM authentication prior to restoring the original request preventing possible hanging when restoring POST requests submitted over AJP. (markt)
> > | 54628: When writing binary WebSocket messages write from start position in array rather than the start of the array. Patch provided by blee. (markt)

> Coyote

> > | Refactor char encoding/decoding using NIO APIs. (remm)

> Web applications

> > | 54203: Complete the Javadoc for `javax.servlet.http.Part`. (markt)
> > | 54638: Fix display of "Used" memory value for memory pools on the status page in Manager web application when the page is rendered as XML. (kkolinko)
> > | Correct typos in configuration samples on SSL Configuration page of Tomcat documentation. (kkolinko)
> > | Disable support for comments on Changelog page of Tomcat documentation. (kkolinko)
> > | Fix several issues with `status.xsd` schema in Manager web application, testing it against actual output of StatusTransformer class. (kkolinko)
> > | Clarify the documentation on how context paths may be configured for web applications. (markt)

> Other

> > | 54601: Change `catalina.sh` to consistently use `LOGGING_MANAGER` variable to configure logging, instead of modifying `JAVA_OPTS` one. (kkolinko)

Tomcat 7.0.37 (markt) | released 2013-02-18

> Catalina

> > | 54521: Ensure that concurrent requests that require a DIGEST authentication challenge receive different nonce values. (markt)
> > | 54534: Ensure that, if a call to `StandardWrapper#isSingleThreadModel()` triggers the loading of a Servlet, the correct class loader is used. (markt)
> > | 54536: Ensure the default error page is displayed if a custom HTTP status code is used when calling `HttpServletResponse#sendError(int, String)`. (markt)

> Coyote

> > | 54456: Ensure that if a client aborts a request when sending a chunked request body that this is communicated correctly to the client reading the request body. (markt)
> > | Update the native component of the APR/native connector to 1.1.27 and make that version the recommended minimum version. (markt)

> Jasper

> > | 54239: Enable web applications to provide their own Expression Language interpreter to enable them to optimise processing of expressions. Based on a patch by Sheldon Shao. (markt)

> Web applications

> > | 54505: Create clearer links from the JNDI How-To to the Tomcat specific options for configuring JNDI resources. (markt)

> Other

> > | Update to Apache Commons Daemon 1.0.13. (markt)

Tomcat 7.0.36 (markt) | not released

> Catalina

> > | Make additional allowances for buggy client implementations of HTTP DIGEST authentication. This is a follow-on to 54060. (markt)
> > | 54438: Fix a regression in the fix for 52953 that triggered a NPE when digested passwords were used and an authentication attempt was made for a user that did not exist in the realm. (markt)
> > | 54448: Correctly handle `@Resource` annotations on primitives. Patch provided by Violeta Georgieva. (markt)
> > | 54450: Correctly handle resource injection when part of the servlet properties uses `@Resource` and the other uses `injection-target`. Patch provided by Violeta Georgieva. (markt)
> > | 54458: Include exception when logging errors in the DataSourceRealm. Patch provided by Violeta Georgieva. (markt)
> > | 54483: Correct one of the Spanish translations. Based on a suggestion from adinamita. (markt)
> > | Prevent the SSO deregister when web application is stopped or reloaded. When StandardManager(pathname="") or DeltaManager stops normally, all sessions in the context are expired. In this case, because most sessions is not time-out, SSO deregister was triggered. (kfujino)
> > | Include the exception in the log message if the parsing of the context.xml file fails. (markt/kkolinko)
> > | 54497: Make memory leak detection code more robust so a failure in the leak detection code does not prevent the Context from stopping unless the error is fatal to the JVM. (markt)
> > | 54507: Do not start the background thread that is used for expiring sessions (amongst other things) until the web application is fully started. Stop the background thread as soon as the web application is stopped. (markt)
> > | Allow WebSocket Ping/Pong messages to be sent between fragments of a fragmented message. (markt)
> > | 54612: Check if the socket is closed before trying to write a WebSocket message to it. Also, flush any partial buffered data before closing the socket. (markt)

> Coyote

> > | 54324: Allow APR connector to disable TLS compression if OpenSSL supports it. (schultz)
> > | 54406: Fix NIO HTTPS connector to prune specified `ciphers` and `sslEnableProtocols` options to those supported by the SSL implementation, sharing logic with the BIO connector. Modified ciphers and sslEnabledProtocols option pruning to not silently revert to JVM defaults when none of the options specified are supported - new behaviour is to warn and explicitly enable no options. (timw)
> > | Align NIO HTTP connector with other HTTP connectors and include leading blank lines when determining the size of the HTTP headers. (markt)

> Jasper

> > | 53869: Performance improvement for pages with lots of heavily nested tags. Retain a reference to the root JSP context rather than traversing the hierarchy on every call. Based on a patch suggested by Sheldon Shao. (markt)
> > | 54440: Correct a regression caused by the changes for 54240 that broke compilation of JSPs with JspC. Patch provided by Sheldon Shao. (markt)
> > | 54466: Improve error message by including the name of the file when the java file generated from a tag file cannot be compiled. Based on a patch by Sheldon Shao. (markt)

> Cluster

> > | Fix incorrect increment of `counterSend_EVT_SESSION_EXPIRED` and `counterSend_EVT_CHANGE_SESSION_ID`. These values are not incremented if no members active in cluster group. (kfujino)
> > | 54476: Correct error in Javadoc of GroupChannel send methods to maker clear that the minimum length of the destination member array is one, not two. (markt)
> > | Prevent SSO deregister when node shutdown normally in cluster environment. (kfujino)
> > | Check cluster member before sending replicate message in ClusterSingleSignOn. (kfujino)

> Web applications

> > | 54461: Improve the documentation for the compiler attribute in the Jasper how-to. (markt)
> > | Add Jespa to the list of third-party Windows authentication providers and make external links in the documentation for those providers `no-follow`. (markt)

> Tribes

> > | 54496: Don't use a hard-coded class name in `MemberImpl.toString()`. (markt)

> Other

> > | Update to Apache Commons Daemon 1.0.12. (markt)

Tomcat 7.0.35 (markt) | released 2013-01-16

> Catalina

> > | 54247: Prevent `ClassNotFoundException`s on stop when running as a service. (markt)
> > | 54249: Ensure resource properties are available when the context path contains encoded characters such as a space. This triggered compilation issues in Jasper. Patch provided by Polina Genova. (markt)
> > | 54256: Improve error reporting when a JAR file fails extension validation by including the name of the JAR file in the exception. (markt)
> > | Allow web applications to be stopped cleanly even if filters throw exceptions when their destroy() method is called. (markt/kkolinko)
> > | Fix memory leak of servlet instances when running with a SecurityManager and either init() or destroy() methods fail or the servlet is a SingleThreadModel one. (kkolinko)
> > | Cleanup method cache lookup code in `SecurityUtil` class. (kkolinko)
> > | Make the Tomcat 7 non-JSR356 WebSocket implementation non-blocking (where supported by the connector) between the HTTP upgrade and the first WebSocket message from the client to the server. (markt)
> > | 54262: Ensure that an empty `<absolute-ordering />` element in the main web.xml file disables scanning for web fragments. Based on a patch by Violeta Georgieva. (markt)
> > | 54284: As per clarification from the Servlet EG, anonymous Filters and Servlets are not permitted. Patch by Violeta Georgieva. (markt)
> > | 54371: Prevent exceptions when processing web fragments for unexpanded WAR files when the context path contains characters that need to be encoded in URLs such as spaces. Based on a patch by Polina Genova. (markt)
> > | 54372: Make HTTP Digest authentication header parsing tolerant of invalid headers sent by known buggy clients. (markt)
> > | 54377: Correctly set request attributes for AccessLog in RemoteIpFilter. Patch by Violeta Georgieva. (markt)
> > | 54379: Implement support for post-construct and pre-destroy elements in web.xml. Patch by Violeta Georgieva. (markt)
> > | 54380: Do not try to register servlets or contexts into the mapper too early (which just caused a warning to be logged). (kkolinko)
> > | Fix NPE in `WebappLoader.stopInternal` when stop is called after a failed start. (kkolinko)
> > | 54381: Add support for receiving WebSocket pong messages. (markt)
> > | 54382: Fix NPE when SSI processing is enabled and an empty SSI directive is present. (markt)
> > | Fix `ArrayIndexOutOfBoundsException` in `HttpParser` when parsing incorrect HTTP headers. (kkolinko)
> > | 54387: Deployment must fail when multiple servlets are mapped to the same url-pattern. (markt)
> > | 54391: Provide a value for the `javax.servlet.context.orderedLibs` attribute. (markt)

> Coyote

> > | 54248: Ensure that byte order marks are swallowed when using a Reader to read a request body with a BOM for those encodings that require byte order marks. (markt)
> > | Fix release of processors in `AjpNioProtocol`. Wrong object was used as a key in the connections map. (kkolinko)

> Jasper

> > | 54240: Add support for auto-detection and configuration of JARs on the classpath that provide tag plug-in implementations. Based on a patch by Sheldon Shao. (markt)
> > | 54241: Revert the fix for 35410 as it was not compliant with the JSP specification, specifically that `<%= obj %>` must be translated to `out.print(obj)` which in turn becomes `out.write(String.valueOf(obj))`. This will trigger a `NullPointerException` if `obj.toString()` returns `null`. The fix for 35410 incorrectly suppressed the `NullPointerException` in this case. (markt)
> > | 54242: Correct handle null iterations with in the JSTL ForEach tag plug-in implementation. Patch provided by Sheldon Shao. (markt)
> > | 54260: Avoid `NullPointerException` when using JSP unloading and tag files. (markt)
> > | 54370: Improve handling of nulls when trying to match sets of parameters to a method in EL. (markt)
> > | 54338: Correctly coerce the value to the expected type when using the tag plug-in for the JSTL set tag. Patch provided by Sheldon Shao. (markt)

> Web applications

> > | 54244: Clarify the documentation for the BIO and NIO SSL configuration attributes `sslEnabledProtocols` and `sslProtocol` within the documentation web application. (markt)
> > | Integrate documentation of Tomcat 7 with Apache Comments System. People can leave their comments when reading documentation online at the tomcat.apache.org site. (rjung)

> Other

> > | 54390: Use 'java_home' on Mac OS X to auto-detect JAVA_HOME. (schultz)

Tomcat 7.0.34 (markt) | released 2012-12-12

> Catalina

> > | 53871: Improve error message if annotation scanning fails during web application start due to poor configuration or illegal cyclic inheritance with the application's classes. (markt)
> > | Fix unit test for AccessLogValve when using non-GMT time zone. (rjung)
> > | 54170: Ensure correct registration of Filters and Servlets in the JMX registry if the Filter or Servlet name includes a character that must be quoted if used in an ObjectName value. (markt)
> > | Add new attribute `renameOnRotate` to the AccessLogValve. (rjung)
> > | 54190: Correct unit tests for BASIC authentication so that session timeout is correctly tested. Also refactor unit test to make it easier to add additional tests. Patch by Brian Burch. (markt)
> > | 54220: Ensure the ErrorReportValve only generates an error report if the error flag on the response has been set. (markt)
> > | Simplify time zone handling in the access log valve and correctly handle various edge cases for non-standard DST changes. (markt)

> Web applications

> > | 54198: Clarify that `HttpServletResponse.sendError(int)` results in an HTML response by default. (markt)
> > | 54207: Correct JNDI factory package name in Javadoc for `org.apache.naming.java.javaURLContextFactory`. (markt)

> jdbc-pool

> > | Fix a handful of Eclipse warnings in the JDBC pool source code including the warnings reported in 53565. (markt)
> > | 54150: Make sure that SlowQueryReportJmx mbean deregistered during webapp shutdown. Reported by Alex Franken. (kfujino)
> > | 54194: Make sure that connection pool mbean is not registered when jmxEnabled is false. Patch provided by tobias.gierke. (kfujino)

> Other

> > | Update to Eclipse JDT Compiler 4.2.1. (markt)

Tomcat 7.0.33 (markt) | released 2012-11-21

> Catalina

> > | 53960, 54115: Extensions to HttpClient test helper class. Patches by Brian Burch. (markt/kkolinko)
> > | 53993: Avoid a possible NPE in the AccessLogValve when the session ID is logged and a session is invalidated. (markt)
> > | Add support for LAST_ACCESS_AT_START system property to PersistentManager. (kfujino)
> > | Update MIME type mapping with additional / updated mime.types from the Apache web server. (markt)
> > | 54007: Fix a memory leak that prevented deletion of a context.xml file associated with a Context that had failed to deploy. Also fix the problems uncovered with undeploying such a Context once the leak had been fixed and the file could be deleted. (markt)
> > | 54044: Correct bug in timestamp cache used by logging (including the access log valve) that meant entries could be made with an earlier timestamp than the true timestamp. (markt)
> > | 54054: Do not share shell environment variables between multiple instances of the CGI servlet. (markt)
> > | 54060: Use a simple parser rather than a regular expression to parse HTTP Digest authentication headers so the header is correctly parsed. The new approach is also faster and generates less garbage. (markt)
> > | 54068: Rewrite the web fragment ordering algorithm to resolve multiple issues that resulted in incorrect ordering or failure to find a correct, valid order. (markt)
> > | The HTTP header parser added to address 52811 has been removed and replaced with the light-weight HTTP header parser created to address 54060. The new parser includes a work-around for a bug in the Adobe Acrobat Reader 9.x plug-in for Microsoft Internet Explorer that was identified when the old parser was introduced (53814).
> > | 54076: Add an alternative work-around for clients that use SPNEGO authentication and expect the authenticated user to be cached per connection (Tomcat only does this if an HTTP session is available). (markt)
> > | 54087: Correctly handle (ignore) invalid If-Modified-Since header rather than throwing an exception. (markt)
> > | 54096: In web.xml, <env-entry> should accept any type that has a constructor that takes a single String or char. (markt)
> > | 54127: Add support for sending a WebSocket Ping. Patch provided by Sean Winterberger. (markt)
> > | Fix CVE-2013-2067: In FormAuthenticator: If it is configured to change Session IDs, do the change before displaying the login form. (kkolinko)
> > | Ensure `AsyncListener.timeout()` and `AsyncListener.complete()` are called with the correct thread context class loader. (fhanik)
> > | 54123: If an asynchronous request times out without any `AsyncListener`s defined, a 500 error will be triggered. (markt)
> > | 54124: Correct provided value of request attribute `javax.servlet.async.request_uri` and add missing request attribute `javax.servlet.async.path_info`. (markt)
> > | Add `denyStatus` initialization parameter to `CsrfPreventionFilter`, allowing to customize the HTTP status code used for denied requests. (kkolinko)
> > | 54141: Increase the permitted number of nested Realm levels from 2 to 3 by default and make the limit configurable via a system property. (markt)
> > | Revert occasional API change in `BaseDirContext` class that was done in 7.0.32. Methods should not be `final`. (kkolinko)
> > | Prevent failures in the AccessLogValve when running under a SecurityManager and the first request received is an asynchronous one. (markt)

> Coyote

> > | Correct an issue that prevented WebSockets from being used over SSL when using the HTTP NIO connector. (markt)
> > | 54022: Ensure the Comet END event is triggered on client disconnect with APR/native on Windows Vista/2k8 or later. Patch provided by Douglas Beachy. (markt)
> > | 54067: Ensure responses with 1xx response codes are correctly marked as not containing an entity body. This caused an issue for some WebSocket clients when an Transfer-Encoding header was sent with the 101 (HTTP upgrade) response. (markt)

> Jasper

> > | 53867: Optimise the XML escaping provided by the PageContext implementation. Based on a patch by Sheldon Shao. (markt)
> > | 53896: Use an optimised CompositeELResolver for Jasper that skips resolvers that are known to be unable to resolve the value. Patch by Jarek Gawor. (markt)
> > | 53986: Correct a regression introduced by the fix for 53713. JSP comments that ended with the sequence ---%> (or any similar sequence with a odd number of - characters) was not correctly parsed. (markt)
> > | 54011: Fix a bug in the tag plug-in for `<c:out>` that triggered a JSP compilation error if the `escapeXml` attribute was used. Patch provided by Sheldon Shao. (markt)
> > | Follow up to 54011. Simplify generated code for `<c:out>`. Based on a patch by Sheldon Shao. (markt)
> > | 54012: Fix a bug in the tag plug-in infrastructure that meant the `<c:set>` triggered a JSP compilation error when used in a tag file. Based on a patch provided by Sheldon Shao. (markt)
> > | 54017: Simplify coercion of `String` instances to `Object`. (markt)
> > | 54144: Fix a bug in the tag plug-in for `<c:out>` that meant that if the value of the tag evaluated to a `java.io.Reader` object then it was not correctly handled. (markt)

> Cluster

> > | Add getSessionIdsFull operation to mbeans-descriptor. listSessionIdsFull no longer exist. (kfujino)
> > | 54086: Fix threading issue when stopping an `NioReceiver`. (markt)

> Web applications

> > | 54143: Add display of the memory pools usage (including PermGen) to the Status page of the Manager web application. (kkolinko)

> Tribes

> > | 54045: Make sure getMembers() returns available member when TcpFailureDetector works in static cluster. (kfujino)

Tomcat 7.0.32 (markt) | released 2012-10-09

> Catalina

> > | Revert multiple operation support for the `JMXProxyServlet` pending further discussion. (schultz)
> > | CVE-2012-4431: Fix bypass of `CsrfPreventionFilter` when there is no session. Improve session management in the filter. (kkolinko)

> Web applications

> > | Correct the couple of broken links in the Tomcat Javadoc. (markt)

> Other

> > | Update optional Checkstyle library to 5.6. (kkolinko)

Tomcat 7.0.31 (markt) | not released

> Catalina

> > | Add one library from JDK 7 to the value of `jarsToSkip` property in the `catalina.properties` file. (kkolinko)
> > | 52777: Add an option to automatically remove old, unused versions (ones where there are no longer any active sessions) of applications deployed using parallel deployment. (markt)
> > | 53828: Use correct status code when closing a WebSocket connection normally in response to a close frame from a client. (markt)
> > | `JMXProxyServlet` now allows multiple operation commands like `invokeAndSet`, `invokeAndGet`, etc. (schultz) Note: reverted in 7.0.32.
> > | 53843: `request.isAsyncStarted()` must continue to return true until the dispatch actually happens (which at the earliest isn't until the thread where `startAsync()` was called returns to the container). (markt)
> > | 53863: Ensure that the implicit servlets (JSP and default) are marked as override-able when using embedded mode. (markt)
> > | When the `DefaultServlet` is under heavy load, the HTTP header parser added to address 52811 generates large amounts of garbage and uses significant CPU time. A cache has been added that significantly reduces the overhead of this parser. (markt)
> > | 53854: Make directory listings work correctly when aliases are used. (markt)

> Jasper

> > | 53713: Performance improvement of up to four times faster parsing of JSP pages. Patch provided by Sheldon Shao. (markt)

> Cluster

> > | Make the cluster members and the cluster deployer associated with the cluster accessible via JMX. (markt)
> > | Fix a behavior of TcpPingInterceptor#useThread. If set to false, ping thread is never started. (kfujino)

> Web applications

> > | Improve the documentation web application to clarify the difference between the tag and version parameters when using text interface of the Manager web application. (markt)
> > | Make sessions saved in the `Store` associated with a `Manager` that extends `PersistentManager` optionally visible (via the showProxySessions Servlet initialisation parameter in web.xml) to the Manager web application. (markt)

Tomcat 7.0.30 (markt) | released 2012-09-06

> Catalina

> > | Automatically delete temporary files used by Servlet 3.0 file upload (for parts which size is greater than `file-size-threshold` option in web.xml) when request processing completes. (kkolinko)
> > | 53071: This additional fix for this issue improves the formatting of Jasper errors (or any exceptions that use a multi-line message) with the `ErrorReportValve`. (markt)
> > | 53469: If a URL passed to `javax.servlet.http.HttpServletResponse.encodeURL()` cannot be made absolute, never encode it and return it unchanged. Previously, the fix for 53062 meant than an `IllegalArgumentException` was thrown. (markt)
> > | 53481: Added support for SSLHonorCipherOrder to allow the server to impose its cipher order on the client. Based on a patch provided by Marcel Šebek. This feature requires Tomcat Native 1.1.25 or later. (schultz)
> > | 53498: Fix atomicity bugs in use of concurrent collections. Based on a patch by Yu Lin. (markt)
> > | Correct a regression in the previous fix for 53062 that did not always correctly normalize redirect URLs when the redirect URL included a query string or fragment component. (markt)
> > | Add missing getter and setter for `roleSearchAsUser` option on JNDI Realm. (markt)
> > | Add some HTTP status codes registered at IANA. (rjung)
> > | 53531: Fix ExpandWar.expand to check the return value of File.mkdir and File.mkdirs. (schultz)
> > | 53535: Reduce memory footprint when performing class scanning on Context start. Patch provided by Cedomir Igaly. (markt)
> > | 53541: Fix JAR scanning when WEB-INF/lib is provided via VirtualDirContext. Patch provided by Philip Zuev. (markt)
> > | 53574: Ensure Servlets defined using jsp-file are available when metadata-complete is true. (markt)
> > | 53584: Ignore path parameters when comparing URIs for FORM authentication. This prevents users being prompted twice for passwords when logging in when session IDs are being encoded as path parameters. (markt)
> > | 53623: When performing a asynchronous dispatch after series of forwards, ensure that the request properties are correct for the request at each stage. (markt)
> > | 53624: Ensure that `HttpServletResponse.sendRedirect()` works when called after a dispatch from an `AsyncContext`. (markt)
> > | 53641: Correct name of HTTP header used in WebSocket handshake for listing the preferred protocols. (markt)
> > | Document the constants that were added to the `RequestDispatcher` interface in Servlet 3.0. (kkolinko)
> > | Ensure custom error pages are not truncated if the page that triggered the error set a content length header. (markt)
> > | 53677: Ensure that a 500 response rather than no response is returned if the HTTP headers exceed the size limit. (markt)
> > | 53702: When merging web.xml fragments, allow for `<jsp-property-group>` elements having multiple `<url-pattern>` elements. (markt)
> > | Always make the resulting web.xml available even if metadata-complete is true. (markt)
> > | 53714: Provide separate system properties to control which JARs are excluded from which scans when using the JarScanner. This allows JARs to be excluded from all scans or only from TLD scanning and/or Servlet 3.0 pluggability scanning. (markt)
> > | Add several JDK libraries to the value of `jarsToSkip` property in the `catalina.properties` file. (markt, kkolinko)
> > | Fix typos etc. in the code that logs merged web.xml (as enabled by `logEffectiveWebXml` option on Context). (kkolinko)
> > | 53758: When adding filters via `FilterRegistration.Dynamic` the filters were added at the wrong point because the `isMatchAfter` logic was inverted. (markt)
> > | 53783: Correctly handle JARs generated by tools that do not create specific entries for directories. Patch provided by Violeta Georgieva. (markt)
> > | Improvements to DIGEST authenticator including the disabling caching of authenticated user in session by default, tracking server rather than client nonces and better handling of stale nonce values. (markt)
> > | Improve performance of DIGEST authenticator for concurrent requests. (markt)
> > | CVE-2012-3546: Fix bypass of security constraint checks with FORM authentication. Remove unneeded processing in `RealmBase`. (kkolinko)
> > | 53800: `FileDirContext.list()` did not provide correct paths for subdirectories. Patch provided by Kevin Wooten. (kkolinko)
> > | 53801: Overlapping URL patterns were sometimes merged incorrectly in security constraints leading to incorrect 401 responses. Note: it was possible for access to be denied when it should have been granted but it was not possible for access to be granted when it should have been denied. (markt)

> Coyote

> > | Remove the `socket.soTrafficClass` from the BIO and NIO HTTP and AJP connectors because any use of the option is either ignored or in some cases (Java 7 with NIO) throws an Exception. (markt)
> > | Prevent possible NPE when processing Comet requests during Connector shutdown. (markt)
> > | 42181: Better handling of edge conditions in chunk header processing. (kkolinko)
> > | 53697: Correct a regression in the fix for 51881 that mean that in some circumstances the `comet` flag was not reset on `HttpAprProcessor` instances. This caused problems when the Processor was re-used for a new connection that would trigger a `NullPointerException` and could result in a JVM crash. (markt)
> > | 53725: Fix possible corruption of GZIP'd output. (markt/kkolinko)
> > | Better parsing of line-terminators for requests using chunked encoding. (markt)
> > | Further improvements to handling of Comet END events when the connector is stopped. (markt)

> Jasper

> > | 53545: Ensure buffered data is cleared when using a jsp:forward action inside a classic custom tag. (markt)
> > | 53654: Support `file://` URLs for JSP dependencies. Patch provided by Viola Lu. (markt)
> > | 53792: Support `MethodExpression`s that include a method invocation that is not at the end of the expression. (markt)

> Cluster

> > | Fix an issue when running under Java 7 which throws exceptions when trying to set an invalid option whereas Java 6 silently swallowed them. The option using the problem was `soTrafficClass`. Investigations showed that this option had no effect for Cluster Channel Receivers so it was removed. (markt)
> > | 53513: Fix race condition between the processing of session sync message and transfer complete message. (kfujino)

> Web applications

> > | Update JSTL version information in the JNDI section of the documentation web application. (markt)
> > | 53524: Correct a typo in the cluster how-to section of the documentation web application. Also fix a handful of spelling errors. (markt)
> > | 53601: Clarify in documentation that building Apache Tomcat 7 from sources requires a Java 6 JDK. (kkolinko)
> > | 53653: Allow for wrapped source code example in config/context.html. Patch provided by Terence Bandoian. (schultz)
> > | 53793: Change links on the list of applications in the Manager to point to '/appname/' instead of '/appname'. (kkolinko)

> Tribes

> > | Avoid potential NPE identified by Find Bugs in `org.apache.catalina.tribes.io.ReplicationStream`. (markt)
> > | 53606: Fix potential NPE in `TcpPingInterceptor`. Based on a patch by F. Arnoud. (markt)
> > | 53607: To avoid NPE, set TCP PING data to ChannelMessage. Patch provided by F.Arnoud (kfujino)

> Other

> > | 53701: Javadoc fixes. Patch provided by sebb. (markt)
> > | Remove some unused code from Tomcat's package renamed, cut-down copy of Commons BCEL used for annotation scanning. (markt)
> > | 53735: Add support for Java 7 byte code to Tomcat's package renamed, cut-down copy of Commons BCEL used for annotation scanning. (markt)

Tomcat 7.0.29 (markt) | released 2012-07-08

> Catalina

> > | Add support for searching for roles in JNDI/LDAP using another value than the actual DN or username specified. Rather it will use a value from the users directory entry. The new attribute introduced to the JNDIRealm is userRoleAttribute (fhanik)
> > | Fix checking of recommended tcnative library version when using the APR connector. (rjung)
> > | 50306: Improve StuckThreadDetectionValve: add stuckThreadNames property as a pair for the stuckThreadIds one, add thread ids to the log messages. (kkolinko)
> > | 52135: Add support for a default error page to be defined in web.xml by defining an error page with just a nested location element. It appears this feature was intended to be included in the Servlet 3.0 specification but was accidently left out. (markt)
> > | 53450: Correct regression in fix for 52999 that could easily trigger a deadlock when deploying a ROOT web application. (markt)
> > | As per section 1.6.2 of the Servlet 3.0 specification and clarification from the Servlet Expert Group, the servlet specification version declared in web.xml no longer controls if Tomcat scans for annotations. Annotation scanning is now always performed - regardless of the version declared in web.xml - unless metadata complete is set to true. (markt)
> > | 53619: As per clarification from the Servlet Expert Group, JARs will always be scanned for ServletContainerInitializers regardless of the setting of metadata complete. However, if an absolute ordering is specified and a JAR is excluded from that ordering it will not be scanned for ServletContainerInitializers nor will it be scanned for matches to any HandleTypes annotations. (markt)
> > | 53465: Populate mapped-name property for resources defined in web.xml. Based on a patch by Violeta Georgieva. (markt)
> > | Make the request available when establishing a WebSocket connection. (markt)
> > | 53467: Correct a regression in the fix for 53257 that introduced problems for JSPs that used characters that must be encoded if used in a URI. (markt)

> Coyote

> > | 53430: Avoid a JVM crash when a connector that requires the APR/native library is explicitly specified and the library, or a recent enough version of it, is not available. (markt)

> Jasper

> > | 53421: Provide a more helpful error message if a getter or setter cannot be found for a bean property when using expression language. (markt)
> > | 53460: Allow container to handle errors if the creation of the PageContext fails rather than swallowing the error. (markt)

> Web applications

> > | Update the WebSocket examples in the examples web application so that they work with secure connections (wss) as well as non-secure (ws) connections. (markt)
> > | 53456: Minor corrections and improvements to the HTTP connector configuration reference. Patch provided by sebb. (markt)
> > | 53459: Correction and clarifications to the SSL Connector configuration examples in the SSL how-to. (markt)
> > | 53464: Correct reference to sample init.d script for use with jsvc in the documentation web application. (markt)
> > | 53473: Correct the allowed values for the SSI option `isVirtualWebappRelative` which are `true` or `false`. (markt)
> > | Document `roleNested` property of `JNDIRealm` in Configuration Reference. (kkolinko)

> jdbc-pool

> > | 53445 (r1354173): Allow configurable name for SlowQueryReportJmx (fhanik)
> > | 53416 (r1354641): Multiple pools with the same name should register under JMX (fhanik)

> Other

> > | Fix cleanup of temporary files in `TestNamingContext` test. (kkolinko)
> > | Remove a few files from the source distribution that are not required since they are copied / generated during the build. (markt)
> > | Add manifest files to the set of files for which the line-ending is changed to match the OS defaults in the source distributions. (markt)
> > | Align Jk Ant tasks definitions between antlib.xml and catalina.tasks files, introducing `jkupdate` as synonym for `jkstatus`. The latter one is deprecated. Simplify `bin/catalina-tasks.xml`, replacing `taskdef` with `typedef` and adding Ant condition implementations used with JMX to `jmxaccessor.tasks` file. (kkolinko)
> > | 53454: Return correct content-length header for HEAD requests when content length is greater than 2GB. (markt)

Tomcat 7.0.28 (markt) | released 2012-06-19

> Catalina

> > | 52055: An additional fix to ensure that the ChunkedInputFilter is correctly recycled. (markt)
> > | 52954: Make DIGEST authentication tolerant of clients (mainly older Android implementations) that do not follow RFC 2617 exactly. (markt)
> > | 52955: Implement custom thread factory for container start-stop thread pool. It allows to use daemon threads and give them more distinct names. (kfujino)
> > | 52999: Remove synchronization bottleneck from the firing of `Container` events. (markt)
> > | 53008: Additional test cases for BASIC authentication and RFC2617 compliance. Patch provided by Brian Burch. (markt)
> > | 53021: Correct WebSocket protocol version detection. (pero)
> > | Add new attributes of `allow` and `deny` to UserConfig. (kfujino)
> > | 53024: Fix context reloading so requests received during the reload are paused and processed when reloading completes rather than receiving 404 responses. (markt)
> > | Improve the handling of watched resources so that changes trigger a reload rather than a stop followed by a start which allows requests received to be paused and processed when reloading completes rather than receiving 404 responses. (markt)
> > | Remove potential bottleneck on creation of new WebSocket connections. (markt)
> > | 53047: If a JDBC Realm or DataSource Realm is configured for an all roles mode that only requires authorization (and no roles) and no role table or column is defined, don't populate the Principal's roles. (markt)
> > | 53056: Add APR version number to tcnative version INFO log message. (schultz)
> > | 53057: Add OpenSSL version number INFO log message when initializing. (schultz)
> > | Save a bit of memory in annotations cache in `DefaultInstanceManager` by trimming annotation lists to their size. (kkolinko)
> > | Correctly configure the parser used to process server.xml so that external entities may be used to include the content of external files into server.xml. (markt)
> > | Make sure ContextMBean#findFilterDefs returns correct filter definitions. (kfujino)
> > | Ensure that `maxParameterCount` applies to multi-part requests handled via the Servlet 3 file upload API. (markt)
> > | 53062: When constructing absolute URLs for redirects from relative URLs ensure that the resulting URLs are normalized. (markt)
> > | 53067: Ensure the WebSocket Servlet continues to work when requests are wrapped. (markt)
> > | Enable host's xmlBase attribute in ContextConfig. (kfujino)
> > | 53071: Use the message from the throwable (if there is one) when generating the report in the `ErrorReportValve` and no message has been specified via `sendError()`. (markt)
> > | 53074: Switch to an infinite socket timeout by default for WebSocket connections. (markt)
> > | 53081: Do not always cache resources loaded by the web application class loader since they may be very large which in turn could trigger a memory leak. Calls to the web application class loader's `getResourceAsStream()` method will now access the resource directly rather than via the cache in most cases. (markt)
> > | 53090: Include superclasses when considering injection targets. Patch provided by Borislav Kapukaranov. (markt)
> > | 53161: Provide a better error message if a `ClassFormatException` occurs during annotation scanning and do not prevent the web application from starting in this case. (markt)
> > | 53180: Improve check for setter method when processing annotations. Patch provided by Violeta Georgieva. (markt)
> > | 53225: Fix an IllegalStateException due to the JAR file being closed when accessing static resources in a JAR file when `urlCacheProtection="false"` in the `JreMemoryLeakPreventionListener`. (markt)
> > | 53230: Changed ManagerBase to throw TooManyActiveSessionsException instead of IllegalStateException when the maximum number of sessions has been exceeded and a new session will not be created. (schultz)

> > 53257: Ensure that resources, including JSP files, that have names that include characters with special meanings in URLs (such as ampersand, semicolon, plus, hash and percent) are correctly handled. This bug is partially a regression caused by the original fix for 51584 and partially an existing issue that had not previously been identified. This fix reverts the original fix for 51584, correctly fixes that issue and fixes the additional issues identified by the test cases that were also added as part of this fix. (markt/kkolinko)

> > | 53266: If a class specified in a `@HandlesTypes` annotation on a `ServletContainerInitializer` is missing log a more helpful message and do not prevent the web application from starting. (markt)
> > | 53267: Ensure that using the GC Daemon Protection feature of the `JreMemoryLeakPreventionListener` does not trigger a full GC every hour. (markt)
> > | 53285: Do not require `security-role-ref` elements to contain a `role-link` element. (markt)
> > | 53301: Prevent double initialization of pre-created Servlet instances when used in embedded mode. (markt)
> > | 53322: When processing resource injection, correctly infer property name from its setter method if the name starts with several uppercase characters. (kkolinko)
> > | 53333: When processing JNDI resources, take account of the types of any specified injection targets to ensure that the resource definition and the injection target types are consistent. Based on a patch provided by Violeta Georgieva. (markt)
> > | 53337: Forwarding via a `RequestDispatcher` to an asynchronous Servlet always failed. Includes a test case based on code by Rossen Stoyanchev. (markt)
> > | 53339: Ensure WebSocket call backs (`onOpen` etc.) are called using the web application's class loader. (markt)
> > | 53342: To avoid BindException, make startStopThreads into a demon thread. (kfujino)
> > | 53353: Make the internal HTTP header parser more tolerant of Content-Type values that contain invalid parameters by ignoring the invalid parameters. It is a followup to bug 52811. (markt)
> > | 53354: Correctly handle `@WebFilter` annotations that do not include a mapping. (markt)
> > | 53356: Add support for servlets mapped explicitly to the context root of a web application. (markt)
> > | 53366: Ensure new HTTP header parser works correctly when running Tomcat under a security manager. (markt/kkolinko)
> > | 53368: Configure the default security policy to allow web applications to use WebSocket when running under a security manager. (markt/kkolinko)
> > | 53373: Allow whitespace around delimiters in <Context> aliases for readability. (schultz)

> Coyote

> > | 52858, CVE-2012-4534: Correct fix for high CPU load. (fhanik)
> > | 53138: Broken Sendfile on SSL introduced in 7.0.27 (fhanik)
> > | 52055: Additional fix required to ensure that `InputFilter`s are recycled between requests. (markt)
> > | 53061: Fix a problem in the NIO connector whereby if the poller was under low but consistent load (>1 request/per second and always less than 1 second between requests) timeouts never took place. (markt)
> > | 53063: When using an Executor with BIO, use the executor's maxThreads as the default for maxConnections. (markt)
> > | 53119: Prevent buffer overflow errors being reported when a client disconnects before the response has been fully written from an AJP connection using the APR/native connector. (markt)
> > | 53169: Allow developers to avoid chunked encoding for a response of unknown length by setting the `Connection: close` header. Based on a patch suggested by Philippe Marschall. (markt)
> > | 53173: Properly count down maxConnections (fhanik)
> > | Update default value of pollerThreadCount for the NIO connector. The new default value will never go above 2 regardless of available processors. (fhanik)
> > | Allow to retrieve the current `connectionCount` via getter from the endpoint and as JMX attribute of the ThreadPool mbean. (rjung)
> > | Correct an edge case where Comet END events were not send to connected clients when the Tomcat connector was stopped. (markt)
> > | 53406: Fix possible stack overflow on connection close when using Comet. (fhanik)
> > | Improve `InternalNioInputBuffer.parseHeaders()`. (kkolinko)
> > | Implement `maxHeaderCount` attribute on Connector. It is equivalent of LimitRequestFields directive of Apache HTTPD. Default value is 100. (kkolinko)

> Jasper

> > | 48097#c7, 53366#c1: If JSP page unexpectedly fails to initialize PageContext instance, write exception to the logs instead of silent swallowing. (kkolinko)
> > | 53032: Modify `JspC` so it extends `org.apache.tools.ant.Task` enabling it to work with features such as namespaces within build.xml files. (markt)

> Cluster

> > | Avoid NPE when reload if a state of a BackupManager is FAILED. (kfujino)
> > | 53087: In order to avoid that a backup node expire a session, replicate session access time in BackupManager. (kfujino)
> > | Add support for SecureRandom to cluster manager template. (kfujino)

> Web applications

> > | Remove obsolete bug warning from Windows service documentation page. (rjung)
> > | 50182: Various improvements to the Compression Filter. Patch provided by David Becker. (markt)
> > | 52853: Clarify how Jar Scanner handles directories. (markt)
> > | 53158: Fix documented defaults for DBCP. Patch provided by ph.dezanneau at gmail.com. (rjung)
> > | 53203: Correct documentation for the default value of `connectionTimeout` attribute for AJP protocol connectors. (kkolinko)
> > | 53289: Clarify `ResourceLink` example that uses DataSource.getConnection(username, password) method. Not all data source implementations support it. (kkolinko)
> > | Fix several HTML markup errors in servlets of examples web application. (kkolinko)
> > | 53398: Correct spelling of "received" in the Manager application's XML output. (markt)
> > | 53403: Update a reference to the Servlet specification in the first web application section of the documentation web application to include newer versions of the specification. (markt)

> jdbc-pool

> > | 50864 (r1311844): JMX enable most pool properties (fhanik)
> > | 53254 (r1340160): Add in the ability to purge connections from the pool (fhanik)
> > | 53367 (r1346691): Prevent pool from hanging during database failure (fhanik)
> > | When a connection is reconnected due to failed validation make sure the ConnectionState is reset or it will assume incorrect values (fhanik)
> > | 53374 (r1348056): Add support for the following properties in DataSourceFactory: `commitOnReturn`, `rollbackOnReturn`, `useDisposableConnectionFacade`, `logValidationErrors` and `propagateInterruptState`. Based on patch proposed by Suresh Avadhanula. (kkolinko)

> Other

> > | Update to Eclipse JDT Compiler 3.7.2 at maven tomcat-jasper.pom. (pero)
> > | Update the native component of the Tomcat APR/native connector to 1.1.24. (markt)
> > | Add missing dependencies in pom files. (markt)
> > | 53034: Add `project.url` and `project.licenses` sections to the POMs for the Maven artifacts. (markt)
> > | Properly mention `jsp_2_2.xsd` in the main LICENSE and INSTALLLICENSE files. (kkolinko)
> > | 53115: Fix using the command "`catalina.bat run`" when the value of `%TEMP%` contains spaces. (kkolinko)
> > | Add dependencies and description to "validate" target in `build.xml`, so that it could be run separately. Improve `BUILDING.txt` and `RUNNING.txt`. (kkolinko)

Tomcat 7.0.27 (markt) | released 2012-04-05

> Catalina

> > | Explicitly ignore empty path values in `virtualClasspath` attribute of `VirtualWebappLoader` class. Document that whitespace around the values is trimmed. Reformat documentation examples to make them more readable. (kkolinko)
> > | Further improve fix for 51197 to allow an error reporting Valve to write a response body if `sendError()` is called during an asynchronous request on a container thread. (markt)
> > | Correct fix for 51741 (r1307600): If `VirtualDirContext` class is configured with non-empty value of `extraResourcePaths` option (a feature added in 7.0.24), do not implicitly set `allowLinking` option to the value of `true`. If it is really needed, it should be set explicitly. (kkolinko)
> > | 52500: Added configurable mechanism to retrieve user names from X509 client certificates. Based on a patch provided by Michael Furman. (schultz)
> > | 52719: Fix a theoretical resource leak in the JAR validation that checks for non-permitted classes in web application JARs. (markt)
> > | Code clean-up identified by 52723, 52724, 52726, 52727, 52729, 52731 and 52732. (markt)
> > | 52792: Improve error message when a JNDI resource can not be found. (markt)
> > | 52811: Fix parsing of Content-Type header in `HttpServletResponse.setContentType()`. Introduces a new HTTP header parser that follows RFC2616. (markt/kkolinko)
> > | 52830: Correct JNDI lookups when using `javax.naming.Name` to identify the resource rather than a `java.lang.String`. (markt)
> > | 52833: Handle the case where the parent class loader for the Catalina object does not have the system class loader in its hierarchy. This may happen when embedding. Patch provided by olamy. (markt)
> > | 52839: Add a unit test for DigestAuthenticator and SingleSignOn. Patch provide by Brian Burch. (markt)
> > | 52846: Make sure NonLoginAuthenticator registers not MemoryUser but GenericPrincipal into a session when UserDatabaseRealm is used. (kfujino)
> > | 52850: Extend memory leak prevention and detection code to work with IBM as well as Oracle JVMs. Extend unit tests to check direct and indirect ThreadLocal memory leak detection. Based on a patch provided by Rohit Kelapure. (markt)

> > Add support for the WebSocket protocol (RFC6455). Both streaming and message based APIs are provided and the implementation currently fully passes the Autobahn test suite. Also included are several examples. A significant contribution to this new functionality was provided by Johno Crawford — particularly the examples. Contributions were also provided by Petr Praus, Jonathan Drake & Slávka. (markt)

> > | When stopping a Context, ensure that any Servlets registered with JMX are unregistered. (markt)
> > | Make the implementation of `Catalina.getParentClassLoader` consistent with similar methods across the code base and have it return the system class loader if no parent class loader is set. (markt)
> > | 52953: Ensure users can authenticate when using DIGEST authentication with digested passwords if the digested password is stored using upper case hexadecimal characters since DIGEST authentication expects digests to use lower case characters. Based on a patch provided by Neale Rudd. (markt)
> > | 52957: Ensure that a Valve implements Lifecycle before calling any Lifecycle methods on that Valve. (markt)
> > | 52958: Fix MBean descriptors for `org.apache.catalina.realm` package. (markt)
> > | 52974: Fix `NameNotFoundException` when field/method is annotated with `@Resource` annotation. Patch provided by Violet Agg. (markt)
> > | Add support for multi-thread deployment in UserConfig. (kfujino)

> Coyote

> > | Correctly register NIO sockets with poller after processing Comet events to ensure that no read events are missed. This fixes an intermittent issue observed in the unit tests. (fhanik/markt)
> > | 52770: Fix a bug in the highly unlikely circumstance that an infinite timeout was specified for writing data to a client when using NIO. (markt)
> > | 52858: Fix high CPU load with SSL, NIO and sendfile when client breaks the connection before reading all the requested data. (markt)
> > | 52926: Avoid NPE when an NIO Comet connection times out on one thread at the same time as it is closed on another thread. (markt)
> > | Include port number when known in connector name when logging messages from connectors that use automatic free port allocation. (markt)
> > | Don't try an unlock the acceptor thread if it is not locked. This is unlikely to impact normal usage but it does fix some unit test issues. (markt)
> > | When using the APR connector ensure that any connections in a keep-alive state are closed when the connector is stopped rather than when the connector is destroyed. This is important when stop() followed by start() is called on the connector. (markt)

> Jasper

> > | 52725: Use configurable package name for tags rather than hard-coded value so configuration actually works. (markt)
> > | 52758: Implement additional interface methods in Eclipse JDT integration required for Jasper to correctly with the latest Eclipse development code. (markt)
> > | 52772: Ensure uriRoot is fully validated before it is used. Patch based on a suggestion by Eugene Chung. (markt)
> > | 52776: Refactor the code so JspFragment.invoke cleans up after itself. Patch provided by Karl von Randow. (markt)
> > | 52970: Take account of coercion rules when invoking methods via EL. (markt)
> > | 52998: Partial fix. Remove static references to the EL expression factory and use per web application references instead. (markt)
> > | 52998: Remainder of fix. Cache the class to use for the EL expression factory per class loader. (kkolinko)
> > | 53001: Revert the fix for 46915 since the use case described in the bug is invalid since it breaks the EL specification. (markt)

> Cluster

> > | Replicate principal in ClusterSingleSignOn. (kfujino)

> Web applications

> > | 52760: Fix expires filter mime type in javascript examples. (rjung)
> > | 52842: Exception in MBeanDumper when dumping MBean for StandardThreadExecutor. (rjung)
> > | Bring built-in mime types for embedded Tomcat more in line with the ones defined in the default web.xml configuration file. (rjung)
> > | Add support to the JMXProxyServlet which is part of the Manager application for fetching a specific key from a `CompositeData` value. Updated documentation, so that the entire 'get' command for the JMX proxy servlet is documented, including the new optional 'key' parameter. (schultz/markt)

> jdbc-pool

> > | Pool cleaner thread should be created using the classloader that loaded the pool, not the context loader (fhanik)
> > | 52804: Make pool properties serializable and cloneable. (fhanik)
> > | 51237 (r1302902): Slow Query Report should log using WARN level when queries are slow and within the threshold of caching it. (fhanik)
> > | 52002 (r1302948): Add in configuration option to disallow connection reuse. (r1305862): useDisposableConnectionFacade is by default enabled (fhanik)
> > | 52493 (r1302969): Java 7 DataSource method addition. (fhanik)
> > | 51893 (r1302990): Throw an error and notification when pool is exhausted. (fhanik)
> > | 50860 (r1303031): Add in option to configure logging for validation errors. (fhanik)
> > | 52066 (r1305931): Add in configuration option, progagateInterruptState, to allow threads to retain the interrupt state. (fhanik)

> Other

> > | 52750: Fix the way how daemon.sh parses command options so that more then one can be provided. (mturk)
> > | Rearrange `validate-eoln` target in `build.xml` so that it could be run ahead of compilation. (kkolinko)
> > | Update Apache Commons Daemon to 1.0.10. (mturk)
> > | Update the native component of the Tomcat APR/native connector to 1.1.23 and take advantage of the simplified distribution. (mturk)
> > | Update to Eclipse JDT Compiler 3.7.2. (markt)

Tomcat 7.0.26 (markt) | released 2012-02-21

> Catalina

> > | Provide constants for commonly used `Charset` objects and use these constants where appropriate. (markt)
> > | Refactor the fix for 52184 to correct two issues (a missing class and incorrect class/method names) when using the extras logging packages. (markt)
> > | 52444: Only load classes during HandlesTypes processing if the class is a match. Previously, every class in the web application was loaded regardless of whether it was a match or not. (markt)
> > | 52488: Correct typo: exipre -> expire. (markt)
> > | Add a unit test for SSO authentication. Patch provided by Brian Burch. (markt)
> > | 52511: Correct regression in the fix for 51741 that caused a harmless exception to be logged when scanning for annotations and `WEB-INF/classes` did not exist. (markt)
> > | Refactor to remove a circular dependency between `org.apache.catalina` and `org.apache.naming`. (markt)
> > | Remove some initialisation code from the standard start process (i.e. via the scripts) that was intended for embedding but is not required when performing a standard start.(markt)
> > | Add new method to `MBeanFactory` that allows any Valve to be created and deprecate the methods to create specific Valves. (markt)
> > | Partial sync of MIME type mapping with mime.types from the Apache web server. (rjung)
> > | 52577: Fix a regression in the fix for 52328. Prevent output truncation when `reset()` is called on a response. (markt)
> > | 52586: Remove an old and now unnecessary hack that modified the path info reported via the `javax.servlet.forward.path_info` request attribute when forwarding to an error page. (markt)
> > | 52587: Ensure that if it is necessary to fall back to the default NullRealm, the NullRealm instance is created early enough for it to be correctly initialised. (markt)
> > | Fix millisecond output in AccessLogValve when using a SimpleDateFormat based time pattern. (rjung)
> > | 52591: When dumping MBean data, skip attributes where getters throw `UnsupportedOperationException`. (markt)
> > | 52607: Ensure that the extension validator checks the JARs in the shared and common class loaders for extensions. (markt)
> > | Correct a threading issue in the generation of the list of standard authenticators during Context initialization that could lead to a web application failing to start if Contexts were started in parallel. (markt)
> > | 52669: Correct regression that broke annotation processing in `/WEB-INF/classes` for web applications deployed as WARs, packageless classes and some embedding scenarios. The regression was introduced by the invalid assumptions made in the fix for 51741. (markt)
> > | 52671: When dumping MBean data, skip attributes where getters throw `NullPointerException`. (markt)

> Coyote

> > | 51543: Provide a meaningful error message when writing more response headers than permitted. (markt)
> > | 52547: Ensure that bytes written (which is used by the access log) is correctly reset after an HTTP 1.0 request has been processed. (markt)
> > | Minor refactoring to reduce code duplication in the HTTP connectors. (markt)
> > | 52606: Ensure that POST bodies are available for reply after FORM authentication when using the AJP connectors. (markt)

> Jasper

> > | 52474: Ensure that leading and trailing white space is removed from listener class names when parsing TLD files. (markt)
> > | 52480: When converting class path entries from URLs to files/directories, ensure that any URL encoded characters are converted. Fixes JSP compilation with javac when Tomcat is installed at a path that includes spaces. (markt)
> > | 52666: Correct coercion order in EL when processing the equality and inequality operators. (markt)

> Web applications

> > | Improve `BUILDING.txt`. Update instructions for building. Add instructions for using Checkstyle and running the tests. (kkolinko)
> > | 38216: Improve handling of `null` return values in the JMX proxy servlet which is part of the Manager application. (kkolinko)
> > | 52515: Make it clear in the Realm how-to in the documentation web application that digested password storage when using DIGEST authentication requires that MD5 digests are used. (markt)
> > | 52634: Fix typos in JSP examples. Patch provided by Felix Schumacher. (rjung)
> > | 52641: Remove mentioning of ldap.jar from docs. Patch provided by Felix Schumacher. (rjung)

> jdbc-pool

> > | Fix code style issues and enable Checkstyle checks for jdbc-pool when it is built within Tomcat. (kkolinko)
> > | 51582 Correct set and reset the query cache to avoid NPE (fhanik)

> Other

> > | Update Commons Daemon to 1.0.9 to resolve 52548 which meant that services created with service.bat did not set the `catalina.home` and `catalina.base` system properties. (markt)
> > | Implement check for correct end-of-line characters in the source files. It is run as separate target in `build.xml`. (kkolinko)

Tomcat 7.0.25 (markt) | released 2012-01-21

> Web applications

> > | Restore format of the first line of error message for JMX proxy servlet in case scripts were depending on it. (markt)

> Other

> > | When building a Windows installer do not copy whole "res" folder to output/dist, but only the files that we need. Apply fixcrlf filter only after the files are copied, so that `INSTALLLICENSE` file had correct line ends. (kkolinko)
> > | Remove `res/License.rtf`. The file that is actually shown by the Windows installer is `res/INSTALLLICENSE`. (kkolinko)
> > | Automate the OpenPGP signature generation for the release process. (markt)
> > | Don't exclude directories named target from the build process. (rjung)

Tomcat 7.0.24 (markt) | not released

> Catalina

> > | 52184: Provide greater control over the logging of errors triggered by invalid input data (i.e. data over which Tomcat has no control). (markt/kkolinko)
> > | 52225: Fix ClassCastException in an Alias added to existing host through JMX. (kkolinko)
> > | Do not throw IllegalArgumentException from parseParameters() call when chunked POST request is too large, but treat it like an IO error. The `FailedRequestFilter` filter can be used to detect this condition. (kkolinko)
> > | 52245: Don't allow web applications to package classes from the `javax.el` package. Patch provided by pid. (markt)
> > | 52259: Fix regression caused by the addition of the threaded component start (46264) that triggered a deadlock on startup if no Realm was configured. (markt)
> > | 52293: Correctly handle the case when `antiResourceLocking` is enabled at the Context level when `unpackWARs` is disabled at the Host level. Based on a patch by Justin Miller. (markt)
> > | In `ExtendedAccessLogValve` when printing %-encoded value of a parameter, use UTF-8 encoding to convert parameter value to bytes instead of platform default encoding. (markt/kkolinko)
> > | 52303: Allow web applications that do not have a login configuration to participate in a SSO session. Patch provided by Brian Burch. (markt)
> > | 52316: When using sendfile, use the number of bytes requested to be written to the response in the access log valve for bytes written rather than recording a value of zero. (markt)
> > | 52326: Reduce log level for class loading errors during `@HandlesTypes` processing to debug. (markt)
> > | 52328: Improve performance when large numbers of single characters and/or small strings are written to the response via a Writer. (markt)
> > | 52384: Do not fail with parameter parsing when debug logging is enabled. (kkolinko)
> > | Do not flag extra '&' characters in parameters as parse errors. (kkolinko)
> > | Reduce log level for the message about hitting `maxParameterCount` limit from WARN to INFO. (kkolinko)
> > | 52387: Ensure that the correct host is used when configuring logging when Tomcat is embedded. Patch provided by David Calavera. (markt)
> > | 52405: Align the Servlet 3.0 implementation with the changes defined in the first maintenance release (also know as Rev. A). See the JCP documentation for a detailed list of changes (markt)
> > | Improve JMX names for objects related to Connectors that have the address attribute set. (markt)
> > | Remove some stale attributes from MBeans. (rjung)
> > | Move destruction of `ContainerBase` objects to `ContainerBase` to ensure that they are destroyed. (markt)
> > | 52443: Change the behaviour of the default Realm in the embedded use case so it is set once on the Engine rather than on every Context thereby avoiding the Lifecycle issues with having the same Realm set on multiple Contexts. (markt)
> > | Provide a new Realm implementation, the NullRealm, that does not contain any users and is used as the default Realm implementation (rather than the JAAS Realm which was used prior to this change) if no Realm is specified. (markt)
> > | 52461: Don't assume file based URLs when checking last modified times for global and host level web.xml files. Patch provided by violetagg. (markt)
> > | Add test cases for the BASIC and NonLogin Authenticators when not using SSO. Patch provided by Brian Burch. (markt)

> Coyote

> > | 52028: Add support for automatic binding to a free port by a connector if the special value of zero is used for the port. This is mainly useful in embedded and testing scenarios. (markt)
> > | Remove obsolete `emptySessionPath` JMX attribute. (rjung)
> > | Correct error in fix for 49683. (markt)
> > | Ensure that the process of unlocking the acceptor thread does not trigger processing of the connection as if it were a valid request. (markt)

> Jasper

> > | 52450: Add setter for entityResolver in ParserUtils. This is mainly useful when jasper and dtds are in different class loaders. (mturk)
> > | 52321: Ensure that the order of multiple prelude/coda values for JSP pages is respected. (markt)
> > | 52335: Only handle `<\%` and not `\%` as escaped in template text. (markt)
> > | 52440: Ensure that when using `ValueExpression.getValueReference()` if the expression is an EL variable that the value returned is the `ValueReference` for the `ValueExpression` associated with the EL variable. (markt)
> > | 52445: Don't assume that EL method expressions have exactly three components (identifier, method name, parameters). (markt)

> Web applications

> > | 38216: Add the ability to invoke MBean operations to the JMX proxy servlet in the Manager application. Based on a patch by Christopher Hlubek. (markt)
> > | Further clarify the relation between values used by `RemoteIpValve` and `RemoteIpFilter` and their use by `AccessLogValve`. (kkolinko)
> > | 52243: Improve windows service documentation to clarify how to include `#` and/or `;` in the value of an environment variable that is passed to the service. (markt)
> > | 52366: Fix typo in VirtualWebappLoader documentation (configuration example). (rjung)
> > | Replace Bugzilla search link on `ROOT/index.jsp` page with one pointing to the bug reporting page of Tomcat site. (kkolinko)
> > | Move MBean dump code from JMXProxyServlet into a utility class. (rjung)

> Tribes

> > | 52208: Fix threading issue that may lead to harmless NPE during shutdown that has occasionally been observed when running the unit tests. (markt)
> > | 52213, 52354, 52355 and 52356: Fix some potential concurrency issues in `FastQueue`. (markt)

> jdbc-pool

> > | r1207712: Pool cleaner should be a global thread, not spawn one thread per connection pool. (fhanik)

> Other

> > | Update Apache Commons Daemon to 1.0.8. (mturk)
> > | Update Apache Commons Pool to 1.5.7. (kkolinko)
> > | Fix line ends in `.gitignore` files contained in source distributions. (rjung)
> > | Run Mapper performance test twice if the first run took too long, to ignore occasional failures. (kkolinko)
> > | Align `.gitignore` and `build.xml` exclude patterns with `svn:ignore`. (kkolinko)
> > | Configure `defaultexcludes` for Ant 1.8.1/1.8.2. The `.git` and `.gitignore` patterns are in since Ant 1.8.2, but we include `.gitignore` in src distributions. (kkolinko)
> > | 52237: Allow JUnit logs to be generated in formats other than plain text. Patch provided by M Hasko. (markt/kkolinko)
> > | Fix build condition for tomcat-dbcp to always rebuild when a new version of commons-pool or commons-dbcp is downloaded. (kkolinko)
> > | Add example of configuration for `SetCharacterEncodingFilter` to the default `web.xml` file. (kkolinko)
> > | Switch unit tests to bind Connectors to localhost rather than all available IP addresses. (markt)
> > | Update to Eclipse JDT Compiler 3.7.1. (markt)
> > | Add Netbeans `nbproject` folder to `svn:ignore` and `.gitignore`. (rjung)
> > | Align `.gitignore` with trunk. (rjung)

Tomcat 7.0.23 (markt) | released 2011-11-25

> Catalina

> > | 46264: Add the ability to start and stop containers (primarily Contexts) using a thread pool rather than a single thread. This can significantly improve start and stop time. Based on patches by Joe Kislo and Felix Schumacher. (markt)
> > | 50570: Enable FIPS mode to be set in AprLifecycleListener. Based upon a patch from Chris Beckey. (schultz/kkolinko)
> > | 51744: Throw the correct exception if an application attempts to modify the associated JNDI context. (markt)
> > | 51744: Add an option to the StandardContext that allows exception throwing when an application attempts to modify the associated JNDI context to be disabled. (markt)
> > | 51910: Prevent NPE on connector stop if Comet applications are being used without the CometConnectionManagerValve. (markt)
> > | 51940: Do not limit saving of request bodies during FORM authentication to POST requests since any HTTP method may include a request body. Based on a patch by Nicholas Sushkin. (markt/kkolinko)
> > | 51956: RemoteAddrFilter used getRemoteHost instead of getRemoteAddr when filtering Comet events. (schultz)
> > | 51952: Make the inclusion of a response body with a redirect response introduced to address 41718 optional and disabled by default due to the side-effects of including a body with the response in this case. (markt)
> > | 51972: Correctly handle protocol relative URLs when used with `sendRedirect()`. (markt)
> > | Simplify the deployment code and use full paths in log messages to remove any ambiguity in where a context is being deployed from. (markt)
> > | 52009: Fix a NPE during access log entry recording when an error occurred during the processing of a Comet request. (markt)
> > | In `OneLineFormatter` log formatter in JULI always use the US locale to format the date (esp. the month names). (rjung)
> > | Cache the results of parsing the global and host level web.xml files to improve web application start time. (markt)
> > | 52042: Correct threading issue in annotation caching that could lead to an NPE if multiple threads were processing the same class hierarchy for annotations. (markt)
> > | Correct additional threading and premature clearance issues with the annotation cache. (markt)
> > | Correct a regression in the fix for 49779 that parameters POSTed by an unauthenticated user to a page that required FORM authentication were lost during the authentication process. (markt)
> > | 52055: Ensure that the input and output buffers are correctly reset between keep-alive requests when using Servlet 3.0 asynchronous request processing. (markt)
> > | Ensure changes to the configuration of the RemoteHostValve and the RemoteAddrValve via JMX are thread-safe. (markt)
> > | Ensure that the memory leak protection for the HttpClient keep-alive always operates even if the thread has already stopped. (markt)
> > | Remove the Java 1.2 specific error handling around the adding of the shutdown hook. (markt)
> > | Correct errors in i18n resources and resource usage that meant some messages were either not used or were incorrectly formatted. (markt)
> > | Replace the use of deprecated auth method names from `authenticator.Constants` with the auth method names from `HttpServletRequest`. (kkolinko)
> > | Make configuration issues for security related Valves and Filters result in the failure of the valve or filter rather than just a warning message. (markt)
> > | Improve performance of parameter processing for GET and POST requests. Also add an option to limit the maximum number of parameters processed per request. This defaults to 10000. Excessive parameters are ignored. Note that `FailedRequestFilter` can be used to reject the request if some parameters were ignored. (markt/kkolinko)
> > | 52091: Address performance issues related to lock contention in StandardWrapper. Patch provided by Taiki Sugawara. (markt)
> > | Switch to using Collections.enumeration() rather than custom code that does the same thing. (markt)
> > | 52113: Don't assume presence of context.xml file with JMX deployment. (markt)
> > | In `RequestFilterValve` (`RemoteAddrValve`, `RemoteHostValve`): refactor value matching logic into separate method and expose this new method `isAllowed` through JMX. (kkolinko)
> > | 52156: Ensure that `getServletContext().getResource(path)` returns the correct resource when path contains `/../` sequences or any other sequences that require normalization. (markt)
> > | Report existence of HTTP request parameter parsing errors via new special ServletRequest attribute, `org.apache.catalina.parameter_parse_failed`. (kkolinko)
> > | New filter `FailedRequestFilter` that will reject a request if there were errors during HTTP parameter parsing. (kkolinko)
> > | Improve special attributes handling in Request object by using hash table lookup instead of series of string comparisons. (kkolinko)
> > | Deprecate unused methods in `IntrospectionUtils` class. (kkolinko)
> > | Improve processing of errors that are wrapped in `InvocationTargetException`. Rethrow fatal errors that must be rethrown. (kkolinko)

> > Improve handling of failed web application deployments during automatic deployment. Once deployment of a web application fails in one form (e.g. WAR), no further attempt (e.g. directory) will be made to deploy that web application. The base Lifecycle implementation has been improved to allow failed web applications to be started once the configuration issues have been resolved. Any changes to a context.xml file (global, per host or web application specific) will now result in a redeploy of the affected web application(s) that ensures that any changes are correctly applied rather than a reload which ignores changes in context.xml files. (markt/kkolinko)

> > | 52173: Improve Javadoc for `delegate` attribute of WebappClassLoader. Based on a patch by bmargulies. (markt)
> > | Add `denyStatus` attribute to `RequestFilterValve` (`RemoteAddrValve`, `RemoteHostValve` valves) and `RequestFilter` (`RemoteAddrFilter`, `RemoteHostFilter` filters). It allows to use different HTTP response code when rejecting denied request. E.g. 404 instead of 403. (kkolinko)
> > | Slightly improve performance of UDecoder.convert(). Align `%2f` handling between implementations. (kkolinko)

> Coyote

> > | 51881: Correctly complete Comet requests when the Comet END event is triggered asynchronously. (markt)
> > | 51905: Fix infinite loop in AprEndpoint shutdown if acceptor unlock fails. Reduce timeout before forcefully closing the socket from 30s to 10s. (kkolinko)
> > | 51912: Fix HTTP header processing in NIO HTTP connector. (kkolinko)
> > | Improve MimeHeaders.toString(). (kkolinko)
> > | Fix threading issue in NIO connectors during shutdown that meant Comet connections were not always shut down cleanly. (markt)
> > | In HTTP connectors: self-guard against using a non-recycled input buffer. Requests will be rejected with response status 400. (kkolinko)
> > | 52121: Fix possible output corruption when compression is enabled for a connector and the response is flushed. Includes a test case provided by David Marcks. (kkolinko/markt)
> > | Improve multi-byte character handling in Coyote output for HTTP and AJP. (rjung)
> > | Refactor acceptor unlock code to reduce waiting time during connector pause and stop. (markt)

> Jasper

> > | Correct possible (but very small) memory leak when using maxLoadedJsps to limit the number of JSPs loaded at any one time. (markt)
> > | 52051: Better handling of missing resource problems with non-standard Servlet mappings so that a 404 response is returned to the client rather than a 500 response. (markt)
> > | 52091: Address performance issues related to log creation in TagHandlerPool. Patch provided by Taiki Sugawara. (markt)
> > | Switch to using Collections.enumeration() rather than custom code that does the same thing. (markt)

> Cluster

> > | Avoid an unnecessary session ID change notice. Notice of changed session ID by JvmRouteBinderValve is unnecessary to BackupManager. In BackupManager, change of session ID is replicated by the call of a setId() method. (kfujino)
> > | Fix duplicate `resetDeltaRequest()` call in `DeltaSession.setId(String)`. (kkolinko)
> > | Work around a known JVM bug that is fixed in 1.7.0_01 but still present in 1.6.0_29 and was triggering intermittent unit test failure for `org.apache.catalina.tribes.group. TestGroupChannelMemberArrival.testMemberArrival`. The bug affects any components that use NIO although it was more likely to be observed in the clustering module than the HTTP or AJP NIO connector. (markt)
> > | When Context manager does not exist, no context manager message is replied in order to avoid timeout (default 60sec) of GET_ALL_SESSIONS sync phase. (kfujino)
> > | Fix setting maxInactiveInterval, sessionIdLength and processExpiresFrequency for cluster managers. Use setter when setting maxActiveSessions. (rjung)

> Web applications

> > | 50923: Use distinct background color for `code` tag in Tomcat documentation, for better readability. (kkolinko)
> > | 51630: Fix bug in async0 example that triggered an IllegalStateException in the application log. (markt)
> > | 52025: Add additional information regarding DriverManager, the service provider mechanism and memory leaks. (markt)
> > | 52049: Improve setup instructions for running as a Windows service: remove references to specific Windows operating systems - it easily becomes dated; correct information on how a JRE is identified and selected. (markt)
> > | 52172: Clarify Tomcat build instructions. Patch provided by bmargulies. (kkolinko)

> jdbc-pool

> > | 52015: In jdbc-pool: JdbcInterceptor passes not 'this' but 'proxy' to `getNext().invoke`. (kfujino)
> > | In jdbc-pool: Improve handling of Errors that originate from methods invoked through reflection. In `TrapException` interceptor: rethrow Error as is, without wrapping it in a RuntimeException. (kkolinko)
> > | In jdbc-pool: Unwrap InvocationTargetException if it is caught in `ResultSetProxy`, like we do it elsewhere. (kkolinko)
> > | When building jdbc-pool from within Tomcat, use Tomcat's `output` directory location. This allows to move all build output away from the source tree. (kkolinko)

> Other

> > | Update the package re-named copy of Commons BCEL (formerly Jakarta BCEL) to the latest code from Commons BCEL trunk. (markt)
> > | Remove some unused code from the packaged renamed Commons BCEL. (markt)
> > | 52059: In Windows uninstaller: Do not forget to remove Tomcat keys from 32-bit registry on deinstallation. (kkolinko)
> > | Start the process of deprecating unused and unnecessary code that will be removed in the next major release (8.0.x). (markt)
> > | Ignore `.git` directory when building the source distributive. (markt)
> > | Remove trailing whitespace from the default configuration files. (kkolinko)
> > | Improve `RUNNING.txt`. (kkolinko)
> > | Update optional Checkstyle library to 5.5. (kkolinko)
> > | In test suite: add `LoggingBaseTest` class to allow use of Tomcat logging configuration in tests that do not start Tomcat. (kkolinko)
> > | In test suite: speed up `TestGroupChannelSenderConnections`. Remove 48 seconds worth of waits. (kkolinko)
> > | 52148: Add tomcat-coyote.jar to catalina-tasks.xml as this JAR is now required by the Ant tasks. Patch provided by Volker Krebs. (markt)
> > | Add sample Apache Commons Daemon JSVC wrapper script `bin/daemon.sh` that can be used with `/etc/init.d`. (mturk)

Tomcat 7.0.22 (markt) | released 2011-10-01

> Catalina

> > | 51550: An additional change that ensures any exceptions thrown by an Authenticator (or any other Valve configured for the Context) will be handled by the custom error pages for the Context if an appropriate error page is configured. (markt)
> > | 51580: Added a nicer error message when a WAR file contains filenames not properly encoded in UTF-8. (schultz)
> > | 51687: Added (optional) protection against sun.java2d.Disposer thread pinning a WebappClassLoader into memory in the JreMemoryLeakPreventionListener. (schultz)
> > | 51741: Fixes a problem with Eclipse WTP "Serve modules without publishing" feature where applications failed to access resources when using getResource() on the classloader. (slaurent)
> > | 51744: Prevent application code from closing the associated JNDI context while the application is running. (markt)
> > | Correct a regression with the fix for 51653 that broke custom error pages for 4xx responses from the Authenticators. Error handling and request listeners are now handled in the StandardHostValve to ensure they wrap all Context level activity. (markt)
> > | 51758: The digester (used for processing XML files) used the logger name `org.apache.commons.digester.Digester` rather than the expected `org.apache.tomcat.util.digester.Digester`. The digester has been changed to use the expected logger name. (markt/kkolinko)
> > | 51774: Fix incorrect cached method signature that prevented session tracking modes from being defined in web.xml when running under a security manager. (markt)
> > | Add an annotation cache to the `DefaultInstanceManager` that improves performance for applications that make use of a lot of non-poolable objects (e.g. tag files) that need to be scanned for annotations when created. (markt)
> > | Use the specification compliant request attribute of `javax.servlet.request.ssl_session_id` to access the SSL session ID and deprecated the Tomcat specific request attribute. (markt)
> > | Allow to overwrite the check for distributability of session attributes by session implementations. (rjung)
> > | Add Java 7 sunec.jar and zipfs.jar to the list of JARs to skip when scanning for TLDs and web fragments. (rjung)
> > | 51862: Added a `classesToInitialize` attribute to `JreMemoryLeakPreventionListener` to allow pre-loading of configurable classes to avoid some classloader leaks. (slaurent)
> > | Reduce visibility of static field `ManagerBase.name` and make it final. (kkolinko)
> > | Add thread name to juli OneLineFormatter. (rjung)
> > | Ensure Servlets that implement ContainerServlet always get treated as restricted. (markt)
> > | 51872: Ensure that the access log always uses the correct value for the remote IP address associated with the request and that requests with multiple errors do not result in multiple entries in the access log. (markt)

> Coyote

> > | Remove unused and undocumented socketCloseDelay attribute from NIO connector. (markt)
> > | 49683: Support separate connection and keep-alive timeouts for the APR/native connector HTTP and AJP connectors. (markt)
> > | Further re-factoring of the HTTP connectors to align the BIO, NIO and APR implementations. (markt)
> > | 51794: Fix race condition in NioEndpoint. (fhanik)
> > | 51811: Correct SSL configuration property name from sslImplemenationName to sslImplementationName. (rjung)
> > | Fix a timing issue in NIO connector that meant that stopping a connector did not trigger a Comet END event if the associated processor was processing a READ event when the connector was stopped. (markt)
> > | Replace unneeded call that iterated events queue in NioEndpoint.Poller. (kkolinko)
> > | 51860: Fix issues if using NIO with a custom SSLImplementation. Based on a suggestion by Roman Tsirulnikov. (markt)
> > | Allow the BIO HTTP connector to be used with SSL when running under Java 7. (markt)
> > | Don't send AJP CPONG if endpoint is already paused. (rjung)
> > | Align APR AJP connector with NIO one. Send 503 if endpoint is paused. (rjung)
> > | Accept AJP request even if endpoint is paused, if CPING was successful. (rjung)

> Jasper

> > | When unloading JSPs due to configuration of the `maxLoadedJsps` initialisation parameter, the unloading code was retaining a reference to the to the unloaded JSP preventing the associated class from being unloaded until the JSP that replaced it was itself unloaded. (markt)
> > | 51852: Correct two problems in the handling of varargs methods with the BeanELResolver. The first meant the wrong method was sometimes called and the second that an ArrayIndexOutOfBoundsExceptions could be thrown. Patch (including a test case) provided by Matt Benson. (markt)

> Cluster

> > | Refactor cluster manager configuration: move handling of common attributes to base class. (kfujino, rjung)
> > | New cluster manager attribute `sessionAttributeFilter` allows to filter which session attributes are replicated using a regular expression applied to the attribute name. (rjung)

> Web applications

> > | Correct the documentation for `connectionLinger` attribute for the AJP and HTTP connectors. (markt)
> > | Document caveat of using `RemoteAddrValve` with IPv6 addresses. (kkolinko)

> jdbc-pool

> > | In jdbc-pool: Avoid IllegalArgumentException when setting maxActive less than or equal to 0. ArrayBlockingQueue doesn't allow capacity of 0 or less. (kfujino)
> > | 48392 (r1169796): Fix typo in `StatementDecoratorInterceptor`. (fhanik)
> > | 51139: In jdbc-pool: validatorClassName and suspectTimeout are ignored. In order to support them correctly, validatorClassName and suspectTimeout are added to a property list. (kfujino)
> > | 51786: In jdbc-pool: Discarded connection is not active in a pool any longer. It removes from the active connection list. (kfujino)
> > | 51871: Fix dependency in Maven POM file of tomcat-jbdc. (kkolinko)

> Other

> > | Update the "test" target in the default build file to report a test failure only after all available connector variants (bio, nio, apr) have been tested. Do not stop after first connector that fails. (kkolinko)
> > | 51887: When running the unit tests, use a fast but insecure random number source for session ID generation to reduce the delays caused by waiting for entropy. (kkolinko/markt)
> > | Code clean-up to further reduce the number of warnings reported by Eclipse, FindBugs and CheckStyle. (markt/kkolinko)

Tomcat 7.0.21 (markt) | released 2011-09-01

> Catalina

> > | 41718: Include a response body when sending a redirect. (markt)
> > | 51640: Improve the memory leak prevention for leaks triggered by java.sql.DriverManager. (markt)
> > | 51644: Fix annotation scanning for contexts with a multi-level context path such as /a/b. (markt)
> > | Unregisters MBean of DataSource when web application stops. (kfujino)
> > | 51650: Code clean-up. Patch provided by Felix Schumacher. (markt)
> > | 51653: Move application level error page handling from the Host to the Context. This ensures that application error page handling is completed before the requestDestroyed event of any ServletRequestListener is fired. (markt)
> > | 51654: Improve handling of invalid appBase settings for Host elements. (markt)
> > | 51658: Fix possible NPE when logging a failed request. Based on a suggestion by Felix Schumacher. (markt)
> > | 51688: JreMemoryLeakPreventionListener now protects against AWT thread creation. (schultz)
> > | 51712: Ensure cache control headers are sent when appropriate even if the request is secure. Patch provided by Michael Zampani. (markt)
> > | 51713: Improve message that is logged if there is an error in the value of `protocol` in a `Connector`. (kkolinko)
> > | 51739: When using a landing page with FORM authentication ensure that the request has a valid HTTP method. (markt)

> Coyote

> > | 51641: Use correct key when removing processor instances from the connections map during clean-up. Patch provided by zhh. (markt)
> > | More changes to align the code between the different HTTP connectors. (markt)
> > | Ensure AjpMessage headers are correct for the direction of the message. (markt)
> > | Code clean-up and re-factoring to reduce duplicate code in the AJP processor implementations. (markt)
> > | Detect incomplete AJP messages and reject the associated request if one is found. (markt)
> > | 51698: Fix CVE-2011-3190. Prevent AJP message injection. (markt)

> Jasper

> > | 41673: Use platform line-endings when reporting compilation errors. (markt)

> Cluster

> > | 51736: Make rpcTimeout configurable in BackupManager. (kfujino)

> Web applications

> > | 51649: Update the documentation web application to include the ThreadLocal leak prevention listener. (markt)

> jdbc-pool

> > | 51583 (r1157874, r1162102): Fix shutdown delay in jdbc-pool. (fhanik/kkolinko)

> Other

> > | 51558: Don't force the use of StandardManager when using any of the `Tomcat#addWebapp()` methods. (markt)
> > | 51704: Make use of `File#mkdirs()` more robust. (markt)

Tomcat 7.0.20 (markt) | released 2011-08-11

> Catalina

> > | Corrected missing comma in the value of `jarsToSkip` property in `conf/catalina.properties` file, which caused tomcat-jdbc.jar and commons-beanutils*.jar to be not ignored when scanning jars for tag libraries. (kkolinko)
> > | 41709: Provide exception messages where no message is provided currently for IllegalStateExcpetions triggered by calling HttpServletResponse methods when the response is committed. (markt)
> > | 51509: Fix potential concurrency issue in CSRF prevention filter that may lead to some requests failing that should not. (markt)
> > | 51518: Correct error in web.xml parsing rules for the <others/> tag when using absolute ordering. (markt)
> > | Move the SetCharacterEncoding filter from the examples web application to the `org.apache.catalina.filters` package so it is available for all web applications. (markt)
> > | 51550: Internal errors in Tomcat components that process requests before they are passed to a web application, such as Authenticators, now return a 500 response rather than a 200 response. (markt)
> > | 51555: Allow destroy() to be called on Lifecycle components that are in the initialized state. (markt)
> > | Add x-threadname pattern format token to ExtendedAccessLogValve to log the current request thread name. Based on a patch from Felix Schumacher. (timw)
> > | 51584: Ensure file paths are encoded/decoded when translated to/from URLs when working with resources from a Context so special characters don't cause issues. (markt)
> > | 51586: Expand error handling to cover anything that is recoverable (or might be recoverable) when loading classes during HandlesTypes processing. (markt)
> > | 51588: Make it easier to extend the AccessLogValve to add support for custom elements. (markt)
> > | Ensure that calls to StandardWrapper methods() that may trigger creation of a Servlet instance always do so in way that correctly instantiates a Servlet instance. (markt)
> > | In JDBCStore: Committing connection if autoCommit is false. Make sure committed connection is returned to the pool if datasource is enabled. (kfujino)
> > | Split `condition` attribute of AccessLogValve into two, `conditionIf` and `conditionUnless`. Implement conditional logging that logs only if a request attribute is present. (kkolinko)
> > | Allow to have several AccessLogValve instances in the same scope (e.g. in the same Context). (kkolinko)
> > | 51610: If an unchecked exception occurs during a lifecycle transition (e.g. web application start) ensure that the component is put into the failed state. (markt)
> > | 51614: Avoid calling store.load() and session.expire() twice in PersistentManager when expiring sessions. (kfujino)
> > | Prevent spurious log warnings on container stop if a child component has previously failed. (markt)
> > | Add missing getter and setter for the alwaysUseSession attribute of the authenticators. (markt)

> Coyote

> > | 49595: Prevent JVM crash with the AJP APR connector when flushing a closed socket. (jfclere)
> > | 50394: Return -1 instead of throwing an exception when encountering an EOF while processing an input stream with the HTTP APR connector. (jfclere)
> > | Correctly handle a connectionTimeout value of -1 (no timeout) for the HTTP NIO and AJP NIO connectors. (markt)
> > | 51503: Add additional validation that prevents a connector from starting if it does not have a port > 0. (markt)
> > | 51557: Ignore HTTP headers that do not comply with RFC 2616 and use header names that are not tokens. (markt)
> > | Improve error handling for HTTP APR if an error occurs while using sendfile. (markt)
> > | Ensure that when using sendfile, HTTP APR sockets are not added to multiple pollers. This may cause errors during shutdown. (markt)
> > | Set `reuse` flag of final AJP `END_RESPONSE` packet to `0` if we plan to close the connection. (rjung)
> > | Correctly indicate if socket is closing when calling recycle for the AJP NIO processor. Note since the flag is unused in this case there were no bugs triggered by the re-factoring error. (rjung)

> Jasper

> > | 51532: JSP files with dependencies in JARs were recompiled on every access leading to poor performance. (markt)
> > | 51544: Correctly resolve bean methods in EL so accessible methods that are overridden by inaccessible methods do not cause an IllegalAccessException. (markt)

> Web applications

> > | 41498: Add the allRolesMode attribute to the Realm configuration page in the documentation web application. (markt)
> > | 48997: Fixed some typos and correct cross-referencing to the HTTP Connector documentation with the SSL How-To page of the documentation web application. (markt)
> > | 49122: Improvements and fixes for index page for ROOT web application. Based on a patch provided by pidster. (markt)
> > | 51516: Correct documentation web application to show correct system property name for changing the name of the SSO session cookie. (markt)
> > | Configure the Manager and Host Manager web applications with the Set Character Encoding Filter to make the default request character encoding UTF-8 to improve i18n support. Note that best results will be obtained if the connector is also configured with `URIEncoding="UTF-8"`.(markt)
> > | Update the documentation web application to be even more explicit about the implications of setting the path attribute on a Context element in server.xml. (markt)
> > | 51561: Update the Realm page within the documentation web application to recommend the use of digest.[bat|sh] to generate digests rather than calling RealmBase directly. (markt)
> > | 51567: Update the class loading page of the documentation web application to include information on the search order for the common class loader when separate values are used for $CATALINA_HOME and $CATALINA_BASE. (markt)
> > | Improve class loading documentation and logging documentation. (kkolinko)
> > | Add information to the security page of the documentation web application for the ciphers attribute of the Connector element. (markt)

> Other

> > | 51503: Add additional validation to Windows installer that ensure that the shutdown port, HTTP port and AJP port are all specified during the install process. (markt)
> > | 51531: Update sample Eclipse classpath file to reflect updated ECJ jar. Patch provided by Ian Brandt. (markt)
> > | Convert Tomcat unit tests to JUnit 4. (kkolinko)
> > | Update optional CheckStyle library to 5.4. (kkolinko)
> > | Remove `resolveHosts` attribute from AccessLogValve configuration in the default `server.xml`. It was documented in 7.0.19 that it has no effect. (kkolinko)
> > | Simplify mapping for `jsp` servlet in the default `web.xml`. (kkolinko)
> > | Correctly handle uninstall with the Windows installer if the service is installed with a name that contains a '-' character. (markt)
> > | 51598: Prevent direct invocation of the Windows uninstaller without a service name from executing since the uninstall will not be complete. (markt)
> > | Use Tomcat icon (cat) instead of Apache Commons Daemon (feather) one in the list of uninstallable programs on Windows. (kkolinko)
> > | Update to Apache Commons Daemon 1.0.7. (markt)
> > | 51621: Add additional required JARs to the deployer distribution. (markt)
> > | Fix a small number of warnings reported by FindBugs. (markt)
> > | Update to version 1.1.22 of the native component for the AJP APR/native and HTTP APR/native connectors. (markt)

Tomcat 7.0.19 (markt) | released 2011-07-19

> Catalina

> > | Add option to activate access log for unit tests. (rjung)
> > | Fix regression in year number formatting for AccessLogValve. (rjung)
> > | 46252: Allow to specify character set to be used to write the access log in AccessLogValve. (kkolinko)
> > | 51494: Prevent an NPE when a long running request completes if the associated web application was destroyed while the request was processing. (markt)
> > | Allow choosing a locale for timestamp formatting in AccessLogValve. (rjung)
> > | When generating access logs for errors, log at the Context/Host level if a Context or Host can be identified for the failed request. (markt)
> > | Create a directory for access log or error log (in AccessLogValve and in JULI FileHandler) automatically when it is specified as a part of the file name, e.g. in the `prefix` attribute. Earlier this happened only if it was specified with the `directory` attribute. (kkolinko)
> > | Log a failure if access log file cannot be opened. (kkolinko)
> > | Use en_US as locale for timestamps in ExtendedAccessLogValve. (rjung)
> > | Use en_US as locale for creationdate in WebdavServlet. (rjung)

> Coyote

> > | 51477: Support all SSL protocol combinations in the APR/native connector. This only works when using the native library version 1.1.21 or later, which is not yet released. (rjung)
> > | Various refactorings to reduce code duplication and unnecessary code in the connectors. (markt)
> > | Correct regression introduced in 7.0.17 that triggered 400 entries in the AccessLog when using the AJP/BIO connector. (markt)
> > | Fix regression producing invalid MBean names when using IPV6 addresses for connectors. (rjung)
> > | Add missing thread name in RequestProcessor when Servlet 3 Async is used. Fixes null thread name in access log and JMX MBean. (rjung)
> > | Fix CVE-2011-2526. Protect against infinite loops (HTTP NIO) and crashes (HTTP APR) if sendfile is configured to send more data than is available in the file. (markt)
> > | Prevent NPEs when a socket is closed in non-error conditions after sendfile processing when using the HTTP NIO connector. (markt)

> Cluster

> > | Remove unnecessary server.xml parsing code for old cluster implementation that does not ship as part of Tomcat 7. (markt)

> Web applications

> > | Add additional information to the documentation web application on the benefits and remaining risks when running under a security manager. (markt)
> > | 51490: Correct broken HTML in JSP tag plugin examples and improve the <c:if> example to make failures more obvious. Based on suggestions by Charles. (markt)
> > | Document ExtendedAccessLogValve. (rjung)
> > | Correct default value of `enableLookups` for connectors and mention, that `resolveHosts` for the AccessLogValve is replaced by `enableLookups`. (rjung)

> jdbc-pool

> > | Include jdbc-pool into Tomcat release. (fhanik)

> Other

> > | Update to Apache Commons Daemon 1.0.6. (markt)
> > | Update to Eclipse JDT Compiler 3.7. (markt)

Tomcat 7.0.18 (markt) | not released

> Catalina

> > | Correct regression introduced in 7.0.17 that triggered an NPE if a CrawlerSessionManagerValve was used without setting crawlerUserAgents. (markt)
> > | 51466: Correct comment typos in HostManagerServlet. Patch provided by Felix Schumacher. (markt)
> > | 51467: Invoke Thread.start() rather than Thread.run() so that listeners and filters are stopped in a separate thread rather than the current thread. Patch provided by Felix Schumacher. (markt)
> > | 51473: Fix concatenation of values in `SecurityConfig.setSecurityProperty()`. (kkolinko)
> > | Fix response.encodeURL() for the special case of an absolute URL with no path segment (http://name). (rjung)

> Coyote

> > | Correct regression caused by connector re-factoring that made AJP APR/native connector very unstable on Windows platforms. (markt)
> > | Correct regression caused by connector re-factoring that meant that sendfile data was not reset between pipe-lined HTTP requests. (markt)

> Tribes

> > | Re-factor tests to align packages for tests with the classes under test. Start to convert non-JUnit tests to JUnit. Remove unnecessary code. (markt)
> > | Add synchronization to receiver socket binding to prevent test failures on Linux. (markt)

> Other

> > | More code clean-up to remove unused code and reduce IDE warnings. (markt/kkolinko)
> > | Further improvements to the Windows installer. (markt/kkolinko)

Tomcat 7.0.17 (markt) | not released

> Catalina

> > | 48956: Add regular expression support for SSI. (markt)
> > | 49165: Allow any time stamp formats supported by SimpleDateFormat in AccessLogValve. Support logging begin and/or end of request. (rjung)
> > | 50677: Allow system property variables to be used in the values of "common.loader" and other "*.loader" properties in the `catalina.properties` file. (kkolinko)
> > | 51376: When adding a Servlet via ServletContext#addServlet(String, Servlet), the Servlet was not initialized when the web application started and a load on startup value was set. (markt)
> > | 51386: Correct code for processing @HandlesTypes annotations so only types of interest are reported to a ServletContainerInitializer. (markt)
> > | Add the Tomcat extras, ant-junit and Java Help Jars to the list of JARs to skip when scanning for TLDs and web fragments. (rjung)
> > | The fix for bug 51310 caused a regression that re-introduced bug 49957 and deleted the contents of the work directory when Tomcat was shutdown. This fix ensures that that work directory for an application is not deleted when Tomcat is shutdown. (markt)
> > | Correct issues with JULI's OneLineFormatter including: correctly re-using formatted timestamps when possible; thread-safety issues in timestamp formatting; correcting the output of any milliseconds to include leading zeros and formatting any parameters present. (kkolinko/markt/rjung)
> > | 51395: Fix memory leak triggered when an application that includes a SAXParserFactory is the first web application to be loaded. (markt)
> > | 51396: Correctly handle jsp-file entries in web.xml when the JSP servlet has been configured via code when embedding Tomcat. (markt)
> > | 51400: Avoid known bottleneck in JVM when converting between Strings and bytes by always providing a Charset rather than an encoding name. Based on a patch by Dave Engberg. (markt)
> > | 51401: Correctly initialise shared WebRuleSet instance used by the digesters that parse web.xml and prevent incorrect warnings about multiple occurrences of elements that are only allowed to appear once in web.xml and web-fragment.xml. (kfujino)
> > | 51403: Avoid NPE in JULI FileHandler if formatter is misconfigured. (kkolinko)
> > | Previous improvements in JAR scanning performance introduced a start-up performance penalty for some use cases. This fix addresses those performance penalties while retaining the original improvements. (markt)
> > | 51418: Provide more control over Context creation when embedding Tomcat. Based on a patch by Benson Margulies. (markt/kkolinko)
> > | Remove redundant copy of catalina.properties from o.a.c.startup. Generate this copy for inclusion in bin and src jars during the ant "compile" task. (rjung)
> > | Use system properties loaded from catalina.properties via the class path in unit tests. (rjung)
> > | Improve JMX unit test. (rjung)
> > | Fix IllegalStateException for JavaScript files when switching from Writer to OutputStream. The special handling of this case in the DefaultServlet was broken due to a MIME type change for JavaScript. (funkman)
> > | Fix CVE-2011-2204. Prevent user passwords appearing in log files if a runtime exception (e.g. OOME) occurs while creating a new user for a MemoryUserDatabase via JMX. (markt)
> > | Fix an issue with the CrawlerSessionManagerValve that meant sessions were not always correctly tracked. (markt)
> > | 51436: Send 100 (Continue) response earlier to enable ServletRequestListener implementations to read the request body. Based on a patch by Simon Olofsson. (markt)
> > | Ensure an access log entry is made if an error occurs during asynchronous request processing and the socket is immediately closed. (markt)
> > | Ensure that if asyncDispatch() is called during an onTimeout event and the target Servlet does not call startAsync() or complete() that Tomcat calls complete() once the target Servlet exits. (markt)
> > | Improve the handling for Servlets that implement the deprecated SingleThreadModel when embedding Tomcat. (markt)
> > | 51445: Correctly initialise all instances of Servlets that implement SingleThreadModel. Based on a patch by Felix Schumacher. (markt)
> > | 51453: Fix a regression in the preemptive authentication support (enhancement 12428) that could trigger authentication even if preemptive authentication was disabled. (markt)
> > | Prevent possible NPE when serving Servlets that implement the SingleThreadModel interface. (markt)
> > | In launcher for embedded Tomcat: do not change `catalina.home` system property if it had a value. (kkolinko)
> > | When using Servlets that implement the SingleThreadModel interface, add the single instance created to the pool when it is determined that a pool of servlets is required rather than throwing it away. (markt)

> Coyote

> > | Fix unit test for bindOnInit which was failing for APR on some platforms. (rjung)
> > | Remove superfluous quotes from thread names for connection pools. (rjung)
> > | Fix crash observed during pausing the connector when using APR. Only add socket to poller if we are sure we don't close it later. (rjung)
> > | Various refactorings to reduce code duplication and unnecessary code in the connectors. (markt)
> > | Correct a regression introduced in Apache Tomcat 7.0.11 that broke certificate revocation list handling. (markt)

> Jasper

> > | Improve the message printed by TldLocationsCache and add configuration example to the `logging.properties` file. (kkolinko)

> > 33453: Recompile JSPs if last modified time of the source or any of its dependencies changes either forwards or backwards. Note that this introduces an incompatible change to the code generated for JSPs. Tomcat will automatically re-compile any JSPs and tag files found in the work directory when upgrading from 7.0.16 or earlier to 7.0.17 or later. If you later downgrade from 7.0.17 or later to 7.0.16 or earlier, you must empty the work directory as part of the downgrade process. (markt)

> > | 36362: Handle the case where tag file attributes (which can use any valid XML name) have a name which is not a Java identifier. (markt/kkolinko)
> > | Broaden the exception handling in the EL Parser so that more failures to parse an expression include the failed expression in the exception message. Hopefully, this will help track down the cause of 51088. (markt)

> Cluster

> > | 51306: Avoid NPE when handleSESSION_EXPIRED is processed while handleSESSION_CREATED is being processed. (kfujino)
> > | Notifications of changes in session ID to other nodes in the cluster should be controlled by notifySessionListenersOnReplication rather than notifyListenersOnReplication. (markt)
> > | The change in session ID is notified to the container event listener on the backup node in cluster. This notification is controlled by notifyContainerListenersOnReplication.(kfujino)

> Web applications

> > | Update Maven repository information in the documentation to reflect current usage. (markt)
> > | 43538: Add host name and IP address to the HTML Manager application. Patch by Dennis Lundberg. (markt)
> > | Add `session="false"` directive to the index page of the ROOT web application. (kkolinko)
> > | 51443: Document the notifySessionListenersOnReplication attribute for the DeltaManager. (markt)
> > | 51447: Viewing a back up session in the HTML Manager web application no longer changes the session to a primary session. Based on a patch provided by Eiji Takahashi. (markt)

> Other

> > | 33262: Install monitor to auto-start for current user only rather than all users to be consistent with menu item creation. (markt)
> > | 40510: Provide an option to install shortcuts for the current user or all users. Also ensure registry is correctly cleaned on uninstall for 64-bit platforms. (markt)
> > | 50949: Provide the ability to specify the AJP port and service name when installing Tomcat using the Windows installer. This permits multiple instances of the same Tomcat version to be installed side-by-side. (markt)
> > | Clean up shell and batch scripts (improve consistency, clarify comments, add `configtest` command support for Windows). (rjung)
> > | 51206: Make CATALINA_BASE visible for setenv.sh. (rjung)
> > | Remove unnecessary variable BASEDIR from scripts. (rjung)
> > | 51425, 51450: Update Spanish translations. Based on patches provided by Jesus Marin. (markt)

Tomcat 7.0.16 (markt) | released 2011-06-17

> Catalina

> > | 51249: Further improve system property replacement code in ClassLoaderLogManager of Tomcat JULI to cover some corner cases. (kkolinko)
> > | 51264: Improve the previous fix for this issue by returning the connection to the pool when not in use so it does not appear to be an abandoned connection. Patch provided by Felix Schumacher. (markt)
> > | 51324: Improve handling of exceptions when flushing the response buffer to ensure that the doFlush flag does not get stuck in the enabled state. Patch provided by Jeremy Norris. (markt)
> > | Correct a regression in the fix for 51278 that prevented any web application from being marked as distributable. (kfujino/markt)
> > | Correct a regression in the fix for 51278 that prevented a web application from overriding the default welcome files. (markt)
> > | Enable remaining valves for Servlet 3 asynchronous processing support. (markt)
> > | Avoid possible NPE when logging requests received during embedded Tomcat shutdown. (markt)
> > | 51340: Fix thread-safety issue when parsing multiple web.xml files in parallel. Apache Tomcat does not do this but products that embed it may. (markt)
> > | 51344: Fix problem with Lifecycle re-factoring for deprecated embedded class that prevented events being triggered. (markt)
> > | 51348: Prevent possible NPE when processing WebDAV locks. (markt)

> Coyote

> > | When parsing the port in the HTTP host header, restrict the value to be base 10 integer digits rather than hexadecimal ones. (rjung/markt/kkolinko)
> > | Various refactorings to reduce code duplication and unnecessary code in the connectors. (markt)

> Jasper

> > | Change JAR scanning log messages where no TLDs are found to DEBUG level and replace the multiple messages with a single INFO level message that indicates that at least one JAR was scanned needlessly and how to obtain more info. (markt)

> Cluster

> > | Enable Servlet 3 asynchronous processing support when using clustering. (markt)

> Web applications

> > | Correct the log4j configuration settings when defining conversion patterns in the documentation web application. (markt)

Tomcat 7.0.15 (markt) | not released

> Catalina

> > | 27122: Remove a workaround for a very old and since fixed Mozilla bug and change the default value of the securePagesWithPragma attribute of the Authenticator Valves to false. These changes should reduce the likelihood of issues when downloading files with IE. (markt)
> > | 35054: Check that a file is not specified for a Host's appBase and log an error if it is. (markt)
> > | 51197: Fix possible dropped connection when sendError or sendRedirect are used during async processing. (markt)
> > | 51221: Correct Spanish translation of text used in a 302 response. Patch provided by Paco Soberón. (markt)
> > | 51249: Correct ClassLoaderLogManager system property replacement code so properties of the form "}${...}" can be used without error. (markt)
> > | 51264: Allow the JDBC persistent session store to use a JNDI datasource to define the database in which sessions are persisted. Patch provided by Felix Schumacher. (markt)
> > | 51274: Add missing i18n strings in PersistentManagerBase. Patch provided by Eiji Takahashi. (markt)
> > | 51276: Provide an abstraction for accessing content in JARs so the most efficient method can be selected depending on the type of URL used to identify the JAR. This improves startup time when JARs are located in $CATALINA_BASE/lib. (markt)
> > | 51277: Improve error message if an application is deployed with an incomplete FORM authentication configuration. (markt)
> > | 51278: Allow ServletContainerInitializers to override settings in the global default web.xml and the host web.xml. (markt)
> > | 51310: When stopping the Server object on shutdown call destroy() after calling stop(). (markt)

> Coyote

> > | 51145: Add an AJP-NIO connector. (markt/rjung)

> Jasper

> > | 51220: Add a system property to enable tag pooling with JSPs that use a custom base class. Based on a patch by Dan Mikusa. (markt)
> > | Include a comment header in generated java files that indicates when the file was generated and which version of Tomcat generated it. (markt)
> > | 51240: Ensure that maxConnections limit is enforced when multiple acceptor threads are configured. (markt)

> Cluster

> > | 51230: Add missing attributes to JMX for ReplicationValve and JvmRouteBinderValve. Patch provided by Eiji Takahashi. (markt)

> Web applications

> > | Add documentation for AJP-NIO connector. (markt/rjung)
> > | 51182: Document JAAS supported added in 51119. Patch provided by Neil Laurance. (markt)
> > | 51225: Fix broken documentation links for non-English locales in the HTML Manager application. Patch provided by Eiji Takahashi. (markt)
> > | 51229: Fix bugs in the Servlet 3.0 asynchronous examples. Patch provided by Eiji Takahashi. (markt)
> > | 51251: Add web application version support to the Ant tasks. Based on a patch provided by Eiji Takahashi. (markt)
> > | 51294: Clarify behaviour of unpackWAR attribute of StandardContext components. (markt)

> Other

> > | 46451: Configure svn:bugtraq properties for Tomcat trunk. Based on a patch provided by Marc Guillemot. (markt)
> > | 51309: Correct logic in catalina.sh stop when using a PID file to ensure the correct message is shown. Patch provided by Caio Cezar. (markt)

Tomcat 7.0.14 (markt) | released 2011-05-12

> Catalina

> > | Stylistic improvements to MIME type sync script. Based on a patch provided by Felix Schumacher. (rjung)
> > | Ensure that the SSLValve provides the SSL key size as an Integer rather than a String. (markt)
> > | Ensure that the RemoteIpValve works correctly with Servlet 3.0 asynchronous requests. (markt)
> > | Use safe equality test when determining event type in the MapperListener. (markt)
> > | Use correct class loader when loading Servlet classes in StandardWrapper. (markt)
> > | Provide additional configuration options for the RemoteIpValve and RemoteIpFilter to allow greater control over the values returned by ServletRequest#getServerPort() and ServletRequest#getLocalPort() when Tomcat is behind a reverse proxy. (markt)
> > | Ensure session cookie paths end in `/` so that session cookies created for a context with a path of `/foo` do not get returned with requests mapped to a context with a path of `/foobar`. (markt)

> Jasper

> > | 51177: Ensure Tomcat's MapElResolver always returns `Object.class` for `getType()` as required by the EL specification. (markt)

Tomcat 7.0.13 (markt) | not released

> Catalina

> > | Correct mix-up in Realm Javadoc. (markt)
> > | Fix display of response headers in AccessLogValve. (kkolinko)
> > | Implement display of multiple request headers in AccessLogValve: print not just the value of the first header, but of the all of them, separated by commas. (kkolinko)
> > | 50306: New StuckThreadDetectionValve to detect requests that take a long time to process, which might indicate that their processing threads are stuck. Based on a patch provided by TomLu. (slaurent)
> > | 51038: Ensure that asynchronous requests are included in access logs. (markt)
> > | 51042: Don't trigger session creation listeners when a session ID is changed as part of the authentication process. (markt)
> > | 51050: Add additional common but non-standard file extension to MIME type mappings for MPEG 4 files. Based on a patch by Cédrik Lime. (markt)
> > | Add some additional common JARs that do not contain TLDs or web fragments to the list of JARs to skip when scanning for TLDs and web fragments. (markt)
> > | While scanning JARs for TLDs and fragments, avoid using JarFile and use JarInputStream as in most circumstances where JARs are scanned, JarFile will create a temporary copy of the JAR rather than using the resource directly. This change significantly improves startup performance for applications with lots of JARs to be scanned. (markt)
> > | Ensure response is committed when `AsyncContext#complete()` is called. (markt)
> > | Add a container event that is fired when a session's ID is changed, e.g. on authentication. (markt)
> > | 51099: Correctly implement non-default login configurations (configured via the loginConfigName attribute) for the SPNEGO authenticator. (fhanik/markt)
> > | 51119: Add JAAS authentication support to the JMXRemoteLifecycleListener. Patch provided by Neil Laurance. (markt)
> > | 51136: Provide methods that enable the name of a Context on Context creation when using Tomcat in an embedded scenario. Based on a patch provided by David Calavera. (markt)
> > | 51137: Add additional Microsoft Office MIME type mappings. (rjung)
> > | Partial sync of MIME type mapping with mime.types from the Apache web server. About 600 MIME types added, some changed. (rjung)
> > | Make access logging more robust when logging requests that generate 400 responses since the request object is unlikely to be fully/correctly populated in that case. (markt)

> Coyote

> > | 50957: Fix regression in HTTP BIO connector that triggered errors when processing pipe-lined requests. (markt)
> > | 50158: Ensure the asynchronous requests never timeout if the timeout is set to zero or less. Based on a patch provided by Chris. (markt)
> > | 51073: Throw an exception and do not start the APR connector if it is configured for SSL and an invalid value is provided for SSLProtocol. (markt)
> > | Align all the connector implementations with the documented default setting for processorCache of 200. This changes the default from -1 (unlimited) for the AJP-BIO, AJP-APR and HTTP-APR connectors. Additional information was also added to the documentation on how to select an appropriate value.
> > | Take account of time spent waiting for a processing thread when calculating connection and keep-alive timeouts for the HTTP BIO connector. (markt)
> > | 51095: Don't trigger a NullPointerException when the SSL handshake fails with the HTTP-APR connector. Patch provided by Mike Glazer. (markt)
> > | Improve handling in AJP connectors of the case where too large a AJP packet is received. (markt)
> > | Restore the automatic disabling of HTTP keep-alive with the BIO connector once 75% of the processing threads are in use and make the threshold configurable. (markt)
> > | Make pollerSize and maxConnections synonyms for the APR connectors since they perform the same function. (markt)
> > | Use maxThreads rather than 10000 as the default maxConnections for the BIO connectors. (markt)

> Jasper

> > | 47371: Correctly coerce the empty string to zero when used as an operand in EL arithmetic. Patch provided by gbt. (markt)
> > | Label JSP/tag file line and column numbers when reporting errors since it may not be immediately obvious what the numbers represent. (markt)
> > | Correct a regression in the fix for 49916 that resulted in JSPs being compiled twice rather than just once. (markt)
> > | Log JARs that are scanned for TLDs where no TLD is found so that users can easily identify JARs that can be added to the list of JARs to skip. (markt)
> > | Use a single TLD location cache for a web application rather than one per JSP compilation to speed up JSP compilation. (markt)
> > | 51124: Refactor BodyContentImpl to assist in determining the root cause of this bug. Based on a patch by Ramiro. (markt)

> Cluster

> > | 50950: Correct possible NotSerializableException for an authenticated session when running with a security manager. (markt)

> Web applications

> > | Configure Security Manager How-To to include a copy of the actual conf/catalina.policy file when the documentation is built, rather than maintaining a copy of its content. (kkolinko)
> > | Fix broken stylesheet URL in XML based manager status output. (rjung)
> > | 51156: Ensure session expiration option is available in Manager application was running web applications that were defined in server.xml. (markt)

> Other

> > | Clarify error messages in *.sh files to mention that if a script is not found it might be because execute permission is needed. (kkolinko)
> > | Update Apache Commons Pool to 1.5.6. (markt)
> > | 51135: Fix auto-detection of JAVA_HOME for 64-bit Windows platforms that only have a 32-bit JVM installed. (markt)
> > | 51154: Remove duplicate @deprecated tags in ServletContext Javadoc. Patch provided by sebb. (markt)
> > | 51155: Add comments to @deprecated tags that have none. Patch provided by sebb. (markt)

Tomcat 7.0.12 (markt) | released 2011-04-06

> Catalina

> > | Automatically correct invalid paths when specified for Context elements inside server.xml and log a warning that the configuration has been corrected. (markt)
> > | Don't unpack WAR files if they are not located in the Host's appBase. (markt)
> > | Don't log to standard out in SSLValve. (markt)
> > | Handle the case where a web crawler provides an invalid session ID in the CrawlerSessionManagerValve. (markt)
> > | Update pattern used in CrawlerSessionManagerValve to that used by the ASF infrastructure team. (markt)
> > | Remove unnecessary whitespace from MIME mapping entries in global web.xml file. (markt)
> > | When using parallel deployment, correctly handle the scenario when the client sends multiple JSESSIONID cookies. (markt)
> > | 12428: Add support (disabled by default) for preemptive authentication. This can be configured per context. Based on a patch suggested by Werner Donn. (markt)
> > | Make the CSRF nonce cache serializable so that it can be replicated across a cluster and/or persisted across Tomcat restarts. (markt)
> > | Resolve some refactoring TODOs in the implementation of the new Context attribute "swallowAbortedUploads". (markt)
> > | Include the seed time when calculating the time taken to create SecureRandom instances for session ID generation, report excessive times (greater than 100ms) at INFO level and provide a value for the message key so a meaningful message appears in the logs. (markt)
> > | Don't register Contexts that fail to start with the Mapper. (markt)

> > 48685: Add initial support for SPNEGO/Kerberos authentication also referred to as integrated Windows authentication. This includes user authentication, authorisation via the directory using the user's delegated credentials and exposing the user's delegated credentials via a request attribute so applications can make use of them to impersonate the current user when accessing third-party systems that use a compatible authentication mechanism. Based on a patch provided by Michael Osipov. (markt)

> > | HTTP range requests cannot be reliably served when a Writer is in use so prevent the DefaultServlet from attempting to do so. (kkolinko)
> > | Protect the DefaultServlet from Valves, Filters and Wrappers that write content to the response. Prevent partial responses to partial GET requests in this case since the range cannot be reliably determined. Also prevent the DefaultServlet from setting a content length header since this too cannot be reliably determined. (markt)
> > | 50929: When wrapping an exception, include the root cause. Patch provided by sebb. (markt)
> > | 50991: Fix regression in fix for 25060 that called close on a JNDI resource while it was still available to the application. (markt)
> > | Provide a configuration option that lets the close method to be used for a JNDI Resource to be defined by the user. This change also disables using the close method unless one is explicitly defined for the resource and limits it to singleton resources. (markt)
> > | Correctly track changes to context.xml files and trigger redeployment when copyXML is set to false. (markt)
> > | 50997: Relax the requirement that directories must have a name ending in `.jar` to be treated as an expanded JAR file by the default JarScanner. Based on patch by Rodion Zhitomirsky. (markt)
> > | Don't append the jvmRoute to a session ID if the jvmRoute is a zero length string. (markt)
> > | Don't register non-singleton DataSource resources with JMX. (markt)
> > | CVE-2011-1184: Provide additional configuration options for the DIGEST authenticator. (markt)
> > | Provide a workaround for Tomcat hanging during shutdown when running the unit tests. (markt)

> Coyote

> > | 50887: Add support for configuring the JSSE provider used to convert client certificates. Based on a patch by pknopp. (markt)
> > | 50903: When a connector is stopped, ensure that requests that are currently in a keep-alive state and waiting for client data are not processed. Requests where processing has started will continue to completion. (markt)
> > | 50927: Improve error message when SSLCertificateFile is not specified when using APR with SSL. Based on a patch provided by sebb. (markt)
> > | 50928: Don't ignore keyPass attribute for HTTP BIO and NIO connectors. Based on a patch provided by sebb. (markt)

> Cluster

> > | Securely seed the SecureRandom instance used for UUID generation and report excessive creation time (greater than 100ms) at INFO level. (markt)

> Web applications

> > | 50924: Clean-up HTTP connector comparison table. (markt)
> > | Slightly expanded the documentation of the Host element to clarify the relationship between host name and DNS name. (markt)
> > | 50925: Update SSL how-to to take account of `keyPass` connector attribute. (markt)
> > | Improve Tomcat Logging documentation. (kkolinko)
> > | Align the authenticator documentation and MBean descriptors with the implementation. (markt)
> > | Prevent the custom error pages for the Manager and Host Manager applications from being accessed directly. (markt)
> > | 50984: When using the Manager application ensure that undeployment fails if a file cannot be deleted. (markt)

> Other

> > | Update Eclipse JDT complier to 3.6.2. (markt)
> > | Update WSDL4J library to 1.6.2 (used by JSR 109 support in the extras package). (markt)
> > | Update optional CheckStyle library to 5.3. (markt)
> > | 50911: Reduce noise generated during the build of the Windows installer so warnings are more obvious. Patch provided by sebb. (markt)
> > | Further work to reduce compiler and validation warnings across the code base. (markt)

Tomcat 7.0.11 (markt) | released 2011-03-11

> Catalina

> > | CVE-2011-1088: Completed fix. Don't ignore @ServletSecurity annotations. (markt)
> > | 25060: Close Apache Commons DBCP datasources when the associated JNDI naming context is stopped (e.g. for a non-global DataSource resource on web application reload) to close remaining database connections immediately rather than waiting for garbage collection. (markt)
> > | 26701: Provide a mechanism for users to register their own `URLStreamHandlerFactory` objects. (markt)
> > | 50855: Fix NPE on HttpServletRequest.logout() when debug logging is enabled. (markt)
> > | New context attribute "swallowAbortedUploads" allows to make request data swallowing configurable for requests that are too large. (rjung)
> > | 50854: Add additional permissions required by the Manager application when running under a security Manager and support a shared Manager installation when $CATALINA_HOME != CATALINA_BASE. (markt)
> > | 50893: Add additional information to the download README for the extras components. (markt)
> > | Calling `stop()` and then `destroy()` on a connector incorrectly triggered an exception. (markt)

> Coyote

> > | 48208: Allow the configuration of a custom trust manager for use in CLIENT-CERT authentication. (markt)
> > | Fix issues that prevented asynchronous servlets from working when used with the HTTP APR connector on platforms that support TCP_DEFER_ACCEPT. (markt)

> Jasper

> > | Correct possible threading issue in JSP compilation when development mode is used. (markt)
> > | 50895: Don't initialize classes created during the compilation stage. (markt)

Tomcat 7.0.10 (markt) | released 2011-03-08

> Catalina

> > | CVE-2011-1088: Partial fix. Don't ignore @ServletSecurity annotations. (markt)
> > | 27988: Improve reporting of missing files. (markt)
> > | 28852: Add URL encoding where missing to parameters in URLs presented by Ant tasks to the Manager application. Based on a patch by Stephane Bailliez. (markt)
> > | Improve handling of SSL renegotiation by failing earlier when the request body contains more bytes than maxSavePostSize. (markt)
> > | Improve shut down speed by not renewing threads during shut down when the `ThreadLocalLeakPreventionListener` is enabled. (markt)

> Coyote

> > | 49284: Add SSL re-negotiation support to the HTTP NIO connector and extend test cases to cover CLIENT-CERT authentication. (fhanik/markt)

Tomcat 7.0.9 (markt) | not released

> Catalina

> > | 19444: Add an option to the JNDI realm to allow role searches to be performed by the authenticated user. (markt)
> > | 21669: Add the ability to specify the roleBase for the JNDI Realm as relative to the users DN. Based on a patch by Art W. (markt)
> > | 22405: Add a new Lifecycle listener, `org.apache.catalina.security.SecurityListener` that prevents Tomcat from starting insecurely. It requires that Tomcat is not started as root and that a umask at least as restrictive as 0007 is used. This new listener is not enabled by default. (markt)
> > | 48863: Better logging when specifying an invalid directory for a class loader. Based on a patch by Ralf Hauser. (markt/kkolinko)
> > | 48870: Refactor to remove use of parallel arrays. (markt)
> > | Enhance the RemoteIpFilter and RemoteIpValve so that the modified remote address, remote host, protocol and server port may be used in an access log if desired. (markt)
> > | Restore access to Environments, Resources and ResourceLinks via JMX which was lost in early 7.0.x re-factoring. (markt)
> > | Remove ServerLifecycleListener. This was already removed from server.xml and with the Lifecycle re-factoring is no longer required. (markt)
> > | Add additional checks to ensure that sub-classes of `org.apache.catalina.util.LifecycleBase` correctly implement the expected state transitions. (markt)
> > | 50189: Once the application has finished writing to the response, prevent further reads from the request since this causes various problems in the connectors which do not expect this. (markt)
> > | 50700: Ensure that the override attribute of context parameters is correctly followed. (markt)
> > | 50721: Correctly handle URL decoding where the URL ends in %nn. Patch provided by Christof Marti. (markt)
> > | 50737: Add additional information when an invalid WAR file is detected. (markt)
> > | 50748: Allow the content length header to be set up to the point the response is committed when a writer is being used. (markt)
> > | 50751: When authenticating with the JNDI Realm, only attempt to read user attributes from the directory if attributes are required. (markt)
> > | 50752: Fix typo in debug message in deprecated Embedded class. (markt)
> > | 50789: Provide an option to enable ServletRequestListeners for forwards as required by some CDI frameworks. (markt)
> > | 50793: When processing Servlet 3.0 async requests, ensure that the requestInitialized and requestDestroyed events are only fired once per request at the correct times. (markt)
> > | 50802: Ensure that `ServletContext.getResourcePaths()` includes static resources packaged in JAR files in its output. (markt)
> > | Web crawlers can trigger the creation of many thousands of sessions as they crawl a site which may result in significant memory consumption. The new Crawler Session Manager Valve ensures that crawlers are associated with a single session - just like normal users - regardless of whether or not they provide a session token with their requests. (markt)
> > | Don't attempt to start NamingResources for Contexts multiple times. (markt)
> > | 50826: Avoid `IllegalArgumentException` if an embedded Tomcat instance that includes at least one Context is destroyed without ever being started. (markt)
> > | Ensure a web application is taken out of service if the web.xml file is not valid. (kkolinko/markt)
> > | Ensure Servlet 2.2 jspFile elements are correctly converted to use a leading '/' if missing. (markt)
> > | 50836: Better documentation of the meaning of `Lifecycle.isAvailable()` and correct a couple of cases where this could incorrectly return true. (markt)

> Coyote

> > | 50780: Fix memory leak in APR implementation of AJP connector introduced by the refactoring for 49884. (markt)
> > | If server configuration errors and/or faulty applications caused the ulimit for open files to be reached, the acceptor threads for all connectors could enter a tight loop. This loop consumed CPU and also logged an error message for every iteration of the loop which lead to large log files being generated. The acceptors have been enhanced to better handle this situation. (markt)

> Jasper

> > | 50720: Ensure that the use of non-ISO-8859-1 character sets for web.xml does not trigger an error when Jasper parses the web.xml file. (markt)
> > | 50726: Ensure that the use of the genStringAsCharArray does not result in String constants that are too long for valid Java code. (markt)
> > | 50790: Improve method resolution in EL expressions. (markt)

> Cluster

> > | 50771: Ensure HttpServletRequest#getAuthType() returns the name of the authentication scheme if request has already been authenticated. (kfujino)

> Web applications

> > | 50713: Remove roles command from the Manager application. (markt)

> Tribes

> > | 50667 (r1068549): Allow RPC callers to get confirmation when sending a reply. (fhanik)

> Other

> > | 50743: Cache CheckStyle results between builds to speed up validation. Patch provided by Oliver. (markt)

Tomcat 7.0.8 (markt) | released 2011-02-05

> Catalina

> > | Fix NPE in CoyoteAdapter when postParseRequest() call fails. (kkolinko)
> > | 50709: Make `ApplicationContextFacade` non-final to enable extension. (markt)
> > | When running under a security manager, user requests may fail with a security exception. (markt)

> Coyote

> > | Reduce level of log message for invalid URL parameters from WARNING to INFO. (markt)
> > | Fix hanging Servlet 3 asynchronous requests when using the APR based AJP connector. (markt)

> Other

> > | Align server.xml installed by the Windows installer with the one bundled in zip/tar.gz files. The differences are LockOutRealm being used and AccessLogValve being enabled by default. (kkolinko)

Tomcat 7.0.7 (markt) | not released

> Catalina

> > | 18462: Don't merge `stdout` and `stderr` internally so users retain the option to treat them separately. (markt)
> > | 18797: Provide protection against `null` or zero length names being provided for users, roles and groups in the `MemoryRealm` and `UserDatabaseRealm`. (markt)
> > | Improve fix for 50205 to trigger an error earlier if invalid configuration is used. (markt)
> > | Provide additional control over component class loaders, primarily for use when embedding. (markt)
> > | Fix NPE in RemoteAddrFilter, RemoteHostFilter. (kkolinko)
> > | 49711: HttpServletRequest#getParts will work in a filter or servlet without an @MultipartConfig annotation or MultipartConfigElement if the new "allowCasualMultipartParsing" context attribute is set to "true". (schultz)
> > | 49978: Correct another instance where deployment incorrectly failed if a directory in the work area already existed. (markt)
> > | 50582: Refactor access logging so chunked encoding is not forced for all requests if bytes sent is logged. (markt)
> > | 50597: Don't instantiate a new instance of a Filter if an instance was provided via the `ServletContext.addFilter(String, Filter)` method. Patch provided by Ismael Juma. (markt)
> > | 50598: Correct URL for Manager text interface. (markt)
> > | 50620: Stop exceptions that occur during `Session.endAccess()` from preventing the normal completion of `Request.recycle()`. (markt)
> > | 50629: Make `StandardContext.bindThread()` and `StandardContext.unbindThread()` protected to allow use by sub-classes. (markt)
> > | Use getName() instead of logName() in error messages in StandardContext. (kkolinko)
> > | 50642: Move the `sun.net.www.http.HttpClient` keep-alive thread memory leak protection from the JreMemoryLeakPreventionListener to the WebappClassLoader since the thread that triggers the memory leak is created on demand. (markt)
> > | 50673: Improve Catalina shutdown when running as a service. Do not call System.exit(). (kkolinko)
> > | 50683: Ensure annotations are scanned when `unpackWARs` is set to `false` in the Host where a web application is deployed. (markt)
> > | Improve HTTP specification compliance in support of `Accept-Language` header. This protects from known exploit of the Oracle JVM bug that triggers a DoS, CVE-2010-4476. (kkolinko)

> Coyote

> > | Prevent possible thread exhaustion if a Comet timeout event takes a while to complete. (markt)
> > | Prevent multiple Comet END events if the CometServlet calls `event.close()` during an END event. (markt)
> > | 50325: When the JVM indicates support for RFC 5746, disable Tomcat's `allowUnsafeLegacyRenegotiation` configuration attribute and use the JVM configuration to control renegotiation. (markt)
> > | 50405: Fix occasional NPE when using NIO connector and Comet. (markt)
> > | Ensure correct recycling of NIO input filters when processing Comet events. (markt)
> > | 50627: Correct interaction of NIO socket and Poller when processing Comet events. (markt)
> > | Correct interaction of APR socket and Poller when processing Comet events. (markt)
> > | 50631: InternalNioInputBuffer should honor `maxHttpHeadSize`. (kkolinko)

> Jasper

> > | Improve special case handling of `javax.servlet.jsp.el.ScopedAttributeELResolver` in `javax.el.CompositeELResolver` to handle sub-classes. (markt)
> > | 15688: Use fully-qualified class names in generated jsp files to avoid naming conflicts with user imports. (markt)
> > | 46819: Remove redundant object instantiations in JspRuntimeLibrary. Patch provided by Anthony Whitford. (markt)
> > | Improve error message when EL identifiers are not valid Java identifiers and use i18n for the error message. (markt)
> > | 50680: Prevent an NPE when using tag files from an exploded JAR file, e.g. from within an IDE. Patch provided by Larry Isaacs. (markt)

> Cluster

> > | 50591: Fix NPE in ReplicationValve. (kkolinko)
> > | Internationalise the log messages for the FarmWarDeployer. (markt)
> > | 50600: Prevent a `ConcurrentModificationException` when removing a WAR file via the FarmWarDeployer. (markt)
> > | Be consistent with locks on sessionCreationTiming, sessionExpirationTiming in DeltaManager.resetStatistics(). (kkolinko)
> > | 50648: Correctly set the interrupt status if a thread using `RpcChannel` is interrupted waiting for a message reply. Based on a patch by Olivier Costet. (markt)
> > | 50646: Ensure larger Tribes messages are fully read. Patch provided by Olivier Costet. (markt)
> > | 50679: Update the FarmWarDeployer to support parallel deployment. (markt)

> Web applications

> > | 22278: Add a commented out `RemoteAddrValve` that limits access to the Manager and Host Manager applications to localhost. Based on a patch by Yann Cébron. (markt)
> > | Correct a handful of Javadoc warnings. (markt)
> > | Provide additional detail about how web application version order is determined when using parallel deployment. (markt)
> > | Correct the documentation for the recoveryCount count attribute of the the default cluster membership. (markt)
> > | 50441: Clarify when it is valid to set the docBase attribute in a Context element. (markt)
> > | 50526: Provide additional documentation on configuring JavaMail resources. (markt)
> > | 50599: Use correct names of roles required to access the Manager application. (markt)

> Other

> > | Extend the Checkstyle tests to check for license headers. (markt)
> > | Modify the build script so a release build always rebuilds the dependencies to ensure that the correct Tomcat version appears in the manifest. (markt)
> > | Code clean-up to remove unused code and reduce IDE warnings. (markt)
> > | 50601: Code clean-up. Patch provided by sebb. (markt)
> > | 50606: Improve CGIServlet: Provide support for specifying empty value for the `executable` init-param. Provide support for explicit additional arguments for the executable. Those were broken when implementing fix for bug 49657. (kkolinko)

Tomcat 7.0.6 (markt) | released 2011-01-14

> General

> > | Update to Apache Commons Daemon 1.0.5. (mturk)

> Catalina

> > | 8705: `org.apache.catalina.SessionListener` now extends `java.util.EventListener`. (markt)
> > | 10526: Add an option to the `Authenticator`s to force the creation of a session on authentication which may offer some performance benefits. (markt)
> > | 10972: Improve error message if the className attribute is missing on an element in server.xml where it is required. (markt)
> > | 48692: Provide option to parse `application/x-www-form-urlencoded` PUT requests. (schultz)
> > | 48822: Include context name in case of error while stopping or starting a context during its reload. Patch provided by Marc Guillemot. (slaurent)
> > | 48837: Extend thread local memory leak detection to include classes loaded by subordinate class loaders to the web application's class loader such as the Jasper class loader. Based on a patch by Sylvain Laurent. (markt)
> > | 48973: Avoid creating a SESSIONS.ser file when stopping an application if there's no session. Patch provided by Marc Guillemot. (slaurent)
> > | 49000: No longer accept specification invalid name only cookies by default. This behaviour can be restored using a system property. (markt)
> > | 49159: Improve memory leak protection by renewing threads of the pool when a web application is stopped. (slaurent)
> > | 49372: Re-fix after connector re-factoring. If connector initialisation fails (e.g. if a port is already in use) do not trigger an `LifecycleException` for an invalid state transition. (markt)
> > | 49543: Allow Tomcat to use shared data sources with per application credentials. (fhanik)
> > | 49650: Remove unnecessary entries package.access property defined in catalina.properties. Patch provided by Owen Farrell. (markt)
> > | 50106: Correct several MBean descriptors. Patch provided by Eiji Takahashi. (markt)
> > | Further performance improvements to session ID generation. Remove legacy configuration options that are no longer required. Provide additional options to control the `SecureRandom` instances used to generate session IDs. (markt)
> > | 50201: Update the access log reference in `StandardEngine` when the ROOT web application is redeployed, started, stopped or defaultHost is changed. (markt/kkolinko)
> > | 50282: Load `javax.security.auth.login.Configuration` with `JreMemoryLeakPreventionListener` to avoid memory leak when stopping a web application that would use JAAS. (slaurent)
> > | 50351: Fix the regression that broke BeanFactory resources caused by the previous fix for 50159. (markt)
> > | 50352: Ensure that `AsyncListener.onComplete()` is fired when `AsyncContext.complete()` is called. (markt)
> > | 50358: Set the correct LifecycleState when stopping instances of the deprecated Embedded class. (markt)
> > | Further Lifecycle refactoring for Connectors and associated components. (markt)
> > | Correct handling of versioned web applications in deployer. (markt)
> > | Correct removal of `LifeCycleListener`s from `Container`s via JMX. (markt)
> > | Don't use `null`s to construct log messages. (markt)
> > | Code clean-up. Replace use of inefficient constructors with more efficient alternatives. (markt)
> > | 50411: Ensure sessions are removed from the `Store` associated with a `PersistentManager`. (markt)
> > | 50413: Ensure 304 responses are not returned when using static files as error pages. (markt/kkolinko)
> > | 50448: Fix possible `IllegalStateException` caused by recent session management refactoring. (markt)
> > | Ensure aliases settings for a context are retained after a context is reloaded. (markt)
> > | Log a warning if context.xml files define values for properties that do not exist (e.g. if there is a typo in a property name). (markt)
> > | 50453: Correctly handle multiple `X-Forwarded-For` headers in the RemoteIpFilter and RemoteIpValve. Patch provided by Jim Riggs. (markt)
> > | 50541: Add support for setting the size limit and time limit for LDAP searches when using the JNDI Realm with `userSearch`. (markt)
> > | All configuration options that use regular expression now require a single regular expression (using `java.util.regex`) rather than a list of comma-separated or semi-colon-separated expressions. (markt)
> > | 50496: Bytes sent in the access log are now counted after compression, chunking etc rather than before. (markt)
> > | 50550: When a new directory is created (e.g. via WebDAV) ensure that a subsequent request for that directory does not result in a 404 response. (markt)
> > | 50554: Code clean up. (markt)
> > | 50556: Improve JreMemoryLeakPreventionListener to prevent a potential class loader leak caused by a thread spawned when the class `com.sun.jndi.ldap.LdapPoolManager` is initialized and the system property `com.sun.jndi.ldap.connect.pool.timeout` is set to a value greater than 0. (slaurent)

> Coyote

> > | 47319: Return the client's IP address rather than null for calls to `getRemoteHost()` when the APR connector is used with `enableLookups="true"` but the IP address is not resolveable. (markt)
> > | 50108: Add get/set methods for Connector property minSpareThreads. Patch provided by Eiji Takahashi. (markt)

> > 50360: Provide an option to control when the socket associated with a connector is bound. By default, the socket is bound on `Connector.init()` and released on `Connector.destroy()` as per the current behaviour but this can be changed so that the socket is bound on `Connector.start()` and released on `Connector.stop()`. This fix also includes further Lifecycle refactoring for Connectors and associated components. (markt)

> > | Remove a huge memory leak in the NIO connector introduced by the fix for 49884. (markt)
> > | 50467: Protected against NPE triggered by a race condition that causes the NIO poller to fail, preventing the processing of further requests. (markt)

> Jasper

> > | 13731: Make variables in `_jspService()` method final where possible. (markt)
> > | 50408: Fix `NoSuchMethodException` when using scoped variables with EL method invocation. (markt)
> > | 50460: Avoid a memory leak caused by using a cached exception instance in `JspDocumentParser` and `ProxyDirContext`. (kkolinko)
> > | 50500: Use correct coercions (as per the EL spec) for arithmetic operations involving string values containing '.', 'e' or 'E'. Based on a patch by Brian Weisleder. (markt)

> Cluster

> > | 50185: Add additional trace level logging to Tribes to assist with fault diagnosis. Based on a patch by Ariel. (markt)
> > | Don't try and obtain session data from the cluster if the current node is the only node in the cluster. Log requesting session data as INFO rather than WARNING. (markt)
> > | 50503: When web application has a version, Engine level Clustering works correctly. (kfujino)
> > | 50547: Add time stamp for CHANGE_SESSION_ID message and SESSION_EXPIRED message. (kfujino)

> Web applications

> > | 21157: Ensure cookies are written before the response is committed in the Cookie example. Patch provided by Stefan Radzom. (markt)
> > | 50294: Add more information to documentation regarding format of configuration files. Patch provided by Luke Meyer. (markt)
> > | Correctly validate provided context path so sessions for the ROOT web application can be viewed through the HTML Manager. (markt)
> > | Improve documentation of database connection factory. (rjung)
> > | 50488: Update classpath required when using jsvc and add a note regarding server VMs. (markt)
> > | Further filtering of Manager display output. (kkolinko)

> Other

> > | Don't configure Windows installer to use PID file since it is not removed when the service stops which prevents the service from starting. (markt)
> > | 14416: Make `TagLibraryInfo.getTag()` more robust at handling `null`s. (markt)
> > | 50552: Avoid NPE that hides error message when using Ant tasks. (schultz)
> > | Provide two alternative locations for the libraries downloaded from the ASF web site at build time. Use the main distribution site as default and the archive one as fallback. (kkolinko)

Tomcat 7.0.5 (markt) | beta, 2010-12-01

> General

> > | Update to Apache Commons Daemon 1.0.4. (mturk)

> Catalina

> > | 3839: Provide a mechanism to gracefully handle the case where users book-mark the form login page or otherwise misuse the FORM authentication process. Based on a suggestion by Mark Morris. (markt)
> > | 49180: Add option to disable log rotation in juli FileHandler. Patch provided by Pid (pidster at apache). (funkman)
> > | 49991: Ensure servlet request listeners are fired for the login and error pages during FORM authentication. (markt)
> > | 50107: When removing a Host via JMX, do not attempt to destroy the host's pipeline twice. Patch provided by Eiji Takahashi. (markt)
> > | 50138: Fix threading issues in `org.apache.catalina.security.SecurityUtil`. (markt)
> > | 50157: Ensure MapperListener is only added to a container object once. (markt)
> > | 50159: Add a new attribute for `<Resource>` elements, `singleton`, that controls whether or not a new object is created every time a JNDI lookup is performed to obtain the resource. The default value is `true`, which will return the same instance of the resource in every JNDI lookup. (markt)
> > | 50168: Separate the `Lifecycle.DESTROY_EVENT` into `Lifecycle.BEFORE_DESTROY_EVENT` and `Lifecycle.AFTER_DESTROY_EVENT`. Use the additional state to ensure that `Context` objects are only destroyed once. (markt)
> > | 50169: Ensure that when a Container is started that it doesn't try and register with the mapper unless its parent has already started. Patch provided by Eiji Takahashi. (markt)
> > | 50222: Modify memory leak prevention code so it pins the system class loader in memory rather than than the common class loader, which is better for embedded systems. Patch provided by Christopher Schultz. (markt)
> > | Improve debug logging for MapperListener registration. (markt)
> > | Expose names of LifecycleListeners and ContainerListeners for StandardContext via JMX. (markt)
> > | Add a new option, `resourceOnlyServlets`, to Context elements that provides a mechanism for working around the issues caused by new requirements for welcome file mapping introduced in Servlet 3.0. By default, the existing Tomcat 6.0.x welcome file handling is used. (markt)
> > | Make Tomcat more tolerant of `null` when generating JMX names for Valves. (markt)
> > | Make AccessLogValve attribute `enabled` changeable via JMX. (pero)
> > | Correct infinite loop if `ServletRequest.startAsync(ServletRequest, ServletResponse)` was called. (markt)
> > | 50232: Remove dependency between StoreBase and PersistentManager and associated code clean-up. Patch provided by Tiago Batista. (markt)
> > | 50252: Prevent ClassCastException when using a <ResourceLink>. Patch provided by Eiji Takahashi. (markt)
> > | Reduce synchronization in session managers to improve performance of session creation. (markt)
> > | If starting children automatically when adding them to a container (e.g. when adding a Context to a Host) don't lock the parent's set of children whilst the new child is being started since this can block other threads and cause issues such as lost cluster messages. (markt)

> > Implement support for parallel deployment. This allows multiple versions of the same web application to be deployed to the same context path at the same time. Users without a current session will be mapped to the latest version of the web application. Users with a current session will continue to use the version of the web application with which the session is associated until the session expires. (markt)

> > | 50308: Allow asynchronous request processing to call `AsyncContext.dispatch()` once the asynchronous request has timed out. (markt)
> > | Make memory leak prevention code that clears ThreadLocal instances more robust against objects with toString() methods that throw exceptions. (markt)

> Coyote

> > | 49860: Complete support for handling trailing headers in chunked HTTP requests. (markt)
> > | Impose a limit on the length of the trailing headers. The limit is configurable with a system property and is `8192` by default. (kkolinko)
> > | 50207: Ensure Comet timeout events are triggered. This bug was a regression triggered by the fix for 49884. (markt)

> Jasper

> > 49297: Enforce the rules in the JSP specification for parsing the attributes of custom and standard actions that require that the attribute names are unique within an element and that there is whitespace before the attribute name. The whitespace test can be disabled by setting the system property `org.apache.jasper.compiler.Parser.STRICT_WHITESPACE` to `false`. Attributes of the page directive have slightly different rules. The implementation of that part of the fix is based on a patch by genspring. (markt)

> > | 50105: When processing composite EL expressions use `Enum.name()` rather than `Enum.toString()` as required by the EL specification. (markt)
> > | Fix minor thread-safety and performance issues in the implementation of `maxLoadedJsps`. (rjung)
> > | Add support for unloading JSPs that have not been requested for a long time using the new parameter `jspIdleTimeout`. (rjung)
> > | Add logging and JMX support to JSP unloading. (rjung)
> > | 50192: Improve performance for EL when running under a security manager. Based on a patch by Robert Goff. (markt)
> > | 50228: Improve recycling of `BodyContentImpl`. This avoids keeping a cached reference to a webapp-provided Writer used in JspFragment.invoke() calls. (kkolinko)
> > | 50273: Provide a workaround for an HP-UX issue that can result in large numbers of SEVERE log messages appearing in the logs as a result of normal operation. (markt)
> > | 50293: Increase the size of internal ELResolver array from 2 to 8 since in typical usage there are at least 5 resolvers. Based on a patch by Robert Goff. (markt)

> Cluster

> > | Add support for maxActiveSessions attribute to BackupManager. (kfujino)
> > | Improve sending an access message in DeltaManager. maxInactiveInterval of not Manager but the session is used. If maxInactiveInterval is negative, an access message is not sending. (kfujino)
> > | 50183: BIO sender was not scheduling tasks to the executor during normal operation. Patch provided by Ariel. (markt)
> > | 50184: Add an option to the RpcChannel to enable the Channel send options to be set for the reply message. Based on a patch by Ariel. (markt)
> > | Ensure that a new Context waiting for session data from other nodes in the cluster does not block the processing of clustering messages for other Contexts. (markt)

> Web applications

> > | 49426: Localize messages in the Manager application based on the Locale of the user rather than the default Locale of the server. (markt)
> > | Localize messages in the Host Manager application based on the Locale of the user rather than the default Locale of the server. (markt)
> > | 50242: Provide a sample log4j configuration that more closely matches the default JULI configuration. Patch provided by Christopher Schultz. (markt)
> > | Restore the ability to edit the contents of /WEB-INF and /META-INF via WebDAV via the provision of a new configuration option, allowSpecialPaths. (markt)
> > | Correct broken links for on-line JavaDocs. (markt)
> > | 50230: Add new DistributedManager interface that is implemented by the Backup Manager to remove circular dependency between tomcat-catalina-ha and tomcat-catalina modules. Also allows third-party distributed Manager implementations to report full session information through the HTML Manager. (markt)
> > | Improve Tomcat Logging documentation. (kkolinko)
> > | 50303: Update JNDI how-to to reflect the new JavaMail download location and that JAF is now included in Java SE 6. (markt)
> > | Fix ordering functionality on sessions page for the HTML Manager application. (markt)
> > | Fix primary sessions not always being treated as such in the HTML Manager application. (markt)
> > | Fix message not being displayed after session attribute removal in the HTML Manager application. (markt)
> > | 50310: Fix display of Servlet information in the Manager application. (markt)
> > | CVE-2010-4172: Multiple XSS in the Manager application. (markt/kkolinko)
> > | 50316: Fix display of negative values in the Manager application. (kkolinko)
> > | 50318: Avoid NPE when trying to view session detail for an expired session in the Manager application. (markt)

> Other

> > | Correct a handful of Javadoc warnings. (markt)
> > | 22965: Fix some typos and formatting issues in the global web.xml file. Based on a patch by Yann Cébron. (markt)
> > | Extend Checkstyle validation checks to check for unused imports. (markt)
> > | General code clean-up to reduce (not eliminate) the number of warnings reported by IDEs. (markt)
> > | 50140: Don't ignore a user specified installation directory when performing a silent install with the Windows installer on 64-bit platforms. (markt)
> > | Reimplemented Windows installer dialogs, using modern libraries (nsDialogs, MUI2). (kkolinko)
> > | When installing with the Windows installer on 64-bit platforms, allow the user to select either a 32-bit JDK or a 64-bit JDK. If a 32-bit JDK is selected, the 32-bit service wrapper and the 32-bit native DLL will be installed. If a 64-bit JDK is selected, the 64-bit service wrapper and the 64-bit native DLL will be installed. (markt/kkolinko)
> > | Create Windows shortcuts for the Manager and Host Manager webapps. (kkolinko)
> > | Support /? command line option in the Windows Installer. (kkolinko)
> > | Display and allow to change roles for the Tomcat admin user in the Windows installer. (kkolinko)
> > | In the Windows installer: do not leave stale `server.xml` and `tomcat-users.xml` fragments in the $TEMP folder. (kkolinko)
> > | 49819: Redesign of home page by Pid (pidster at apache). (timw)

Tomcat 7.0.4 (markt) | beta, 2010-10-21

> Catalina

> > | 49428: Re-implement the fix for bug 49428 – namespace issues for some Microsoft WebDAV clients. (kkolinko)
> > | 49669: Fix memory leak triggered by using the deprecated javax.security.auth.Policy class. (markt)
> > | 49922: Don't add filter twice to filter chain if the filter matches more than one URL pattern and/or Servlet name. Patch provided by heyoulin. (markt)
> > | 49937: Use an InstanceManager when creating an AsyncListener through the AsyncContext to ensure annotations are processed. Based on a patch by David Jencks. (markt)
> > | To avoid NoSuchMethodException, xmlValidation and xmlNamespaceAware are removed from the createStandardHost definition of mbeans-descriptors.xml. (kfujino)
> > | 49945: Continue improvements to JMX. Fix a handful of attributes that were showing as Unavailable in JConsole. Patch provided by Chamith Buddhika. (markt)
> > | 49952: Allow ServletContainerInitializers to add listeners to a web application. Patch provided by David Jencks. (markt)
> > | 49956: Handle case when @Resource annotation uses the full JNDI name for a resource. Based on a patch by Gurkan Erdogdu. (markt)
> > | 49557: Correct regression due to Lifecycle refactoring that cleared all work directories (with compiled JSPs and persisted sessions) when Tomcat was stopped. (markt)
> > | 49978: Correctly handle the case when a directory expected to be created during web application start is already present. Rather than throwing an exception and failing to start, allow the web application to start normally. (markt)
> > | 49987: Fix thread safety issue with population of servlet context initialization parameters. (markt)
> > | 49994: As per the Java EE 6 specification, return a new object instance for each JNDI look up of a resource reference. (markt)
> > | 50015: Re-factor dynamic servlet security implementation to make extensions, such as JACC implementations, simpler. Patch provided by David Jencks. (markt)
> > | 50016: Re-factor `isUserInRole()` and `login()/logout()` methods to support JACC implementations and to improve encapsulation. Patch provided by David Jencks. (markt)
> > | 50017: Code clean-up. No functional change. Patch provided by sebb. (markt)
> > | 50027: Avoid NPE on start when a Context is defined in server.xml with one or more JNDI resources. (markt)
> > | 50059: JARs should always be searched for static resources even if the web application is marked as meta-data complete. (markt)
> > | 50063: Correct regression in fix for 50059 that causes applications marked as meta-data complete to return 404s for all requests. Patch provided by heyoulin. (markt)
> > | 50087: Catch ClassFormatErrors when scanning for annotations. (markt)

> Coyote

> > | 49923: Avoid using negative timeouts during acceptor unlock to ensure APR connector shuts down properly. (mturk)
> > | 49972: Fix potential thread safe issue when formatting dates for use in HTTP headers. (markt)
> > | 50003: Set not maxThreads but minSpareThreads to corePoolSize, if AbstractEndpoint.setMinSpareThreads is called. (kfujino)
> > | 50044: Fix issue when using comet where socket remained in long poll after the comet request has ended. (markt)
> > | 50054: Correctly handle the setting of minSpareThreads in AJP connector. (kfujino)
> > | 50072: Fix issues when using a non-blocking read for the request line with the NIO connector that could result in the request line being mis-read. (markt)

> Jasper

> > | 49986: Fix thread safety issue for JSP reload. (timw)
> > | 49998: Make jsp:root detection work with single quoted attributes as well. (timw)
> > | Correctly handle the setting of primitive bean values via expression language. (markt)
> > | Don't swallow exceptions when processing TLD files and handle the case when there is no web.xml file. (markt)
> > | 50066: Fix building of recursive tag files when the file depends on a JAR file. Patch provided by Sylvain Laurent. (markt)
> > | 50078: Fix threading problem in EL caches. Patch provided by Takayoshi Kimura. (markt)
> > | Make EL cache sizes configurable. (markt)

> Web applications

> > | Apply filters to default home page so copyright year is correctly displayed. (markt)

> Other

> > | 48716: Do not call reset if the default LogManager is in use. (markt)
> > | 50013: Correctly package classes from `org.apache.tomcat.util.file` and add the tomcat-util.jar to the class path for the Ant tasks. Based on a patch provided by Sylvain Laurent. (markt)

Tomcat 7.0.3 (markt) | not released

> Catalina

> > | 48644: Review all instances of catching Throwable and re-throw where appropriate. (markt)
> > | Allow glob patterns in the `jarsToSkip` configuration and add some debug logging to the jar scanner. (rjung)
> > | 48738: Workaround a couple of long standing JDK bugs to enable GZIP compressed output streams to be flushed. Based on a patch provided by Jiong Wang. (markt)
> > | 48967: Replace strings "catalina.base" and "catalina.home" by globally defined constants. Patch provided by Marc Guillemot. (rjung)
> > | 49195: Don't report an error when shutting down a Windows service for a Tomcat instance that has a disabled shutdown port. (markt)
> > | 49209: Prevent possible AccessControlException during undeployment when running with a security manager. Patch provided by Sylvain Laurent. (markt)
> > | 49657: Handle CGI executables with spaces in the path. (markt)
> > | 49667: Ensure that using the JDBC driver memory leak prevention code does not cause a one of the memory leaks it is meant to avoid. (markt)
> > | 49670: Restore SSO functionality that was broken by Lifecycle refactoring. (markt)
> > | 49698: Allow a listener to complete an asynchronous request if it times out. (markt)
> > | 49714: The annotation process of Jar doesn't influence distributable element of web.xml. (kfujino)
> > | 49721: Alls JAR in a web application should be searched for resources, not just those with a web-fragment.xml that is going to be processed. (markt)
> > | 49728: Improve PID file handling when another process is managing the PID file and Tomcat does not have write access. (markt)
> > | 49730: Fix a race condition in StandardThreadExector that can cause requests to experience large delays. Patch provided by Sylvain Laurent. (markt)
> > | 49749: Single sign on cookies should have httpOnly flag set using same rules as session cookies. (markt)
> > | 49750: Align `WebappClassLoader.validate()` implementation with Javadoc and ensure that `javax.servlet.*` classes can not be loaded by a `WebappClassLoader` instance. Patch provided by pid. (markt)
> > | 49757: Correct some generics warnings. Based on a patch provided by Gábor. (markt)
> > | 49779: Improve handling of POST requests and FORM authentication, particularly when the user agent responds to the 302 response by repeating the POST request including a request body. Any request body provided at this point is now swallowed. (markt)
> > | CSRF prevention filter did not correctly handle URLs that used anchors. (markt)
> > | Fix memory leak on web application stopped caused by failed to de-register the web application's Servlets with the MBean server. (markt)
> > | More tweaks to the Lifecycle refactoring to ensure that when a component is being destroyed, the destroy method is only called once on each child component. (markt)
> > | Keep the MBean names for web applications consistent between Tomcat 6 and Tomcat 7. (markt)
> > | 49856: Add an executorName attribute to Connectors so it is possible to trace ThreadPool to Connector to Executor via the JMX interface. (markt)
> > | 49865: Tomcat failed to start if catalina.properties was not present. (markt)
> > | 49876: Fix the generics warnings in the copied Apache Jakarta BCEL code. Based on a patch by Gábor. (markt)
> > | 49883: Ensure that the CombinedRealm and LockOutRealm return a name for use in log messages rather than throwing an `UnsupportedOperationException`. (markt)
> > | 49884: Fix occasional NullPointerException on async complete(). This resulted in a major refactoring of the async implementation to address a number of threading issues. (markt)
> > | Update the version numbers in ServerInfo defaults to Tomcat 7.0.x. (markt)
> > | 49892: Correct JNDI name for method resource injections. Based on a patch by Gurkan Erdogdu. (markt)
> > | Ensure that Context elements defined in server.xml use any configClass setting specified in the parent Host element. (markt)
> > | GSOC 2010. Enable the creation of Services, Engines, Connectors, Hosts and Contexts via JMX from a minimal server.xml that contains only a Server element. Based on a patch by Chamith Buddhika. (markt)
> > | 49909: Fix a regression introduced with the fix for 47950 that prevented JSTL classes being loaded. (markt)
> > | 49915: Make error more obvious, particularly when accessed via JConsole, if StandardServer.storeConfig() is called when there is no StoreConfig implementation present. (markt)
> > | 50018: Fix some minor Javadoc errors in Jasper source. Based on a patch by sebb. (timw)
> > | 50021: Correct a regression in the fix for 46844 that may have caused additional problems during a failure at start up. (markt)
> > | 50026: Prevent serving of resources from WEB-INF and META-INF directories when DefaultServlet or WebdavServlet is mapped to a sub-path of the context. This changes DefaultServlet to always serve resources with paths relative to the root of the context regardless of where it is mapped, which is a breaking change for current servlet-mappings that map the default servlet to a subpath. (timw)
> > | 50689: Provide 100 Continue responses at appropriate points during FORM authentication if client indicates that they are expected. (markt)

> Coyote

> > | Wait for the connectors to exit before closing them down. (mturk)
> > | Follow up to 48545. Make JSSE connectors more tolerant of a incorrect trust store password. (markt)
> > | Fix some edge cases in the NIO connector when handling requests that are not received all at the same time and the socket needs to be returned to the poller. (markt)
> > | Further work to reduce the code duplication in the HTTP connectors. (markt)
> > | Make sure acceptor threads are stopped when the connector is stopped. (markt)
> > | Make sure async timeout thread is stopped when the connector is stopped. (markt)
> > | 49625: Ensure Vary header is set if response may be compressed rather than only setting it if it is compressed. (markt)
> > | 49802: Re-factor connector pause, stop and destroy methods so that calling any of those methods has the expected results. (markt)
> > | Various refactorings to reduce code duplication and unnecessary code in the connectors. (markt)
> > | 49860: Add partial support for trailing headers in chunked HTTP requests. (markt)

> Jasper

> > | 49665: Provide better information including JSP file name and location when a missing file is detected during TLD handling. Patch provided by Ted Leung. (markt)
> > | 49726: Specifying a default content type via a JSP property group should not prevent a page from setting some other content type. (markt)
> > | 49799: The new `omit` attribute for `jsp:attribute` elements now supports the use of expressions and expression language. (markt)
> > | 49916: Switch to using an initialisation parameter to pass JSP file information from Catalina to Jasper. This simplifies the Catalina code as well as making it easier for Geronimo and others to integrate Jasper. Patch provided by David Jencks. (markt)
> > | 49985: Fix thread safety issue in EL parser. (markt)

> Cluster

> > | Remove domainReplication attribute from ClusterManager. If you send session to only same domain, use DomainFilterInterceptor. (kfujino)
> > | Add Null check when CHANGE_SESSION_ID message received. (kfujino)
> > | Add support for LAST_ACCESS_AT_START system property to DeltaSession. (kfujino)
> > | Avoid a NPE in the DeltaManager when a parallel request invalidates the session before the current request has a chance to send the replication message. (markt)
> > | 49905: Prevent memory leak when using asynchronous session replication. (markt)
> > | 49924: When non-primary node changes into a primary node, make sure isPrimarySession is changed to true. (kfujino)

> Web applications

> > | Correct the class name of the default JAR scanner in the documentation web application. (rjung)
> > | 49585: Update JSVC documentation to reflect new packaging of Commons Daemon. (markt)
> > | Update the Servlet, JSP and EL Javadoc links to link to the specifications and the relevant part of the Java EE 6 Javadoc. (markt)
> > | Update a few places in the docs where the Manager documentation referred to the old role name of manager rather than than the new manager-script. (markt)

> Extras

> > | 49861: Don't log RMI ports formatted with commas for the JMX remote listener. (markt)

> Other

> > | Correct the user names created by the Windows installer for the Manager and Host Manager applications. (mturk)
> > | Correct the Eclipse compiler dependency in the Jasper POM. (markt)
> > | Extend Checkstyle validation checks to check import order. (markt)
> > | 49758: Fix generics warnings exposed by a fix in Eclipse 3.6. Patch provided by sebb. (markt)
> > | Update Apache Commons Pool to 1.5.5. (markt)
> > | 49955: Improvement and correction of Building Tomcat guide. Based on a patch from Wesley Acheson. (timw)
> > | 49993: Improve check for `JAVA_HOME` and add support for `JRE_HOME` in `service.bat`. (mturk)

Tomcat 7.0.2 (markt) | beta, 2010-08-11

> Catalina

> > | Fix regression that prevented running with a security manager enabled. (markt)

> Web applications

> > | Correct Javadoc errors. (markt)
> > | Provide Javadoc for Servlet 3.0 API, JSP 2.2 API and EL 2.2 API. (markt)
> > | Remove second copy of RUNNING.txt from the full-docs distribution. Some unpacking utilities can't handle multiple copies of a file with the same name in a directory. (markt)

> Other

> > | Extend Checkstyle validation checks to check for tabs in nearly all text files. (markt)
> > | Update Apache Commons Daemon from 1.0.2 to 1.0.3. (markt)
> > | Update Eclipse JDT Core Batch Compiler (ecj.jar) from 3.5.1 to 3.6. (markt)

Tomcat 7.0.1 (markt) | not released

> Catalina

> > | GSOC 2010. Continue work to align MBean descriptors with reality. Patch provided by Chamith Buddhika. (markt)
> > | When running under a security manager, enforce package access and package definition restrictions defined in the catalina.properties file. (markt)
> > | When using a Loader configured with `searchExternalFirst="true"` failure to find the class in an external repository should not prevent searching of the local repositories. (markt)
> > | Add entryPoint support to the CSRF prevention filter. (markt)
> > | 48297: Correctly initialise handler chain for web services resources. (markt)
> > | 48960: Add a new option to the SSI Servlet and SSI Filter to allow the disabling of the `exec` command. This is now disabled by default. Based on a patch by Yair Lenga. (markt)
> > | 48998, 49617: Add the ExpiresFilter, a port of the httpd mod_expires module. Patch provided by Cyrille Le Clerc. (markt)
> > | 49030: When initializing/starting/stopping connectors and one of them fails, do not ignore the others. (markt/kkolinko)
> > | 49128: Don't swallow exceptions unnecessarily in `WebappClassLoader.start()`. (markt)
> > | 49182: Align comments in setclasspath.[sh|bat] with behaviour. Based on a patch provided by sebb. (markt)
> > | 49230: Enhance JRE leak prevention listener with protection for the keep-alive thread started by `sun.net.www.http.HttpClient`. Based on a patch provided by Rob Kooper. (markt)
> > | 49414: When reporting threads that may have triggered a memory leak on web application stop, attempt to differentiate between request processing threads and threads started by the application. (markt)
> > | 49428: Add a work-around for the known namespace issues for some Microsoft WebDAV clients. Patch provided by Panagiotis Astithas. (markt)
> > | Add support for `*.jar` pattern in VirtualWebappLoader. (kkolinko)
> > | Use a LockOutRealm in the default configuration to prevent attempts to guess user passwords by brute-force. (markt)
> > | 49478: Add support for user specified character sets to the `AddDefaultCharsetFilter`. Based on a patch by Felix Schumacher. (markt)
> > | 49503: Make sure connectors bind to their associated ports sufficiently early to allow jsvc and the org.apache.catalina.startup.EXIT_ON_INIT_FAILURE system property to operate correctly. (markt)
> > | 49525: Ensure cookies for the ROOT context have a path of / rather than an empty string. (markt)
> > | 49528, 49567: Ensure that `AsyncContext.isAsyncStarted()` returns the correct value after `AsyncContext.start()` and that if `AsyncContext.complete()` is called on a separate thread that it is handled correctly. (markt)
> > | 49530: Contexts and Servlets not stopped when Tomcat is shut down. (markt)
> > | 49536: If no ROOT context is deployed, ensure a 404 rather than a 200 is returned for requests that don't map to any other context. (markt)
> > | Additional debug logging in StandardContext to provide information on Manager selection. (markt)
> > | 49550: Suppress deprecation warning where deprecated code is required to be used. No functional change. Patch provided by Sebb. (markt)
> > | 49551: Allow default context.xml location to be specified using an absolute path. (markt)
> > | Improve logging of unhandled exceptions in servlets by including the path of the context where the error occurred. (markt)
> > | Include session ID in error message logged when trying to set an attribute on an invalid session. (markt)
> > | Improve the CSRF protection filter by using SecureRandom rather than Random to generate nonces. Also make the implementation class used user configurable. (markt)
> > | Avoid NullPointerException, when copyXML=true and META-INF/context.xml does not exist. (kfujino)
> > | 49598: When session is changed and the session cookie is replaced, ensure that the new Set-Cookie header overwrites the old Set-Cookie header. (markt)
> > | Create a thread to trigger asynchronous timeouts when using the BIO connector, change the default timeout to 10s (was infinite) and make the default timeout configurable using the `asyncTimeout` attribute on the connector. (pero/markt)
> > | 49600: Make exceptions returned by the `ProxyDirContext` consistent for resources that weren't found by checking the `DirContext` or the cache. Test case based on a patch provided by Marc Guillemot. (markt)
> > | 49613: Improve performance when using SSL for applications that make multiple class to `Request.getAttributeNames()`. Patch provided by Sampo Savolainen. (markt)
> > | Handle the edge cases where resources packaged in JARs have names that start with a single quote character or a double quote character. (markt)
> > | Correct copy and paste typo in web.xml parsing rules that mixed up `local-ejb-ref` and `resource-env-ref`. (markt)
> > | Refactor session managers to remove unused code and to reduce code duplication. Also, all session managers used for session replication now extend `org.apache.catalina.ha.session.ClusterManagerBase`. (markt)

> Jasper

> > | Remove references to Jikes since it does not support Java 6. (markt)
> > | Correct over zealous type checking for EL in attributes that broke the use of JSF converters. (markt)
> > | Correct algorithm used to identify correct method to use when a MethodExpressions is used in EL. (markt)
> > | 49217: Ensure that identifiers used in EL meet the requirements of the Java Language Specification. (markt)
> > | Improve logging of JSP exceptions by including JSP snippet (if enabled) rather than just the root cause in the host log. (markt)
> > | 49555: Correctly handled Tag Libraries where functions are defined in static inner classes. (markt)

> Cluster

> > | 49127: Don't swallow exceptions unnecessarily in `SimpleTcpReplicationManager.startInternal()`. (markt)
> > | 49407: Change the BackupManager so it is consistent with DeltaManager and reports both primary and backup sessions when active sessions are requested. (markt)
> > | 49445: When session ID is changed after authentication, ensure the DeltaManager replicates the change in ID to the other nodes in the cluster. (kfujino)

> Web applications

> > | 49112: Update the ROOT web application's index page. Patch provided by pid. (markt)
> > | 49213: Add the permissions necessary to enable the Manager application to operate currently when running with a security manager. (markt)
> > | 49436: Correct documented default for readonly attribute of the UserDatabase component. (markt)
> > | 49475: Use new role name for manager application access on the ROOT web application's index page. (markt)
> > | 49476: CSRF protection was preventing access to the session expiration features. Also switch the manager application to the generic CSRF protection filter. (markt)
> > | Better handle failure to create directories required for new hosts in the Host Manager application. (markt)
> > | Switch the Host Manager application to the generic CSRF protection for the HTML interface and prevent started hosts from being started and stopped hosts from being stopped. (markt)
> > | 49518: Fix typo in extras documentation. (markt)
> > | 49522: Fix regression due to change of name for MBeans for naming resources that broke the complete server status page in the manager application. Note these MBeans now have a new name. (markt)
> > | 49570: When using the example compression filter, set the Vary header on compressed responses. (markt)
> > | Add redirects for the root of the manager and host-manager web applications that redirect users to the html interface rather than returning a 404. (markt)
> > | Provide the HTML Manager application with the ability to differentiate between primary, backup and proxy sessions. Note that proxy sessions are only shown if enabled in web.xml. (markt)

> Other

> > | 49130: Better describe the core package in the Windows installer, making it clear that the service will be installed. Patch provided by sebb. (markt)
> > | Re-factor unit tests to enable them to be run once with each of the HTTP connector implementations (BIO, NIO and APR/native). (markt)
> > | 49268: Add the necessary plumbing to include CheckStyle in the build process. Start with no checks. Additional checks will be added as they are agreed. (markt)
> > | Updated to Ant 1.8.1. The build now requires a minimum of Ant 1.8.x. (markt)
> > | Update the re-packaged version of commons-fileupload from 1.2.1 to 1.2.2. The layout of re-packaged version was also restored to the original commons-fileupload layout to make merging of future updates easier. (markt)
> > | Update the re-packaged version of Jakarta BCEL from trunk revision 880760 to trunk revision 978831. (markt)

Tomcat 7.0.0 (markt) | beta, 2010-06-29

> Catalina

> > | Update Servlet support to the Servlet 3.0 specification. (all)
> > | Improve and document VirtualWebappLoader. (rjung)
> > | 43642: Add prestartminSpareThreads attribute for Executor. (jfclere)
> > | Switch from AnnotationProcessor to InstanceManager. Patch provided by David Jecks with modifications by Remy. (remm/fhanik)
> > | r620845 and r669119. Make shutdown address configurable. (jfclere)
> > | r651977 Add some missing control checks to `ThreadWithAttributes`. (markt)
> > | r677640 Add a startup class that does not require any configuration files. (costin)
> > | r700532 Log if temporary file operations within the CGI servlet fail. Make sure header Reader is closed on failure. (markt)
> > | r708541 Delete references to DefaultContext which was removed in 6.0.x. (markt)
> > | r709018 Initial implementation of an asynchronous file handler for JULI. (fhanik)
> > | Give session thisAccessedTime and lastAccessedTime clear semantics. (rjung)
> > | Expose thisAccessedTime via Session interface. (rjung)
> > | Provide a log format for JULI that provides the same information as the default but on a single line. (markt)
> > | r723889 Provide the ability to configure the Executor job queue size and a timeout for adding jobs to the queue. (fhanik)
> > | Add support for aliases to StandardContext. This allows content from other directories and/or WAR files to be mapped to paths within the context. (markt)
> > | Provide clearer definition of Lifecycle interface, particularly start and stop, and align components that implement Lifecycle with this definition. (markt)
> > | 48662: Provide a new option to control the copying of context XML descriptors from web applications to the host's xmlBase. Copying of XML descriptors is now disabled by default. (markt)
> > | Move comet classes from the org.apache.catalina package to the org.apache.catalina.comet package to allow comet to work under a security manager. (markt)

> Coyote

> > | Port SSLInsecureRenegotiation from mod_ssl. This requires to use tomcat-native 1.2.21 that have option to detect this support from OpenSSL library. (mturk)
> > | Allow bigger AJP packets also for request bodies and responses using the packetSize attribute of the Connector. (rjung)
> > | r703017 Make Java socket options consistent between NIO and JIO connector. Expose all the socket options available on `java.net.Socket` (fhanik)
> > | 46051: The writer returned by `getWriter()` now conforms to the `PrintWriter` specification and uses platform dependent line endings rather than always using `\r\n`. (markt)
> > | Use tc-native 1.2.x which is based on APR 1.3.3+ (mturk)
> > | r724239 NIO connector now always uses an Executor. (fhanik)
> > | r724393 Implement keepAliveCount for NIO connector in a thread safe manner. (fhanik)
> > | r724849 Implement keep alive timeout for NIO connector. (fhanik)

> Jasper

> > | Update JSP support to the JSP 2.2 specification. (markt)
> > | Update EL support to the EL 2.2 specification. (markt)
> > | r787978 Use "1.6" as the default value for compilerSourceVM and compilerTargetVM options of Jasper. (kkolinko)
> > | 48358: Add support for limiting the number of JSPs that are loaded at any one time. Based on a patch by Isabel Drost. (markt)
> > | 48689: Access TLD files through a new JarResource interface to make extending Jasper simpler, particularly in OSGi environments. Patch provided by Jarek Gawor. (markt)

> High Availability

> > | Add support for UDP and secure communication to tribes. (fhanik)
> > | Add versioning to the tribes communication protocol to support future developments. (fhanik)
> > | Add a demo on how to use the payload. (fhanik)
> > | Started to add JMX support to the cluster implementation. (markt)
> > | r609778 Minor fixes to the throughput interceptor and the NIO receiver. (fhanik)
> > | r630234 Additional checks for the NIO receiver. (fhanik)
> > | r671650 Improve error message when multicast is not enabled. (fhanik)

> Web applications

> > | r631321 Update changelog to support the <rev> element in the documentation. (fhanik)
> > | A number of additional roles were added to the Manager and Host Manager applications to separate out permissions for the HTML interface, the text interface and the JMX proxy. (markt)
> > | CSRF protection was added to the Manager and Host Manager applications. (markt)
> > | List array elements in the JMX proxy output of the Manager application. (rjung)

> Extras

> > | A new JmxRemoteLifecycleListener that can be used to fix the ports used for remote JMX connections, eg when using JConsole. (markt)

> Other

> > | Numerous code clean-up changes including the use of generics and removing unused imports, fields, parameters and methods. (markt)
> > | All deprecated internal code has been removed. Warning: If you have custom components for a previous Tomcat version that extend internal Tomcat classes and override deprecated methods it is highly likely that they will no longer work. (markt)
> > | Parameterize version number throughout build scripts and source. (rjung)

Copyright © 1999-2016, Apache Software Foundation